commit e1a596186c81e65a34ce13076449712d3bf97eb4
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Aug 20 14:03:49 2021 +1000

    depend

commit 5450606c8f7f7a0d70211cea78bc2dab74ab35d1
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Aug 20 13:59:43 2021 +1000

    update version numbers

commit feee2384ab8d694c770b7750cfa76a512bdf8246
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Aug 20 03:22:55 2021 +0000

    upstream: openssh-8.7
    
    OpenBSD-Commit-ID: 8769dff0fd76ae3193d77bf83b439adee0f300cd

commit 9a2ed62173cc551b2b5f479460bb015b19499de8
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Aug 20 10:48:13 2021 +1000

    Also check pid in pselect_notify_setup.
    
    Spotted by djm@.

commit deaadcb93ca15d4f38aa38fb340156077792ce87
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Aug 20 08:39:33 2021 +1000

    Prefix pselect functions to clarify debug messages

commit 10e45654cff221ca60fd35ee069df67208fcf415
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Aug 20 08:30:42 2021 +1000

    Fix race in pselect replacement code.
    
    On the second and subsequent calls to pselect the notify_pipe was not
    added to the select readset, opening up a race that om G. Christensen
    discovered on multiprocessor Solaris <=9 systems.
    
    Also reinitialize notify_pipe if the pid changes.  This will prevent a
    parent and child from using the same FD, although this is not an issue
    in the current structure it might be in future.

commit 464ba22f1e38d25402e5ec79a9b8d34a32df5a3f
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Aug 18 12:51:30 2021 +1000

    Check compiler for c99 declarations after code.
    
    The sntrup761 reference code contains c99-style declarations after code
    so don't try to build that if the compiler doesn't support it.

commit 7d878679a4b155a359d32104ff473f789501748d
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Aug 17 15:12:04 2021 +1000

    Remove trailing backslash on regress-unit-binaries

commit b71b2508f17c68c5d9dbbe537686d81cedb9a781
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Aug 17 07:59:27 2021 +1000

    Put stdint.h inside HAVE_STDINT_H.
    
    From Tom G. Christensen.

commit 6a24567a29bd7b4ab64e1afad859ea845cbc6b8c
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Aug 16 14:13:02 2021 +1000

    Improve github test driver script.
    
     - use a trap to always output any failed regress logs (since the script
       sets -e, the existing log output is never invoked).
     - pass LTESTS and SKIP_LTESTS when re-running with sshd options (eg.
       UsePAM).

commit b467cf13705f59ed348b620722ac098fe31879b7
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Aug 16 11:32:23 2021 +1000

    Remove deprecated ubuntu-16.04 test targets.
    
    Github has deprecated ubuntu-16.04 and it will be removed on 20
    September.

commit 20e6eefcdf78394f05e453d456c1212ffaa6b6a4
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sun Aug 15 23:25:26 2021 +1000

    Skip agent ptrace test on hurd.

commit 7c9115bbbf958fbf85259a061c1122e2d046aabf
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sun Aug 15 19:37:22 2021 +1000

    Add hurd test target.

commit 7909a566f6c6a78fcd30708dc49f4e4f9bb80ce3
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sun Aug 15 12:45:10 2021 +1000

    Skip scp3 tests on all dfly58 and 60 configs.

commit e65198e52cb03534e8c846d1bca74c310b1526de
Author: Tim Rice <tim@multitalents.net>
Date:   Sat Aug 14 13:08:07 2021 -0700

    openbsd-compat/openbsd-compat.h: put bsd-signal.h before bsd-misc.h
    to get sigset_t from signal.h needed for the pselect replacement.

commit e50635640f79920d9375e0155cb3f4adb870eee5
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Aug 13 13:21:00 2021 +1000

    Test OpenSSH from OpenBSD head on 6.8 and 6.9.

commit e0ba38861c490c680117b7fe0a1d61a181cd00e7
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Aug 13 13:00:14 2021 +1000

    Skip scp3 test on dragonfly 58 and 60.
    
    The tests hang, so skip until we figure them out.

commit dcce2a2bcf007bf817a2fb0dce3db83fa9201e92
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Aug 12 23:59:25 2021 +0000

    upstream: mention that CASignatureAlgorithms accepts +/- similarly to
    
    the other algorithm list directives; ok jmc bz#3335
    
    OpenBSD-Commit-ID: 0d46b53995817052c78e2dce9dbd133963b073d9

commit 090a82486e5d7a8f7f16613d67e66a673a40367f
Author: schwarze@openbsd.org <schwarze@openbsd.org>
Date:   Thu Aug 12 09:59:00 2021 +0000

    upstream: In the editline(3) branch of the sftp(1) event loop,
    
    handle SIGINT rather than ignoring it, such that the user can use Ctrl-C to
    discard the currently edited command line and get a fresh prompt, just like
    in ftp(1), bc(1), and in shells.
    
    It is critical to not use ssl_signal() for this particular case
    because that function unconditionally sets SA_RESTART, but here we
    need the signal to interrupt the read(2) in the el_gets(3) event loop.
    
    OK dtucker@ deraadt@
    
    OpenBSD-Commit-ID: 8025115a773f52e9bb562eaab37ea2e021cc7299

commit e1371e4f58404d6411d9f95eb774b444cea06a26
Author: naddy@openbsd.org <naddy@openbsd.org>
Date:   Wed Aug 11 14:07:54 2021 +0000

    upstream: scp: tweak man page and error message for -3 by default
    
    Now that the -3 option is enabled by default, flip the documentation
    and error message logic from "requires -3" to "blocked by -R".
    
    ok djm@
    
    OpenBSD-Commit-ID: a872592118444fb3acda5267b2a8c3d4c4252020

commit 49f46f6d77328a3d10a758522b670a3e8c2235e7
Author: naddy@openbsd.org <naddy@openbsd.org>
Date:   Wed Aug 11 14:05:19 2021 +0000

    upstream: scp: do not spawn ssh with two -s flags for
    
    remote-to-remote copies
    
    Do not add another "-s" to the argument vector every time an SFTP
    connection is initiated.  Instead, introduce a subsystem flag to
    do_cmd() and add "-s" when the flag is set.
    
    ok djm@
    
    OpenBSD-Commit-ID: 25df69759f323661d31b2e1e790faa22e27966c1

commit 2a2cd00783e1da45ee730b7f453408af1358ef5b
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Aug 11 08:55:04 2021 +0000

    upstream: test -Oprint-pubkey
    
    OpenBSD-Regress-ID: 3d51afb6d1f287975fb6fddd7a2c00a3bc5094e0

commit b9f4635ea5bc33ed5ebbacf332d79bae463b0f54
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Aug 11 08:54:17 2021 +0000

    upstream: when verifying sshsig signatures, support an option
    
    (-Oprint-pubkey) to dump the full public key to stdout; based on patch from
    Fabian Stelzer; ok markus@
    
    OpenBSD-Commit-ID: 0598000e5b9adfb45d42afa76ff80daaa12fc3e2

commit 750c1a45ba4e8ad63793d49418a0780e77947b9b
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Aug 11 05:21:32 2021 +0000

    upstream: oops, missed one more %p
    
    OpenBSD-Commit-ID: e7e62818d1564cc5cd9086eaf7a51cbd1a9701eb

commit b5aa27b69ab2e1c13ac2b5ad3f8f7d389bad7489
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Aug 11 05:20:17 2021 +0000

    upstream: remove a bunch of %p in format strings; leftovers of
    
    debuggings past. prompted by Michael Forney, ok dtucker@
    
    OpenBSD-Commit-ID: 4853a0d6c9cecaba9ecfcc19066e52d3a8dcb2ac

commit 419aa01123db5ff5dbc68b2376ef23b222862338
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Aug 11 09:21:09 2021 +1000

    Add includes.h to compat tests.
    
    On platforms where closefrom returns void (eg glibc>=2.34) the prototype
    for closefrom in its compat tests would cause compile errors.  Remove
    this and have the tests pull in the compat headers in the same way as
    the main code.  bz#3336.

commit 931f592f26239154eea3eb35a086585897b1a185
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Aug 10 03:35:45 2021 +0000

    upstream: adapt to scp -M flag change; make scp3.sh test SFTP mode too
    
    OpenBSD-Regress-ID: 43fea26704a0f0b962b53c1fabcb68179638f9c0

commit 391ca67fb978252c48d20c910553f803f988bd37
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Aug 10 03:33:34 2021 +0000

    upstream: Prepare for a future where scp(1) uses the SFTP protocol by
    
    default. Replace recently added -M option to select the protocol with -O
    (olde) and -s (SFTP) flags, and label the -s flag with a clear warning that
    it will be removed in the near future (so no, don't use it in scripts!).
    
    prompted by/feedback from deraadt@
    
    OpenBSD-Commit-ID: 92ad72cc6f0023c9be9e316d8b30eb6d8d749cfc

commit bfdd4b722f124a4fa9173d20dd64dd0fc69856be
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Aug 9 23:56:36 2021 +0000

    upstream: make scp -3 the default for remote-to-remote copies. It
    
    provides a much better and more intuitive user experience and doesn't require
    exposing credentials to the source host.
    
    thanks naddy@ for catching the missing argument in usage()
    
    "Yes please!" - markus@
    "makes a lot of sense" - deraadt@
    "the right thing to do" - dtucker@
    
    OpenBSD-Commit-ID: d0d2af5f0965c5192ba5b2fa461c9f9b130e5dd9

commit 2f7a3b51cef689ad9e93d0c6c17db5a194eb5555
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Aug 9 23:49:31 2021 +0000

    upstream: make scp in SFTP mode try to use relative paths as much
    
    as possible. Previosuly, it would try to make relative and ~/-rooted paths
    absolute before requesting transfers.
    
    prompted by and much discussion deraadt@
    ok markus@
    
    OpenBSD-Commit-ID: 46639d382ea99546a4914b545fa7b00fa1be5566

commit 2ab864010e0a93c5dd95116fb5ceaf430e2fc23c
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Aug 9 23:47:44 2021 +0000

    upstream: SFTP protocol extension to allow the server to expand
    
    ~-prefixed paths, in particular ~user ones. Allows scp in sftp mode to accept
    these paths, like scp in rcp mode does.
    
    prompted by and much discussion deraadt@
    ok markus@
    
    OpenBSD-Commit-ID: 7d794def9e4de348e1e777f6030fc9bafdfff392

commit 41b019ac067f1d1f7d99914d0ffee4d2a547c3d8
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Aug 9 23:44:32 2021 +0000

    upstream: when scp is in SFTP mode, try to deal better with ~
    
    prefixed paths. ~user paths aren't supported, but ~/ paths will be accepted
    and prefixed with the SFTP server starting directory (more to come)
    
    prompted by and discussed with deraadt@
    ok markus@
    
    OpenBSD-Commit-ID: 263a071f14555c045fd03132a8fb6cbd983df00d

commit b4b3f3da6cdceb3fd168b5fab69d11fba73bd0ae
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Aug 9 07:21:01 2021 +0000

    upstream: on fatal errors, make scp wait for ssh connection before
    
    exiting avoids LogLevel=verbose (or greater) messages from ssh appearing
    after scp has returned exited and control has returned to the shell; ok
    markus@
    
    (this was originally committed as r1.223 along with unrelated stuff that
    I rolled back in r1.224)
    
    OpenBSD-Commit-ID: 1261fd667ad918484889ed3d7aec074f3956a74b

commit 2ae7771749e0b4cecb107f9d4860bec16c3f4245
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Aug 9 07:19:12 2021 +0000

    upstream: rever r1.223 - I accidentally committed unrelated changes
    
    OpenBSD-Commit-ID: fb73f3865b2647a27dd94db73d6589506a9625f9

commit 986abe94d481a1e82a01747360bd767b96b41eda
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Aug 9 07:16:09 2021 +0000

    upstream: show only the final path component in the progress meter;
    
    more useful with long paths (that may truncate) and better matches
    traditional scp behaviour; spotted by naddy@ ok deraadt@
    
    OpenBSD-Commit-ID: 26b544d0074f03ebb8a3ebce42317d8d7ee291a3

commit 2b67932bb3176dee4fd447af4368789e04a82b93
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Aug 9 07:13:54 2021 +0000

    upstream: on fatal errors, make scp wait for ssh connection before
    
    exiting avoids LogLevel=verbose (or greater) messages from ssh appearing
    after scp has returned exited and control has returned to the shell; ok
    markus@
    
    OpenBSD-Commit-ID: ef9dab5ef5ae54a6a4c3b15d380568e94263456c

commit 724eb900ace30661d45db2ba01d0f924d95ecccb
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sun Aug 8 08:49:09 2021 +0000

    upstream: xstrdup environment variable used by ForwardAgent. bz#3328
    
    from goetze at dovetail.com, ok djm@ deraadt@
    
    OpenBSD-Commit-ID: 760320dac1c3b26904284ba417a7d63fccc5e742

commit 86b4cb3a884846b358305aad17a6ef53045fa41f
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sun Aug 8 08:27:28 2021 +0000

    upstream: Although it's POSIX, not all shells used in Portable support
    
    the implicit 'in "$@"' after 'for i'.
    
    OpenBSD-Regress-ID: 3c9aec6bca4868f85d2742b6ba5223fce110bdbc

commit f2ccf6c9f395923695f22345e626dfd691227aaf
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sun Aug 8 17:39:56 2021 +1000

    Move portable specific settings down.
    
    This brings the top hunk of the file back in sync with OpenBSD
    so patches to the CVS Id should apply instead of always being
    rejected.

commit 71b0eb997e220b0fc9331635af409ad84979f2af
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sun Aug 8 07:27:52 2021 +0000

    upstream: Move setting of USER further down the startup In portable
    
    we have to change this and having it in the same hunk as the CVS Id string
    means applying changes fails every. single. time.
    
    OpenBSD-Regress-ID: 87cd603eb6db58c9b430bf90adacb7f90864429b

commit f0aca2706c710a0da1a4be705f825a807cd15400
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sun Aug 8 06:38:33 2021 +0000

    upstream: Drop -q in ssh-log-wrapper.sh to preserve logs.
    
    scp and sftp like to add -q to the command line passed to ssh which
    overrides the LogLevel we set in the config files and suppresses output
    to the debug logs so drop any "-q" from the invoked ssh.  In the one
    case where we actually want to use -q in the banner test, call the ssh
    binary directly bypassing the logging wrapper.
    
    OpenBSD-Regress-ID: e2c97d3c964bda33a751374c56f65cdb29755b75

commit cf27810a649c5cfae60f8ce66eeb25caa53b13bc
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sat Aug 7 01:57:08 2021 +0000

    upstream: Fix prototype mismatch for do_cmd. ok djm@
    
    OpenBSD-Commit-ID: 1c1598bb5237a7ae0be99152f185e0071163714d

commit 85de69f64665245786e28c81ab01fe18b0e2a149
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Aug 7 01:55:01 2021 +0000

    upstream: sftp-client.c needs poll.h
    
    remove unused variable
    
    OpenBSD-Commit-ID: 233ac6c012cd23af62f237167a661db391055a16

commit 397c4d72e50023af5fe3aee5cc2ad407a6eb1073
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Aug 7 11:30:57 2021 +1000

    Include poll.h and friends for struct pollfd.

commit a9e2c533195f28627f205682482d9da384c4c52e
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Aug 7 00:14:17 2021 +0000

    upstream: do_upload() used a near-identical structure for
    
    tracking expected status replies from the server to what do_download() was
    using.
    
    Refactor it to use the same structure and factor out some common
    code into helper functions.
    
    OpenBSD-Commit-ID: 0c167df8ab6df4a5292c32421922b0cf379e9054

commit 7b1cbcb7599d9f6a3bbad79d412604aa1203b5ee
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Aug 7 00:12:09 2021 +0000

    upstream: make scp(1) in SFTP mode follow symlinks like
    
    traditional scp(1) ok markus@
    
    OpenBSD-Commit-ID: 97255e55be37e8e26605e4ba1e69f9781765d231

commit 133b44e500422df68c9c25c3b6de35c0263132f1
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Aug 7 00:10:49 2021 +0000

    upstream: fix incorrect directory permissions on scp -3
    
    transfers; ok markus@
    
    OpenBSD-Commit-ID: 64b2abaa5635a2be65ee2e77688ad9bcebf576c2

commit 98b59244ca10e62ff67a420856770cb700164f59
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Aug 7 00:09:57 2021 +0000

    upstream: a bit more debugging of file attributes being
    
    sent/received over the wire
    
    OpenBSD-Commit-ID: f68c4e207b08ef95200a8b2de499d422808e089b

commit c677e65365d6f460c084e41e0c4807bb8a9cf601
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Aug 7 00:08:52 2021 +0000

    upstream: make scp(1) in SFTP mode output better match original
    
    scp(1) by suppressing "Retrieving [path]" lines that were emitted to support
    the interactive sftp(1) client. ok markus@
    
    OpenBSD-Commit-ID: 06be293df5f156a18f366079be2f33fa68001acc

commit 48cd39b7a4e5e7c25101c6d1179f98fe544835cd
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Aug 7 00:07:18 2021 +0000

    upstream: factor out a structure duplicated between downloading
    
    and crossloading; ok markus@
    
    OpenBSD-Commit-ID: 96eede24d520569232086a129febe342e4765d39

commit 318c06bb04ee21a0cfa6b6022a201eacaa53f388
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Aug 7 00:06:30 2021 +0000

    upstream: use sftp_client crossloading to implement scp -3
    
    feedback/ok markus@
    
    OpenBSD-Commit-ID: 7db4c0086cfc12afc9cfb71d4c2fd3c7e9416ee9

commit de7115b373ba0be3861c65de9b606a3e0e9d29a3
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Aug 7 00:02:41 2021 +0000

    upstream: support for "cross"-loading files/directories, i.e.
    
    downloading from one SFTP server while simultaneously uploading to another.
    
    feedback & ok markus@
    
    OpenBSD-Commit-ID: 3982878e29d8df0fa4ddc502f5ff6126ac714235

commit a50bd0367ff2063bbc70a387740a2aa6914de094
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Aug 7 00:01:29 2021 +0000

    upstream: factor our SSH2_FXP_OPEN calls into their own function;
    
    "looks fine" markus@
    
    OpenBSD-Commit-ID: d3dea2153f08855c6d9dacc01973248944adeffb

commit e3c0ba05873cf3d3f7d19d595667a251026b2d84
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Aug 7 00:00:33 2021 +0000

    upstream: prepare for scp -3 implemented via sftp
    
    OpenBSD-Commit-ID: 194aac0dd87cb175334b71c2a30623a5ad55bb44

commit 395d8fbdb094497211e1461cf0e2f80af5617e0a
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Aug 6 09:00:18 2021 +0000

    upstream: Make diff invocation more portable.
    
    POSIX does not require diff to have -N, so compare in both directions
    with just -r, which should catch missing files in either directory.
    
    OpenBSD-Regress-ID: 0e2ec8594556a6f369ed5a0a90c6806419b845f7

commit d247a73ce27b460138599648d9c637c6f2b77605
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Aug 4 21:28:00 2021 +0000

    upstream: regression test for scp -3
    
    OpenBSD-Regress-ID: b44375d125c827754a1f722ec6b6b75b634de05d

commit 35c8e41a6f6d8ad76f8d1cd81ac2ea23d0d993b2
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Aug 6 05:04:42 2021 +0000

    upstream: Document "ProxyJump none". bz#3334.
    
    OpenBSD-Commit-ID: f78cc6f55731f2cd35c3a41d5352ac1ee419eba7

commit 911ec6411821bda535d09778df7503b92f0eafab
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Aug 4 01:34:55 2021 +0000

    upstream: Allow for different (but POSIX compliant) behaviour of
    
    basename(3) and prevent a use-after-free in that case in the new sftp-compat
    code.
    
    POSIX allows basename(3) to either return a pointer to static storage
    or modify the passed string and return a pointer to that.  OpenBSD does
    the former and works as is, but on other platforms "filename" points
    into "tmp" which was just freed.  This makes the freeing of tmp
    consistent with the other variable in the loop.
    
    Pinpointed by the -portable Valgrind regress test.  ok djm@ deraadt@
    
    OpenBSD-Commit-ID: 750f3c19bd4440e4210e30dd5d7367386e833374

commit 6df1fecb5d3e51f3a8027a74885c3a44f6cbfcbd
Author: Damien Miller <djm@mindrot.org>
Date:   Wed Aug 4 11:05:11 2021 +1000

    use openbsd-compat glob.h is required

commit 9ebd1828881dfc9014a344587934a5ce7db6fa1b
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Aug 3 21:03:23 2021 +1000

    Missing space between macro arg and punctuation.
    
    From jmc@

commit 0fd3f62eddc7cf54dcc9053be6f58998f3eb926a
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Aug 3 21:02:33 2021 +1000

    Avoid lines >80 chars.  From jmc@

commit af5d8094d8b755e1daaf2e20ff1dc252800b4c9b
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Aug 3 01:05:24 2021 +0000

    upstream: regression tests for scp SFTP protocol support; mostly by
    
    Jakub Jelen in GHPR#194 ok markus
    
    OpenBSD-Regress-ID: 36f1458525bcb111741ec8547eaf58b13cddc715

commit e4673b7f67ae7740131a4ecea29a846593049a91
Author: anton@openbsd.org <anton@openbsd.org>
Date:   Thu Jul 29 15:34:09 2021 +0000

    upstream: Treat doas with arguments as a valid SUDO variable.
    
    Allows one to specify SUDO="doas -n" which I do while running make regress.
    
    ok dtucker@
    
    OpenBSD-Regress-ID: 4fe5814b5010dbf0885500d703bea06048d11005

commit 197e29f1cca190d767c4b2b63a662f9a9e5da0b3
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Aug 2 23:38:27 2021 +0000

    upstream: support for using the SFTP protocol for file transfers in
    
    scp, via a new "-M sftp" option. Marked as experimental for now.
    
    Some corner-cases exist, in particular there is no attempt to
    provide bug-compatibility with scp's weird "double shell" quoting
    rules.
    
    Mostly by Jakub Jelen in GHPR#194 with some tweaks by me. ok markus@
    Thanks jmc@ for improving the scp.1 bits.
    
    OpenBSD-Commit-ID: 6ce4c9157ff17b650ace571c9f7793d92874051c

commit dd533c7ab79d61a7796b77b64bd81b098e0d7f9f
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Fri Jul 30 14:28:13 2021 +0000

    upstream: fix a formatting error and add some Xr; from debian at
    
    helgefjell de
    
    removed references to rlogin etc. as no longer relevant;
    suggested by djm
    
    ok djm dtucker
    
    OpenBSD-Commit-ID: 3c431c303068d3aec5bb18573a0bd5e0cd77c5ae

commit c7cd347a8823819411222c1e10a0d26747d0fd5c
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Fri Jul 30 14:25:01 2021 +0000

    upstream: fix a formatting error and mark up known_hosts
    
    consistently; issues reported by debian at helgefjell de
    
    ok djm dtucker
    
    OpenBSD-Commit-ID: a1fd8d21dc77f507685443832df0c9700481b0ce

commit 4455aec2e4fc90f64ae4fc47e78ebc9c18721738
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Wed Jul 28 05:57:42 2021 +0000

    upstream: no need to talk about version 2 with the -Q option, so
    
    rewrite the text to read better;
    
    issue reported by debian at helgefjell de
    ok djm dtucker
    
    OpenBSD-Commit-ID: 59fe2e8219c37906740ad062e0fdaea487dbe9cf

commit bec429338e9b30d2c7668060e82608286a8a4777
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Tue Jul 27 14:28:46 2021 +0000

    upstream: word fix; reported by debian at helgefjell de
    
    OpenBSD-Commit-ID: 0c6fd22142422a25343c5bd1a618f31618f41ece

commit efad4deb5a1f1cf79ebefd63c6625059060bfbe1
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Tue Jul 27 14:14:25 2021 +0000

    upstream: standardise the grammar in the options list; issue
    
    reported by debian at helgefjell de
    
    ok dtucker djm
    
    OpenBSD-Commit-ID: 7ac15575045d82f4b205a42cc7d5207fe4c3f8e6

commit 1e11fb24066f3fc259ee30db3dbb2a3127e05956
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Aug 2 18:56:29 2021 +1000

    Check for RLIMIT_NOFILE before trying to use it.

commit 0f494236b49fb48c1ef33669f14822ca4f3ce2f4
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Jul 27 17:45:34 2021 +1000

    lastenv is only used in setenv.
    
    Prevents an unused variable warning on platforms that have setenv but
    not unsetenv.

commit a1f78e08bdb3eaa88603ba3c6e01de7c8671e28a
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Jul 26 12:45:30 2021 +1000

    Move SUDO to "make test" command line.
    
    Environment variables don't get passed by vmrun, so move to command
    line.

commit 02e624273b9c78a49a01239159b8c09b8409b1a0
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sun Jul 25 23:26:36 2021 +1000

    Set SUDO for tests and cleanup.

commit 460ae5d93051bab70239ad823dd784822d58baad
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sun Jul 25 22:37:55 2021 +1000

    Pass OPENSSL=no to make tests too.

commit b398f499c68d74ebe3298b73757cf3f36e14e0cb
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sun Jul 25 12:27:37 2021 +0000

    upstream: Skip unit and makefile-based key conversion tests when
    
    we're building with OPENSSL=no.
    
    OpenBSD-Regress-ID: 20455ed9a977c93f846059d1fcb48e29e2c8d732

commit 727ce36c8c5941bde99216d27109405907caae4f
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sun Jul 25 12:13:03 2021 +0000

    upstream: Replace OPENSSL as the variable that points to the
    
    openssl binary with OPENSSL_BIN.  This will allow us to use the OPENSSL
    variable from mk.conf or the make(1) command line indicating if we're
    building with our without OpenSSL, and ultimately get the regress tests
    working in the OPENSSL=no configuration.
    
    OpenBSD-Regress-ID: 2d788fade3264d7803e5b54cae8875963f688c4e

commit 55e17101a9075f6a63af724261c5744809dcb95c
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sat Jul 24 02:57:28 2021 +0000

    upstream: Skip RFC4716 format import and export tests when built
    
    without OpenSSL.
    
    OpenBSD-Regress-ID: d2c2d5d38c1acc2b88cc99cfe00a2eb8bb39dfa4

commit f5ccb5895d39cd627ad9e7b2c671d2587616100d
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sat Jul 24 02:51:14 2021 +0000

    upstream: Don't omit ssh-keygen -y from usage when built without
    
    OpenSSL.  It is actually available, albeit only for ed25519 keys.
    
    OpenBSD-Commit-ID: 7a254c33d0e6a55c30c6b016a8d298d3cb7a7674

commit 819d57ac23469f1f03baa8feb38ddefbada90fdc
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sat Jul 24 02:08:13 2021 +0000

    upstream: Exclude key conversion options from usage when built
    
    without OpenSSL since those are not available, similar to what we currently
    do with the moduli screening options.  We can also use this to skip the
    conversion regression tests in this case.
    
    OpenBSD-Commit-ID: 3c82caa398cf99cd4518c23bba5a2fc66b16bafe

commit b6673b1d2ee90b4690ee84f634efe40225423c38
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Jul 24 13:02:51 2021 +1000

    Test OpenBSD upstream with and without OpenSSL.

commit 9d38074b5453c1abbdf888e80828c278d3b886ac
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Jul 24 01:54:23 2021 +0000

    upstream: test for first-match-wins in authorized_keys environment=
    
    options
    
    OpenBSD-Regress-ID: 1517c90276fe84b5dc5821c59f88877fcc34c0e8

commit 2b76f1dd19787e784711ea297ad8fc938b4484fd
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jul 23 05:53:02 2021 +0000

    upstream: Simplify keygen-convert by using $SSH_KEYTYPES directly.
    
    OpenBSD-Regress-ID: cdbe408ec3671ea9ee9b55651ee551370d2a4108

commit 7d64a9fb587ba9592f027f7a2264226c713d6579
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Jul 24 01:55:19 2021 +0000

    upstream: don't leak environment= variable when it is not the first
    
    match
    
    OpenBSD-Commit-ID: 7fbdc3dfe0032deaf003fd937eeb4d434ee4efe0

commit db2130e2340bf923e41c791aa9cd27b9e926042c
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Fri Jul 23 06:01:17 2021 +0000

    upstream: punctuation;
    
    OpenBSD-Commit-ID: 64be152e378c45975073ab1c07e0db7eddd15806

commit 03190d10980c6fc9124e988cb2df13101f266507
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jul 23 05:56:47 2021 +0000

    upstream: mention in comment that read_passphrase(..., RP_ALLOW_STDIN)
    
    will try to use askpass first. bz3314
    
    convert a couple of debug() -> debug_f() while here
    
    OpenBSD-Commit-ID: c7e812aebc28fcc5db06d4710e0f73613dee545c

commit 1653ece6832b2b304d46866b262d5f69880a9ec7
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jul 23 05:07:16 2021 +0000

    upstream: Test conversion of ed25519 and ecdsa keys too.
    
    OpenBSD-Regress-ID: 3676d2d00e58e0d6d37f2878f108cc2b83bbe4bb

commit 8b7af02dcf9d2b738787efd27da7ffda9859bed2
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jul 23 04:56:21 2021 +0000

    upstream: Add test for exporting pubkey from a passphrase-protected
    
    private key.
    
    OpenBSD-Regress-ID: da99d93e7b235fbd5b5aaa01efc411225e6ba8ac

commit 441095d4a3e5048fe3c87a6c5db5bc3383d767fb
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jul 23 03:54:55 2021 +0000

    upstream: regression test for time-limited signature keys
    
    OpenBSD-Regress-ID: 2a6f3bd900dbee0a3c96f1ff23e032c93ab392bc

commit 9e1882ef6489a7dd16b6d7794af96629cae61a53
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jul 23 05:24:02 2021 +0000

    upstream: note successful authentication method in final "Authenticated
    
    to ..." message and partial auth success messages (all at LogLevel=verbose)
    ok dtucker@
    
    OpenBSD-Commit-ID: 06834b89ceb89f8f16c5321d368a66c08f441984

commit a917e973a1b90b40ff1e950df083364b48fc6c78
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jul 23 04:04:52 2021 +0000

    upstream: Add a ForkAfterAuthentication ssh_config(5) counterpart
    
    to the ssh(1) -f flag. Last part of GHPR231 from Volker Diels-Grabsch. ok
    dtucker
    
    OpenBSD-Commit-ID: b18aeda12efdebe2093d55263c90fe4ea0bce0d3

commit e0c5088f1c96a145eb6ea1dee438010da78f9ef5
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jul 23 04:00:59 2021 +0000

    upstream: Add a StdinNull directive to ssh_config(5) that allows
    
    the config file to do the same thing as -n does on the ssh(1) commandline.
    Patch from Volker Diels-Grabsch via GHPR231; ok dtucker
    
    OpenBSD-Commit-ID: 66ddf3f15c76796d4dcd22ff464aed1edd62468e

commit e3957e21ffdc119d6d04c0b1686f8e2fe052f5ea
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jul 23 03:57:20 2021 +0000

    upstream: make authorized_keys environment="..." directives
    
    first-match-wins and more strictly limit their maximum number; prompted by
    OOM reported by OSS-fuzz (35470).
    
    feedback and ok dtucker@
    
    OpenBSD-Commit-ID: 01f63fc10dcd995e7aed9c378ad879161af83121

commit d0bb1ce731762c55acb95817df4d5fab526c7ecd
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jul 23 03:37:52 2021 +0000

    upstream: Let allowed signers files used by ssh-keygen(1)
    
    signatures support key lifetimes, and allow the verification mode to specify
    a signature time to check at. This is intended for use by git to support
    signing objects using ssh keys. ok dtucker@
    
    OpenBSD-Commit-ID: 3e2c67b7dcd94f0610194d1e8e4907829a40cf31

commit 44142068dc7ef783d135e91ff954e754d2ed432e
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Jul 19 08:48:33 2021 +0000

    upstream: Use SUDO when setting up hostkey.
    
    OpenBSD-Regress-ID: 990cf4481cab8dad62e90818a9b4b36c533851a7

commit 6b67f3f1d1d187597e54a139cc7785c0acebd9a2
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Jul 19 05:08:54 2021 +0000

    upstream: Increase time margin for rekey tests. Should help
    
    reliability on very heavily loaded hosts.
    
    OpenBSD-Regress-ID: 4c28a0fce3ea89ebde441d7091464176e9730533

commit 7953e1bfce9e76bec41c1331a29bc6cff9d416b8
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Jul 19 13:47:51 2021 +1000

    Add sshfp-connect.sh file missed in previous.

commit b75a80fa8369864916d4c93a50576155cad4df03
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Jul 19 03:13:28 2021 +0000

    upstream: Ensure that all returned SSHFP records for the specified host
    
    name and hostkey type match instead of only one.  While there, simplify the
    code somewhat and add some debugging.  Based on discussion in bz#3322, ok
    djm@.
    
    OpenBSD-Commit-ID: 0a6a0a476eb7f9dfe8fe2c05a1a395e3e9b22ee4

commit 1cc1fd095393663cd72ddac927d82c6384c622ba
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Jul 19 02:21:50 2021 +0000

    upstream: Id sync only, -portable already has this.
    
    Put dh_set_moduli_file call inside ifdef WITH_OPENSSL. Fixes
    build with OPENSSL=no.
    
    OpenBSD-Commit-ID: af54abbebfb12bcde6219a44d544e18204defb15

commit 33abbe2f4153f5ca5c874582f6a7cc91ae167485
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Jul 19 02:46:34 2021 +0000

    upstream: Add test for host key verification via SSHFP records. This
    
    requires some external setup to operate so is disabled by default (see
    comments in sshfp-connect.sh).
    
    OpenBSD-Regress-ID: c52c461bd1df3a803d17498917d156ef64512fd9

commit f0cd000d8e3afeb0416dce1c711c3d7c28d89bdd
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Jul 19 02:29:28 2021 +0000

    upstream: Add ed25519 key and test SSHFP export of it. Only test
    
    RSA SSHFP export if we have RSA functionality compiled in.
    
    OpenBSD-Regress-ID: b4ff5181b8c9a5862e7f0ecdd96108622333a9af

commit 0075511e27e5394faa28edca02bfbf13b9a6693e
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Jul 19 00:16:26 2021 +0000

    upstream: Group keygen tests together.
    
    OpenBSD-Regress-ID: 07e2d25c527bb44f03b7c329d893a1f2d6c5c40c

commit 034828820c7e62652e7c48f9ee6b67fb7ba6fa26
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sun Jul 18 23:10:10 2021 +0000

    upstream: Add test for ssh-keygen printing of SSHFP records.
    
    OpenBSD-Regress-ID: fde9566b56eeb980e149bbe157a884838507c46b

commit 52c3b6985ef1d5dadb4c4fe212f8b3a78ca96812
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Jul 17 00:38:11 2021 +0000

    upstream: wrap some long lines
    
    OpenBSD-Commit-ID: 4f5186b1466656762dae37d3e569438d900c350d

commit 43ec991a782791d0b3f42898cd789f99a07bfaa4
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Jul 17 00:36:53 2021 +0000

    upstream: fix sftp on ControlPersist connections, broken by recent
    
    SessionType change; spotted by sthen@
    
    OpenBSD-Commit-ID: 4c5ddc5698790ae6ff50d2a4f8f832f0eeeaa234

commit 073f45c236550f158c9a94003e4611c07dea5279
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jul 16 09:00:23 2021 +0000

    upstream: Explicitly check for and start time-based rekeying in the
    
    client and server mainloops.
    
    Previously the rekey timeout could expire but rekeying would not start
    until a packet was sent or received. This could cause us to spin in
    select() on the rekey timeout if the connection was quiet.
    
    ok markus@
    
    OpenBSD-Commit-ID: 4356cf50d7900f3df0a8f2117d9e07c91b9ff987

commit ef7c4e52d5d840607f9ca3a302a4cbb81053eccf
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Wed Jul 14 06:46:38 2021 +0000

    upstream: reorder SessionType; ok djm
    
    OpenBSD-Commit-ID: c7dd0b39e942b1caf4976a0b1cf0fed33d05418c

commit 8aa2f9aeb56506dca996d68ab90ab9c0bebd7ec3
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Jul 14 11:26:50 2021 +1000

    Make whitespace consistent.

commit 4f4297ee9b8a39f4dfd243a74c5f51f9e7a05723
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Jul 14 11:26:12 2021 +1000

    Add ARM64 Linux self-hosted runner.

commit eda8909d1b0a85b9c3804a04d03ec6738fd9dc7f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jul 13 23:48:36 2021 +0000

    upstream: add a SessionType directive to ssh_config, allowing the
    
    configuration file to offer equivalent control to the -N (no session) and -s
    (subsystem) command-line flags.
    
    Part of GHPR#231 by Volker Diels-Grabsch with some minor tweaks;
    feedback and ok dtucker@
    
    OpenBSD-Commit-ID: 726ee931dd4c5cc7f1d7a187b26f41257f9a2d12

commit 7ae69f2628e338ba6e0eae7ee8a63bcf8fea7538
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jul 12 02:12:22 2021 +0000

    upstream: fix some broken tests; clean up output
    
    OpenBSD-Regress-ID: 1d5038edb511dc4ce1622344c1e724626a253566

commit f5fc6a4c3404bbf65c21ca6361853b33d78aa87e
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Jul 12 18:00:05 2021 +1000

    Add configure-time detection for SSH_TIME_T_MAX.
    
    Should fix printing cert times exceeding INT_MAX (bz#3329) on platforms
    were time_t is a long long.  The limit used is for the signed type, so if
    some system has a 32bit unsigned time_t then the lower limit will still
    be imposed and we would need to add some way to detect this.  Anyone using
    an unsigned 64bit can let us know when it starts being a problem.

commit fd2d06ae4442820429d634c0a8bae11c8e40c174
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Jul 12 06:22:57 2021 +0000

    upstream: Make limit for time_t test unconditional in the
    
    format_absolute_time fix for bz#3329 that allows printing of timestamps past
    INT_MAX. This was incorrectly included with the previous commit.   Based on
    discussion with djm@.
    
    OpenBSD-Commit-ID: 835936f6837c86504b07cabb596b613600cf0f6e

commit 6c29b387cd64a57b0ec8ae7d2c8d02789d88fcc3
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Jul 12 06:08:57 2021 +0000

    upstream: Use existing format_absolute_time() function when
    
    printing cert validity instead of doing it inline.  Part of bz#3329.
    
    OpenBSD-Commit-ID: a13d4e3c4f59644c23745eb02a09b2a4e717c00c

commit 99981d5f8bfa383791afea03f6bce8454e96e323
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jul 9 09:55:56 2021 +0000

    upstream: silence redundant error message; reported by Fabian Stelzer
    
    OpenBSD-Commit-ID: 9349a703016579a60557dafd03af2fe1d44e6aa2

commit e86097813419b49d5bff5c4b51d1c3a5d4d2d804
Author: John Ericson <John.Ericson@Obsidian.Systems>
Date:   Sat Dec 26 11:40:49 2020 -0500

    Re-indent krb5 section after pkg-config addition.

commit 32dd2daa56c294e40ff7efea482c9eac536d8cbb
Author: John Ericson <John.Ericson@Obsidian.Systems>
Date:   Sat Dec 26 11:40:49 2020 -0500

    Support finding Kerberos via pkg-config
    
    This makes cross compilation easier.

commit def7a72234d7e4f684d72d33a0f7229f9eee0aa4
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Jul 9 14:34:06 2021 +1000

    Update comments about EGD to include prngd.

commit b5d23150b4e3368f4983fd169d432c07afeee45a
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Jul 5 01:21:07 2021 +0000

    upstream: Fix a couple of whitespace things. Portable already has
    
    these so this removes two diffs between the two.
    
    OpenBSD-Commit-ID: 769f017ebafd8e741e337b3e9e89eb5ac73c9c56

commit 8f57be9f279b8e905f9883066aa633c7e67b31cf
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Jul 5 01:16:46 2021 +0000

    upstream: Order includes as per style(9). Portable already has
    
    these so this removes a handful of diffs between the two.
    
    OpenBSD-Commit-ID: 8bd7452d809b199c19bfc49511a798f414eb4a77

commit b75624f8733b3ed9e240f86cac5d4a39dae11848
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Jul 5 00:50:25 2021 +0000

    upstream: Remove comment referencing now-removed
    
    RhostsRSAAuthentication.  ok djm@
    
    OpenBSD-Commit-ID: 3d864bfbd99a1d4429a58e301688f3be464827a9

commit b67eb12f013c5441bb4f0893a97533582ad4eb13
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jul 5 00:25:42 2021 +0000

    upstream: allow spaces to appear in usernames for local to remote,
    
    and scp -3 remote to remote copies. with & ok dtucker bz#1164
    
    OpenBSD-Commit-ID: e9b550f3a85ffbb079b6720833da31317901d6dd

commit 8c4ef0943e574f614fc7c6c7e427fd81ee64ab87
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jul 2 07:20:44 2021 +0000

    upstream: Remove obsolete comments about SSHv1 auth methods. ok
    
    djm@
    
    OpenBSD-Commit-ID: 6060f70966f362d8eb4bec3da2f6c4712fbfb98f

commit 88908c9b61bcb99f16e8d398fc41e2b3b4be2003
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Jul 3 23:00:19 2021 +1000

    Remove reference to ChallengeResponse.
    
    challenge_response_authentication was removed from the struct, keeping
    kbd_interactive_authentication.

commit 321874416d610ad2158ce6112f094a4862c2e37f
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Jul 3 20:38:09 2021 +1000

    Move signal.h up include order to match upstream.

commit 4fa83e2d0e32c2dd758653e0359984bbf1334f32
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Jul 3 20:36:06 2021 +1000

    Remove old OpenBSD version marker.
    
    Looks like an accidental leftover from a sync.

commit 9d5e31f55d5f3899b72645bac41a932d298ad73b
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Jul 3 20:34:19 2021 +1000

    Remove duplicate error on error path.
    
    There's an extra error() call on the listen error path, it looks like
    its removal was missed during an upstream sync.

commit 888c459925c7478ce22ff206c9ac1fb812a40caf
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Jul 3 20:32:46 2021 +1000

    Remove some whitespace not in upstream.
    
    Reduces diff vs OpenBSD by a small amount.

commit 4d2d4d47a18d93f3e0a91a241a6fdb545bbf7dc2
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Jul 3 19:27:43 2021 +1000

    Replace remaining references to ChallengeResponse.
    
    Portable had a few additional references to ChallengeResponse related to
    UsePAM, replaces these with equivalent keyboard-interactive ones.

commit 53237ac789183946dac6dcb8838bc3b6b9b43be1
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Jul 3 19:23:28 2021 +1000

    Sync remaining ChallengeResponse removal.
    
    These were omitted from commit 88868fd131.

commit 2c9e4b319f7e98744b188b0f58859d431def343b
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Jul 3 19:17:31 2021 +1000

    Disable rocky84 to figure out why agent test fails

commit bfe19197a92b7916f64a121fbd3c179abf15e218
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Jul 2 15:43:28 2021 +1000

    Remove now-unused SSHv1 enums.
    
    sRhostsRSAAuthentication and sRSAAuthentication are protocol 1 options
    and are no longer used.

commit c73b02d92d72458a5312bd098f32ce88868fd131
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jul 2 05:11:20 2021 +0000

    upstream: Remove references to ChallengeResponseAuthentication in
    
    favour of KbdInteractiveAuthentication.  The former is what was in SSHv1, the
    latter is what is in SSHv2 (RFC4256) and they were treated as somewhat but
    not entirely equivalent.  We retain the old name as deprecated alias so
    config files continue to work and a reference in the man page for people
    looking for it.
    
    Prompted by bz#3303 which pointed out the discrepancy between the two
    when used with Match.  Man page help & ok jmc@, with & ok djm@
    
    OpenBSD-Commit-ID: 2c1bff8e5c9852cfcdab1f3ea94dfef5a22f3b7e

commit f841fc9c8c7568a3b5d84a4cc0cefacb7dbc16b9
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Jul 2 15:20:32 2021 +1000

    Fix ifdefs around get_random_bytes_prngd.
    
    get_random_bytes_prngd() is used if either of PRNGD_PORT or PRNGD_SOCKET
    are defined, so adjust ifdef accordingly.

commit 0767627cf66574484b9c0834500b42ea04fe528a
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Jul 2 14:30:23 2021 +1000

    wrap get_random_bytes_prngd() in ifdef
    
    avoid unused static function warning

commit f93fdc4de158386efe1116bd44c5b3f4a7a82c25
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Jun 28 13:06:37 2021 +1000

    Add rocky84 test target.

commit d443006c0ddfa7f6a5bd9c0ae92036f3d5f2fa3b
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 25 06:30:22 2021 +0000

    upstream: fix decoding of X.509 subject name; from Leif Thuresson
    
    via bz3327 ok markus@
    
    OpenBSD-Commit-ID: 0ea2e28f39750dd388b7e317bc43dd997a217ae8

commit 2a5704ec142202d387fda2d6872fd4715ab81347
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jun 25 06:20:39 2021 +0000

    upstream: Use better language to refer to the user. From l1ving
    
    via github PR#250, ok jmc@
    
    OpenBSD-Commit-ID: 07ca3526626996613e128aeddf7748c93c4d6bbf

commit 4bdf7a04797a0ea1c431a9d54588417c29177d19
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jun 25 03:38:17 2021 +0000

    upstream: Replace SIGCHLD/notify_pipe kludge with pselect.
    
    Previously sshd's SIGCHLD handler would wake up select() by writing a
    byte to notify_pipe.  We can remove this by blocking SIGCHLD, checking
    for child terminations then passing the original signal mask through
    to pselect.  This ensures that the pselect will immediately wake up if
    a child terminates between wait()ing on them and the pselect.
    
    In -portable, for platforms that do not have pselect the kludge is still
    there but is hidden behind a pselect interface.
    
    Based on other changes for bz#2158, ok djm@
    
    OpenBSD-Commit-ID: 202c85de0b3bdf1744fe53529a05404c5480d813

commit c9f7bba2e6f70b7ac1f5ea190d890cb5162ce127
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Jun 25 15:08:18 2021 +1000

    Move closefrom() to before first malloc.
    
    When built against tcmalloc, tcmalloc allocates a descriptor for its
    internal use, so calling closefrom() afterward causes the descriptor
    number to be reused resulting in a corrupted connection.  Moving the
    closefrom a little earlier should resolve this.  From kircherlike at
    outlook.com via bz#3321, ok djm@

commit 7ebfe4e439853b88997c9cfc2ff703408a1cca92
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Jun 18 20:41:45 2021 +1000

    Put second -lssh in link line for sftp-server.
    
    When building --without-openssl the recent port-prngd.c change adds
    a dependency on atomicio, but since nothing else in sftp-server uses
    it, the linker may not find it.  Add a second -lssh similar to other
    binaries.

commit e409d7966785cfd9f5970e66a820685c42169717
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Jun 18 18:34:08 2021 +1000

    Try EGD/PRNGD if random device fails.
    
    When built --without-openssl, try EGD/PRGGD (if configured) as a last
    resort before failing.

commit e43a898043faa3a965dbaa1193cc60e0b479033d
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Jun 18 18:32:51 2021 +1000

    Split EGD/PRNGD interface into its own file.
    
    This will allow us to use it when building --without-openssl.

commit acb2887a769a1b1912cfd7067f3ce04fad240260
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Jun 17 21:03:19 2021 +1000

    Handle GIDs > 2^31 in getgrouplist.
    
    When compiled in 32bit mode, the getgrouplist implementation may fail
    for GIDs greater than LONG_MAX.  Analysis and change from ralf.winkel
    at tui.com.

commit 31fac20c941126281b527605b73bff30a8f02edd
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu Jun 10 09:46:28 2021 +0000

    upstream: Use $SUDO when reading sshd's pidfile here too.
    
    OpenBSD-Regress-ID: 6bfb0d455d493f24839034a629c5306f84dbd409

commit a3a58acffc8cc527f8fc6729486d34e4c3d27643
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu Jun 10 09:43:51 2021 +0000

    upstream: Use $SUDO when reading sshd's pidfile in case it was
    
    created with a very restrictive umask.  This resyncs with -portable.
    
    OpenBSD-Regress-ID: 07fd2af06df759d4f64b82c59094accca1076a5d

commit 249ad4ae51cd3bc235e75a4846eccdf8b1416611
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu Jun 10 09:37:59 2021 +0000

    upstream: Set umask when creating hostkeys to prevent excessive
    
    permissions warning.
    
    OpenBSD-Regress-ID: 382841db0ee28dfef7f7bffbd511803e1b8ab0ef

commit 9d0892153c005cc65897e9372b01fa66fcbe2842
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu Jun 10 03:45:31 2021 +0000

    upstream: Add regress test for SIGHUP restart
    
    while handling active and unauthenticated clients.  Should catch anything
    similar to the pselect bug just fixed in sshd.c.
    
    OpenBSD-Regress-ID: 3b3c19b5e75e43af1ebcb9586875b3ae3a4cac73

commit 73f6f191f44440ca3049b9d3c8e5401d10b55097
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu Jun 10 03:14:14 2021 +0000

    upstream: Continue accept loop when pselect
    
    returns -1, eg if it was interrupted by a signal.  This should prevent
    the hang discovered by sthen@ wherein sshd receives a SIGHUP while it has
    an unauthenticated child and goes on to a blocking read on a notify_pipe.
    feedback deraadt@, ok djm@
    
    OpenBSD-Commit-ID: 0243c1c5544fca0974dae92cd4079543a3fceaa0

commit c785c0ae134a8e8b5c82b2193f64c632a98159e4
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 8 22:30:27 2021 +0000

    upstream: test that UserKnownHostsFile correctly accepts multiple
    
    arguments; would have caught readconf.c r1.356 regression
    
    OpenBSD-Regress-ID: 71ca54e66c2a0211b04999263e56390b1f323a6a

commit 1a6f6b08e62c78906a3032e8d9a83e721c84574e
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 8 22:06:12 2021 +0000

    upstream: fix regression in r1.356: for ssh_config options that
    
    accepted multiple string arguments, ssh was only recording the first.
    Reported by Lucas via bugs@
    
    OpenBSD-Commit-ID: 7cbf182f7449bf1cb7c5b4452667dc2b41170d6d

commit 78e30af3e2b2dd540a341cc827c6b98dd8b0a6de
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 8 07:40:12 2021 +0000

    upstream: test argv_split() optional termination on comments
    
    OpenBSD-Regress-ID: 9fd1c4a27a409897437c010cfd79c54b639a059c

commit a023138957ea2becf1c7f93fcc42b0aaac6f2b03
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Jun 8 07:05:27 2021 +0000

    upstream: Add testcases from bz#3319 for IPQoS and TunnelDevice
    
    being overridden on the command line.
    
    OpenBSD-Regress-ID: 801674d5d2d02abd58274a78cab2711f11de14a8

commit 660cea10b2cdc11f13ba99c89b1bbb368a4d9ff2
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 8 06:52:43 2021 +0000

    upstream: sprinkle some "# comment" at end of configuration lines
    
    to test comment handling
    
    OpenBSD-Regress-ID: cb82fbf40bda5c257a9f742c63b1798e5a8fdda7

commit acc9c32dcb6def6c7d3688bceb4c0e59bd26b411
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 8 06:51:47 2021 +0000

    upstream: more descriptive failure message
    
    OpenBSD-Regress-ID: 5300f6faf1d9e99c0cd10827b51756c5510e3509

commit ce04dd4eae23d1c9cf7c424a702f48ee78573bc1
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 7 01:16:34 2021 +0000

    upstream: test AuthenticationMethods inside a Match block as well
    
    as in the main config section
    
    OpenBSD-Regress-ID: ebe0a686621b7cb8bb003ac520975279c28747f7

commit 9018bd821fca17e26e92f7a7e51d9b24cd62f2db
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 7 00:00:50 2021 +0000

    upstream: prepare for stricter sshd_config parsing that will refuse
    
    a config that has {Allow,Deny}{Users,Groups} on a line with no subsequent
    arguments. Such lines are permitted but are nonsensical noops ATM
    
    OpenBSD-Regress-ID: ef65463fcbc0bd044e27f3fe400ea56eb4b8f650

commit a10f929d1ce80640129fc5b6bc1acd9bf689169e
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 8 07:09:42 2021 +0000

    upstream: switch sshd_config parsing to argv_split()
    
    similar to the previous commit, this switches sshd_config parsing to
    the newer tokeniser. Config parsing will be a little stricter wrt
    quote correctness and directives appearing without arguments.
    
    feedback and ok markus@
    
    tested in snaps for the last five or so days - thanks Theo and those who
    caught bugs
    
    OpenBSD-Commit-ID: 9c4305631d20c2d194661504ce11e1f68b20d93e

commit ea9e45c89a4822d74a9d97fef8480707d584da4d
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 8 07:07:15 2021 +0000

    upstream: Switch ssh_config parsing to use argv_split()
    
    This fixes a couple of problems with the previous tokeniser,
    strdelim()
    
    1. strdelim() is permissive wrt accepting '=' characters. This is
      intended to allow it to tokenise "Option=value" but because it
      cannot keep state, it will incorrectly split "Opt=val=val2".
    2. strdelim() has rudimentry handling of quoted strings, but it
      is incomplete and inconsistent. E.g. it doesn't handle escaped
      quotes inside a quoted string.
    3. It has no support for stopping on a (unquoted) comment. Because
      of this readconf.c r1.343 added chopping of lines at '#', but
      this caused a regression because these characters may legitimately
      appear inside quoted strings.
    
    The new tokeniser is stricter is a number of cases, including #1 above
    but previously it was also possible for some directives to appear
    without arguments. AFAIK these were nonsensical in all cases, and the
    new tokeniser refuses to accept them.
    
    The new code handles quotes much better, permitting quoted space as
    well as escaped closing quotes. Finally, comment handling should be
    fixed - the tokeniser will terminate only on unquoted # characters.
    
    feedback & ok markus@
    
    tested in snaps for the last five or so days - thanks Theo and those who
    caught bugs
    
    OpenBSD-Commit-ID: dc72fd12af9d5398f4d9e159d671f9269c5b14d5

commit d786424986c04d1d375f231fda177c8408e05c3e
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Jun 8 07:02:46 2021 +0000

    upstream: Check if IPQoS or TunnelDevice are already set before
    
    overriding. Prevents values in config files from overriding values supplied
    on the command line.  bz#3319, ok markus.
    
    OpenBSD-Commit-ID: f3b08b898c324debb9195e6865d8999406938f74

commit aae4b4d3585b9f944d7dbd3c9e5ba0006c55e457
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 8 06:54:40 2021 +0000

    upstream: Allow argv_split() to optionally terminate tokenisation
    
    when it encounters an unquoted comment.
    
    Add some additional utility function for working with argument
    vectors, since we'll be switching to using them to parse
    ssh/sshd_config shortly.
    
    ok markus@ as part of a larger diff; tested in snaps
    
    OpenBSD-Commit-ID: fd9c108cef2f713f24e3bc5848861d221bb3a1ac

commit da9f9acaac5bab95dca642b48e0c8182b246ab69
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Jun 7 19:19:23 2021 +1000

    Save logs on failure for upstream test

commit 76883c60161e5f3808787085a27a8c37f8cc4e08
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Jun 7 14:36:32 2021 +1000

    Add obsdsnap-i386 upstream test target.

commit d45b9c63f947ec5ec314696e70281f6afddc0ac3
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 7 03:38:38 2021 +0000

    upstream: fix debug message when finding a private key to match a
    
    certificate being attempted for user authentication. Previously it would
    print the certificate's path, whereas it was supposed to be showing the
    private key's path. Patch from Alex Sherwin via GHPR247
    
    OpenBSD-Commit-ID: d5af3be66d0f22c371dc1fe6195e774a18b2327b

commit 530739d42f6102668aecd699be0ce59815c1eceb
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Jun 6 11:34:16 2021 +0000

    upstream: Match host certificates against host public keys, not private
    
    keys. Allows use of certificates with private keys held in a ssh-agent.
    Reported by Miles Zhou in bz3524; ok dtucker@
    
    OpenBSD-Commit-ID: 25f5bf70003126d19162862d9eb380bf34bac22a

commit 4265215d7300901fd7097061c7517688ade82f8e
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Jun 6 03:40:39 2021 +0000

    upstream: Client-side workaround for a bug in OpenSSH 7.4: this release
    
    allows RSA/SHA2 signatures for public key authentication but fails to
    advertise this correctly via SSH2_MSG_EXT_INFO. This causes clients of these
    server to incorrectly match PubkeyAcceptedAlgorithms and potentially refuse
    to offer valid keys.
    
    Reported by and based on patch from Gordon Messmer via bz3213, thanks
    also for additional analysis by Jakub Jelen. ok dtucker
    
    OpenBSD-Commit-ID: d6d0b7351d5d44c45f3daaa26efac65847a564f7

commit bda270d7fb8522d43c21a79a4b02a052d7c64de8
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Jun 6 03:17:02 2021 +0000

    upstream: degrade gracefully if a sftp-server offers the
    
    limits@openssh.com extension but fails when the client tries to invoke it.
    Reported by Hector Martin via bz3318
    
    OpenBSD-Commit-ID: bd9d1839c41811616ede4da467e25746fcd9b967

commit d345d5811afdc2d6923019b653cdd93c4cc95f76
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Jun 6 03:15:39 2021 +0000

    upstream: the limits@openssh.com extension was incorrectly marked
    
    as an operation that writes to the filesystem, which made it unavailable in
    sftp-server read-only mode. Spotted by Hector Martin via bz3318
    
    OpenBSD-Commit-ID: f054465230787e37516c4b57098fc7975e00f067

commit 2b71010d9b43d7b8c9ec1bf010beb00d98fa765a
Author: naddy@openbsd.org <naddy@openbsd.org>
Date:   Sat Jun 5 13:47:00 2021 +0000

    upstream: PROTOCOL.certkeys: update reference from IETF draft to
    
    RFC
    
    Also fix some typos.
    ok djm@
    
    OpenBSD-Commit-ID: 5e855b6c5a22b5b13f8ffa3897a868e40d349b44

commit aa99b2d9a3e45b943196914e8d8bf086646fdb54
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Jun 4 23:41:29 2021 +1000

    Clear notify_pipe from readset if present.
    
    Prevents leaking an implementation detail to the caller.

commit 6de8dadf6b4d0627d35bca0667ca44b1d61c2c6b
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Jun 4 23:24:25 2021 +1000

    space->tabs.

commit c8677065070ee34c05c7582a9c2f58d8642e552d
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Jun 4 18:39:48 2021 +1000

    Add pselect implementation for platforms without.
    
    This is basically the existing notify_pipe kludge from serverloop.c
    moved behind a pselect interface.  It works by installing a signal
    handler that writes to a pipe that the select is watching, then calls
    the original handler.
    
    The select call in serverloop will become pselect soon, at which point the
    kludge will be removed from thereand will only exist in the compat layer.
    Original code by markus, help from djm.

commit 7cd7f302d3a072748299f362f9e241d81fcecd26
Author: Vincent Brillault <vincent.brillault@cern.ch>
Date:   Sun May 24 09:15:06 2020 +0200

    auth_log: dont log partial successes as failures
    
    By design, 'partial' logins are successful logins, so initially with
    authenticated set to 1, for which another authentication is required. As
    a result, authenticated is always reset to 0 when partial is set to 1.
    However, even if authenticated is 0, those are not failed login
    attempts, similarly to attempts with authctxt->postponed set to 1.

commit e7606919180661edc7f698e6a1b4ef2cfb363ebf
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 4 06:19:07 2021 +0000

    upstream: The RB_GENERATE_STATIC(3) macro expands to a series of
    
    function definitions and not a statement, so there should be no semicolon
    following them. Patch from Michael Forney
    
    OpenBSD-Commit-ID: c975dd180580f0bdc0a4d5b7d41ab1f5e9b7bedd

commit c298c4da574ab92df2f051561aeb3e106b0ec954
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 4 05:59:18 2021 +0000

    upstream: rework authorized_keys example section, removing irrelevant
    
    stuff, de-wrapping the example lines and better aligning the examples with
    common usage and FAQs; ok jmc
    
    OpenBSD-Commit-ID: d59f1c9281f828148e2a2e49eb9629266803b75c

commit d9cb35bbec5f623589d7c58fc094817b33030f35
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 4 05:10:03 2021 +0000

    upstream: adjust SetEnv description to clarify $TERM handling
    
    OpenBSD-Commit-ID: 8b8cc0124856bc1094949d55615e5c44390bcb22

commit 771f57a8626709f2ad207058efd68fbf30d31553
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jun 4 05:09:08 2021 +0000

    upstream: Switch the listening select loop from select() to
    
    pselect() and mask signals while checking signal flags, umasking for pselect
    and restoring afterwards. Also restore signals before sighup_restart so they
    don't remain blocked after restart.
    
    This prevents a race where a SIGTERM or SIGHUP can arrive between
    checking the flag and calling select (eg if sshd is processing a
    new connection) resulting in sshd not shutting down until the next
    time it receives a new connection.  bz#2158, with & ok djm@
    
    OpenBSD-Commit-ID: bf85bf880fd78e00d7478657644fcda97b9a936f

commit f64f8c00d158acc1359b8a096835849b23aa2e86
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 4 05:02:40 2021 +0000

    upstream: allow ssh_config SetEnv to override $TERM, which is otherwise
    
    handled specially by the protocol. Useful in ~/.ssh/config to set TERM to
    something generic (e.g. "xterm" instead of "xterm-256color") for destinations
    that lack terminfo entries. feedback and ok dtucker@
    
    OpenBSD-Commit-ID: 38b1ef4d5bc159c7d9d589d05e3017433e2d5758

commit 60107677dc0ce1e93c61f23c433ad54687fcd9f5
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 4 04:02:21 2021 +0000

    upstream: correct extension name "no-presence-required" =>
    
    "no-touch-required"
    
    document "verify-required" option
    
    OpenBSD-Commit-ID: 1879ff4062cf61d79b515e433aff0bf49a6c55c5

commit ecc186e46e3e30f27539b4311366dfda502f0a08
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Jun 2 13:54:11 2021 +1000

    Retire fbsd7 test target.
    
    It's the slowest of the selfhosted targets (since it's 32bit but has
    most of the crypto algos). We still have coverage for 32bit i386.

commit 5de0867b822ec48b5eec9abde0f5f95d1d646546
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Jun 2 11:21:40 2021 +1000

    Check for $OPENSSL in md5 fallback too.

commit 1db69d1b6542f8419c04cee7fd523a4a11004be2
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Jun 2 11:17:54 2021 +1000

    Add dfly60 target.

commit a3f2dd955f1c19cad387a139f0e719af346ca6ef
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Jun 2 00:17:45 2021 +0000

    upstream: Merge back shell portability changes
    
    bringing it back in sync with -portable.
    
    OpenBSD-Regress-ID: c07905ba931e66ad7d849b87b7d19648007175d1

commit 9d482295c9f073e84d75af46b720a1c0f7ec2867
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Jun 1 23:56:20 2021 +0000

    upstream: Use a default value for $OPENSSL,
    
    allowing it to be overridden. Do the same in the PuTTY tests since it's
    needed there and not exported by test-exec.sh.
    
    OpenBSD-Regress-ID: c49dcd6aa7602a8606b7afa192196ca1fa65de16

commit 07660b3c99f8ea74ddf4a440e55c16c9f7fb3dd1
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon May 24 10:25:18 2021 +0000

    upstream: Find openssl binary via environment variable. This
    
    allows overriding if necessary (eg in -portable where we're testing against a
    specific version of OpenSSL).
    
    OpenBSD-Regress-ID: 491f39cae9e762c71aa4bf045803d077139815c5

commit 1a4d1da9188d7c88f646b61f0d6a3b34f47c5439
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri May 21 04:03:47 2021 +0000

    upstream: fix memleak in test
    
    OpenBSD-Regress-ID: 5e529d0982aa04666604936df43242e97a7a6f81

commit 60455a5d98065a73ec9a1f303345856bbd49aecc
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri May 21 03:59:01 2021 +0000

    upstream: also check contents of remaining string
    
    OpenBSD-Regress-ID: d526fa07253f4eebbc7d6205a0ab3d491ec71a28

commit 39f6cd207851d7b67ca46903bfce4a9f615b5b1c
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri May 21 03:48:07 2021 +0000

    upstream: unit test for misc.c:strdelim() that mostly servces to
    
    highlight its inconsistencies
    
    OpenBSD-Regress-ID: 8d2bf970fcc01ccc6e36a5065f89b9c7fa934195

commit 7a3a1dd2c7d4461962acbcc0ebee9445ba892be0
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu May 27 21:23:15 2021 +1000

    Put minix3 config in the host-specific block.

commit 59a194825f12fff8a7f75d91bf751ea17645711b
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon May 31 06:48:42 2021 +0000

    upstream: Hash challenge supplied by client during FIDO key enrollment
    
    prior to passing it to libfido2, which does expect a hash.
    
    There is no effect for users who are simply generating FIDO keys using
    ssh-keygen - by default we generate a random 256 bit challenge, but
    people building attestation workflows around our tools should now have
    a more consistent experience (esp. fewer failures when they fail to
    guess the magic 32-byte challenge length requirement).
    
    ok markus@
    
    OpenBSD-Commit-ID: b8d5363a6a7ca3b23dc28f3ca69470472959f2b5

commit eb68e669bc8ab968d4cca5bf1357baca7136a826
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu May 27 21:14:15 2021 +1000

    Include login_cap.h for login_getpwclass override.
    
    On minix3, login_getpwclass is __RENAME'ed to __login_getpwclass50 so
    without this the include overriding login_getpwclass causes a compile
    error.

commit 2063af71422501b65c7a92a5e14c0e6a3799ed89
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu May 27 21:13:38 2021 +1000

    Add minix3 test target.

commit 2e1efcfd9f94352ca5f4b6958af8a454f8cf48cd
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed May 26 01:47:24 2021 +0000

    upstream: fix SEGV in UpdateHostkeys debug() message, triggered
    
    when the update removed more host keys than remain present. Fix tested by
    reporter James Cook, via bugs@
    
    OpenBSD-Commit-ID: 44f641f6ee02bb957f0c1d150495b60cf7b869d3

commit 9acd76e6e4d2b519773e7119c33cf77f09534909
Author: naddy@openbsd.org <naddy@openbsd.org>
Date:   Sun May 23 18:22:57 2021 +0000

    upstream: ssh: The client configuration keyword is
    
    "hostbasedacceptedalgorithms"
    
    This fixes a mistake that slipped in when "HostbasedKeyTypes" was
    renamed to "HostbasedAcceptedAlgorithms".
    
    Bug report by zack@philomathiclife.com
    
    OpenBSD-Commit-ID: d745a7e8e50b2589fc56877f322ea204bc784f38

commit 078a0e60c92700da4c536c93c007257828ccd05b
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue May 25 11:40:47 2021 +1000

    Rename README.md to ci-status.md.
    
    The original intent was to provide a status page for the CIs configured
    in that directory, but it had the side effect of replacing the top-level
    README.md.

commit 7be4ac813662f68e89f23c50de058a49aa32f7e4
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed May 19 01:24:05 2021 +0000

    upstream: restore blocking status on stdio fds before close
    
    ssh(1) needs to set file descriptors to non-blocking mode to operate
    but it was not restoring the original state on exit. This could cause
    problems with fds shared with other programs via the shell, e.g.
    
    > $ cat > test.sh << _EOF
    > #!/bin/sh
    > {
    >         ssh -Fnone -oLogLevel=verbose ::1 hostname
    >         cat /usr/share/dict/words
    > } | sleep 10
    > _EOF
    > $ ./test.sh
    > Authenticated to ::1 ([::1]:22).
    > Transferred: sent 2352, received 2928 bytes, in 0.1 seconds
    > Bytes per second: sent 44338.9, received 55197.4
    > cat: stdout: Resource temporarily unavailable
    
    This restores the blocking status for fds 0,1,2 (stdio) before ssh(1)
    abandons/closes them.
    
    This was reported as bz3280 and GHPR246; ok dtucker@
    
    OpenBSD-Commit-ID: 8cc67346f05aa85a598bddf2383fcfcc3aae61ce

commit c4902e1a653c67fea850ec99c7537f358904c0af
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon May 17 11:43:16 2021 +0000

    upstream: fix breakage of -W forwaring introduced in 1.554; reported by
    
    naddy@ and sthen@, ok sthen@
    
    OpenBSD-Commit-ID: f72558e643a26dc4150cff6e5097b5502f6c85fd

commit afea01381ad1fcea1543b133040f75f7542257e6
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon May 17 07:22:45 2021 +0000

    upstream: Regenerate moduli.
    
    OpenBSD-Commit-ID: 83c93a2a07c584c347ac6114d6329b18ce515557

commit be2866d6207b090615ff083c9ef212b603816a56
Author: Damien Miller <djm@mindrot.org>
Date:   Mon May 17 09:40:23 2021 +1000

    Handle Android libc returning NULL pw->pw_passwd
    
    Reported by Luke Dashjr

commit 5953c143008259d87342fb5155bd0b8835ba88e5
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri May 14 05:20:32 2021 +0000

    upstream: fix previous: test saved no_shell_flag, not the one that just
    
    got clobbered
    
    OpenBSD-Commit-ID: b8deace085d9d941b2d02f810243b9c302e5355d

commit 1e9fa55f4dc4b334651d569d3448aaa3841f736f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri May 14 03:09:48 2021 +0000

    upstream: Fix ssh started with ControlPersist incorrectly executing a
    
    shell when the -N (no shell) option was specified. bz3290 reported by Richard
    Schwab; patch from markus@ ok me
    
    OpenBSD-Commit-ID: ea1ea4af16a95687302f7690bdbe36a6aabf87e1

commit d1320c492f655d8f5baef8c93899d79dded217a5
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed May 12 11:34:30 2021 +0000

    upstream: Clarify language about moduli. While both ends of the
    
    connection do need to use the same parameters (ie groups), the DH-GEX
    protocol takes care of that and both ends do not need the same contents in
    the moduli file, which is what the previous text suggested.  ok djm@ jmc@
    
    OpenBSD-Commit-ID: f0c18cc8e79c2fbf537a432a9070ed94e96a622a

commit d3cc4d650ce3e59f3e370b101778b0e8f1c02c4d
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri May 7 04:11:51 2021 +0000

    upstream: include pid in LogVerbose spam
    
    OpenBSD-Commit-ID: aacb86f96ee90c7cb84ec27452374285f89a7f00

commit e3c032333be5fdbbaf2751f6f478e044922b4ec4
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri May 7 03:09:38 2021 +0000

    upstream: don't sigdie() in signal handler in privsep child process;
    
    this can end up causing sandbox violations per bz3286; ok dtucker@
    
    OpenBSD-Commit-ID: a7f40b2141dca4287920da68ede812bff7ccfdda

commit a4039724a3f2abac810735fc95cf9114a3856049
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri May 7 09:23:40 2021 +0000

    upstream: Increase ConnectionAttempts from 4 to 10 as the tests
    
    occasionally time out on heavily loaded hosts.
    
    OpenBSD-Regress-ID: 29a8cdef354fc9da471a301f7f65184770434f3a

commit c0d7e36e979fa3cdb60f5dcb6ac9ad3fd018543b
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri May 7 02:26:55 2021 +0000

    upstream: dump out a usable private key string too; inspired by Tyson
    
    Whitehead
    
    OpenBSD-Regress-ID: 65572d5333801cb2f650ebc778cbdc955e372058

commit 24fee8973abdf1c521cd2c0047d89e86d9c3fc38
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri May 7 02:29:40 2021 +0000

    upstream: correct mistake in spec - the private key blobs are encoded
    
    verbatim and not as strings (i.e. no 4-byte length header)
    
    OpenBSD-Commit-ID: 3606b5d443d72118c5b76c4af6dd87a5d5a4f837

commit f43859159cc62396ad5d080f0b1f2635a67dac02
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue May 4 22:53:52 2021 +0000

    upstream: Don't pass NULL as a string in debugging as it does not work
    
    on some platforms in -portable.  ok djm@
    
    OpenBSD-Commit-ID: 937c892c99aa3c9c272a8ed78fa7c2aba3a44fc9

commit ac31aa3c6341905935e75f0539cf4a61bbe99779
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon May 3 00:16:45 2021 +0000

    upstream: more debugging for UpdateHostKeys signature failures
    
    OpenBSD-Commit-ID: 1ee95f03875e1725df15d5e4bea3e73493d57d36

commit 8e32e97e788e0676ce83018a742203614df6a2b3
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat May 1 20:07:47 2021 +1000

    Add obsd69 test target.

commit f06893063597c5bb9d9e93f851c4070e77d2fba9
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Apr 30 04:29:53 2021 +0000

    upstream: a little debugging in the main mux process for status
    
    confirmation failures in multiplexed sessions
    
    OpenBSD-Commit-ID: 6e27b87c95176107597035424e1439c3232bcb49

commit e65cf00da6bc31e5f54603b7feb7252dc018c033
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Apr 30 04:02:52 2021 +0000

    upstream: Remove now-unused skey function prototypes leftover from
    
    skey removal.
    
    OpenBSD-Commit-ID: 2fc36d519fd37c6f10ce74854c628561555a94c3

commit ae5f9b0d5c8126214244ee6b35aae29c21028133
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Apr 29 13:01:50 2021 +1000

    Wrap sntrup761x25519 inside ifdef.
    
    From balu.gajjala at gmail.com via bz#3306.

commit 70a8dc138a6480f85065cdb239915ad4b7f928cf
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Apr 28 14:44:07 2021 +1000

    Add status badges for Actions-based tests.

commit 40b59024cc3365815381474cdf4fe423102e391b
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Apr 28 12:22:11 2021 +1000

    Add obsdsnap (OpenBSD snapshot) test target.

commit e627067ec8ef9ae8e7a638f4dbac91d52dee3e6d
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Apr 28 11:35:28 2021 +1000

    Add test building upstream OpenBSD source.

commit 1b8108ebd12fc4ed0fb39ef94c5ba122558ac373
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Apr 27 14:22:20 2021 +1000

    Test against OpenSSL 1.1.0h instead of 1.1.0g.
    
    1.1.0g requires a perl glob module that's not installed by default.

commit 9bc20efd39ce8525be33df3ee009f5a4564224f1
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Apr 27 12:37:59 2021 +1000

    Use the default VM type for libcrypto ver tests.

commit 9f79e80dc40965c2e73164531250b83b176c1eea
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Apr 27 12:24:10 2021 +1000

    Always build OpenSSL shared.
    
    This is the default for current versions but we need it to test against
    earlier versions.

commit b3cc9fbdff2782eca79e33e02ac22450dc63bce9
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Apr 27 09:18:02 2021 +1000

    Fix custom OpenSSL tests.
    
    Check out specified OpenSSL version.  Install custom libcrypto where
    configure expects to find it.  Remove unneeded OpenSSL config time
    options.  Older OpenSSL versions were not make -j safe so remove it.

commit 77532609874a99a19e3e2eb2d1b7fa93aef963bb
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Apr 26 17:18:25 2021 +1000

    Export CC and CFLAGS for c89 test.

commit 33f62dfbe865f4de77980ab88774bf1eb5e4e040
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Apr 26 17:13:44 2021 +1000

    Add c89 here too.

commit da9d59f526fce58e11cba49cd8eb011dc0bf5677
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Apr 26 15:34:23 2021 +1000

    Add test against OpenSSL w/out ECC.

commit 29e194a752359ebf85bf7fce100f23a0477fc4de
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Apr 26 14:49:59 2021 +1000

    Ensure we can still build with C89.

commit a38016d369d21df5d35f761f2b67e175e132ba22
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Apr 26 14:29:03 2021 +1000

    Interop test agains PuTTY.

commit 095b0307a77be8803768857cc6c0963fa52ed85b
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Apr 26 14:02:03 2021 +1000

    Support testing against arbitary libcrytpo vers.
    
    Add tests against various LibreSSL and OpenSSL versions.

commit b16082aa110fa7128ece2a9037ff420c4a285317
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Apr 26 13:35:44 2021 +1000

    Add fbsd10 test target.

commit 2c805f16b24ea37cc051c6018fcb05defab6e57a
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sun Apr 25 14:15:02 2021 +1000

    Disable compiler hardening on nbsd4.
    
    The system compiler supports -fstack-protector-all, but using it will
    result in an internal compiler error on some files.

commit 6a5d39305649da5dff1934ee54292ee0cebd579d
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sun Apr 25 13:01:34 2021 +1000

    Add nbsd3, nbsd4 and nbsd9 test targets.

commit d1aed05bd2e4ae70f359a394dc60a2d96b88f78c
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Apr 24 22:03:46 2021 +1000

    Comment out nbsd2 test target for now.

commit a6b4ec94e5bd5a8a18cd2c9942d829d2e5698837
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Apr 24 17:52:24 2021 +1000

    Add OPENBSD ORIGINAL marker.

commit 3737c9f66ee590255546c4b637b6d2be669a11eb
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Apr 23 19:49:46 2021 +1000

    Replace "==" (a bashism) with "=".

commit a116b6f5be17a1dd345b7d54bf8aa3779a28a0df
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Apr 23 16:34:48 2021 +1000

    Add nbsd2 test target.

commit 196bf2a9bb771f45d9b0429cee7d325962233c44
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Apr 23 14:54:10 2021 +1000

    Add obsd68 test target.

commit e3ba6574ed69e8b7af725cf5e8a9edaac04ff077
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Apr 23 14:53:32 2021 +1000

    Remove dependency on bash.

commit db1f9ab8feb838aee9f5b99c6fd3f211355dfdcf
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Apr 23 14:41:13 2021 +1000

    Add obsd67 test target.

commit c039a6bf79192fe1daa9ddcc7c87dd98e258ae7c
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Apr 23 11:08:23 2021 +1000

    Re-add macos-11.0 test target.

commit a6db3a47b56adb76870d59225ffb90a65bc4daf2
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Apr 23 10:28:28 2021 +1000

    Add openindiana test target.

commit 3fe7e73b025c07eda46d78049f1da8ed7dfc0c69
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Apr 23 10:26:35 2021 +1000

    Test krb5 on Solaris 11 too.

commit f57fbfe5eb02df1a91f1a237c4d27165afd87c13
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Apr 22 22:27:26 2021 +1000

    Don't always set SUDO.
    
    Rely on sourcing configs to set as appropriate.

commit e428f29402fb6ac140b52f8f12e06ece7bb104a0
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Apr 22 22:26:08 2021 +1000

    Remove now-unused 2nd arg to configs.

commit cb4ff640d79b3c736879582139778f016bbb2cd7
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Apr 21 01:08:04 2021 +1000

    Add win10 test target.

commit 4457837238072836b2fa3107d603aac809624983
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Apr 20 23:31:29 2021 +1000

    Add nbsd8 test target.

commit bd4fba22e14da2fa196009010aabec5a8ba9dd42
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Apr 17 09:55:47 2021 +1000

    Add obsd51 target.

commit 9403d0e805c77a5741ea8c3281bbe92558c2f125
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Apr 16 18:14:25 2021 +1000

    Add fbsd13 target.

commit e86968280e358e62649d268d41f698d64d0dc9fa
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Apr 16 13:55:25 2021 +1000

    depend

commit 2fb25ca11e8b281363a2a2a4dec4c497a1475d9a
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Apr 16 13:53:02 2021 +1000

    crank version in README and RPM spec files

commit b2b60ebab0cb77b5bc02d364d72e13db882f33ae
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Apr 16 03:42:00 2021 +0000

    upstream: openssh-8.6
    
    OpenBSD-Commit-ID: b5f3e133c846127ec114812248bc17eff07c3e19

commit faf2b86a46c9281d237bcdec18c99e94a4eb820a
Author: markus@openbsd.org <markus@openbsd.org>
Date:   Thu Apr 15 16:24:31 2021 +0000

    upstream: do not pass file/func to monitor; noted by Ilja van Sprundel;
    
    ok djm@
    
    OpenBSD-Commit-ID: 85ae5c063845c410283cbdce685515dcd19479fa

commit 2dc328023f60212cd29504fc05d849133ae47355
Author: Damien Miller <djm@mindrot.org>
Date:   Wed Apr 14 11:42:55 2021 +1000

    sshd don't exit on transient read errors
    
    openssh-8.5 introduced a regression that would cause sshd to exit
    because of transient read errors on the network socket (e.g. EINTR,
    EAGAIN). Reported by balu.gajjala AT gmail.com via bz3297

commit d5d6b7d76d171a2e6861609dcd92e714ee62ad88
Author: Damien Miller <djm@mindrot.org>
Date:   Sat Apr 10 18:45:00 2021 +1000

    perform report_failed_grab() inline

commit ea996ce2d023aa3c6d31125e2c3ebda1cb42db8c
Author: Damien Miller <djm@mindrot.org>
Date:   Sat Apr 10 18:22:57 2021 +1000

    dedicated gnome-ssk-askpass3 source
    
    Compatibility with Wayland requires that we use the gdk_seat_grab()
    API for grabbing mouse/keyboard, however these API don't exist in
    Gtk+2.
    
    This branches gnome-ssk-askpass2.c => gnome-ssk-askpass3.c and
    makes the changes to use the gdk_seat_grab() instead of grabbing
    mouse/focus separately via GDK.
    
    In the future, we can also use the branched file to avoid some
    API that has been soft-deprecated in GTK+3, e.g. gtk_widget_modify_fg

commit bfa5405da05d906ffd58216eb77c4375b62d64c2
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Apr 8 15:18:15 2021 +1000

    Ensure valgrind-out exists.
    
    Normally the regress tests would create it, but running the unit tests
    on their own would fail because the directory did not exist.

commit 1f189181f3ea09a9b08aa866f78843fec800874f
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Apr 8 15:17:19 2021 +1000

    Pass OBJ to unit test make invocation.
    
    At least the Valgrind unit tests uses $OBJ.

commit f42b550c281d28bd19e9dd6ce65069164f3482b0
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Apr 8 14:20:12 2021 +1000

    Add pattern for valgrind-unit.

commit 19e534462710e98737478fd9c44768b50c27c4c6
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Apr 8 13:31:08 2021 +1000

    Run unit tests under valgrind.
    
    Run a separate build for the unit tests under Valgrind.  They take long
    enough that running in parallel with the other Valgrind tests helps.

commit 80032102d05e866dc2a48a5caf760cf42c2e090e
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Apr 8 13:25:57 2021 +1000

    ifdef out MIN and MAX.
    
    In -portable, defines.h ensures that these are defined, so redefining
    potentially causes a warning.  We don't just delete it to make any
    future code syncs a little but easier.  bz#3293.

commit d1bd184046bc310c405f45da3614a1dc5b3e521a
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Apr 7 10:23:51 2021 +1000

    Remove only use of warn().
    
    The warn() function is only used in one place in portable and does not
    exist upstream.  Upgrade the only instance it's used to fail()
    (the privsep/sandbox+proxyconnect, from back when that was new) and
    remove the now-unused function.

commit fea8f4b1aa85026ad5aee5ad8e1599a8d5141fe0
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Apr 7 10:18:32 2021 +1000

    Move make_tmpdir() into portable-specific area.
    
    Reduces diff vs OpenBSD and makes it more likely diffs will apply
    cleanly.

commit 13e5fa2acffd26e754c6ee1d070d0afd035d4cb7
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Apr 6 23:57:56 2021 +0000

    upstream: Add TEST_SSH_ELAPSED_TIMES environment variable to print the
    
    elapsed time in seconds of each test.  This depends on "date +%s" which is
    not specified by POSIX but is commonly implemented.
    
    OpenBSD-Regress-ID: ec3c8c19ff49b2192116a0a646ee7c9b944e8a9c

commit ef4f46ab4387bb863b471bad124d46e8d911a79a
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Apr 7 09:59:15 2021 +1000

    Move the TEST_SSH_PORT section down a bit.
    
    This groups the portable-specific changes together and makes it a
    little more likely that patches will apply cleanly.

commit 3674e33fa70dfa1fe69b345bf576113af7b7be11
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Apr 7 10:05:10 2021 +1000

    Further split Valgrind tests.
    
    Even split in two, the Valgrind tests take by far the longest to run,
    so split them four ways to further increase parallelism.

commit 961af266b861e30fce1e26170ee0dbb5bf591f29
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Apr 6 23:24:30 2021 +0000

    upstream: include "ssherr.h" not <ssherr.h>; from Balu Gajjala via
    
    bz#3292
    
    OpenBSD-Commit-ID: e9535cd9966eb2e69e73d1ede1f44905c30310bd

commit e7d0a285dbdd65d8df16123ad90f15e91862f959
Author: Damien Miller <djm@mindrot.org>
Date:   Wed Apr 7 08:50:38 2021 +1000

    wrap struct rlimit in HAVE_GETRLIMIT too

commit f283a6c2e0a9bd9369e18462acd00be56fbe5b0d
Author: Damien Miller <djm@mindrot.org>
Date:   Wed Apr 7 08:20:35 2021 +1000

    wrap getrlimit call in HAVE_GETRLIMIT; bz3291

commit 679bdc4a5c9244f427a7aee9c14b0a0ed086da1f
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Apr 6 09:07:33 2021 +0000

    upstream: Don't check return value of unsetenv(). It's part of the
    
    environment setup and not part of the actual test, and some platforms
    -portable runs on declare it as returning void, which prevents the test from
    compiling.
    
    OpenBSD-Regress-ID: 24f08543ee3cdebc404f2951f3e388cc82b844a1

commit 320af2f3de6333aa123f1b088eca146a245e968a
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Sun Apr 4 11:36:56 2021 +0000

    upstream: remove stray inserts; from matthias schmidt
    
    OpenBSD-Commit-ID: 2c36ebdc54e14bbf1daad70c6a05479a073d5c63

commit 801f710953b24dd2f21939171c622eac77c7484d
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Sun Apr 4 06:11:24 2021 +0000

    upstream: missing comma; from kawashima james
    
    OpenBSD-Commit-ID: 31cec6bf26c6db4ffefc8a070715ebef274e68ea

commit b3ca08cb174266884d44ec710a84cd64c12414ea
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Apr 5 23:46:42 2021 +1000

    Install libcbor with libfido2.

commit f3ca8af87a4c32ada660da12ae95cf03d190c083
Author: Damien Miller <djm@mindrot.org>
Date:   Sat Apr 3 18:21:08 2021 +1100

    enable authopt and misc unit tests
    
    Neither were wired into the build, both required some build
    adaptations for -portable

commit dc1b45841fb97e3d7f655ddbcfef3839735cae5f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Apr 3 06:58:30 2021 +0000

    upstream: typos in comments; GHPR#180 from Vill
    
    =?UTF-8?q?e=20Skytt=C3=A4?=
    MIME-Version: 1.0
    Content-Type: text/plain; charset=UTF-8
    Content-Transfer-Encoding: 8bit
    
    OpenBSD-Commit-ID: 93c732381ae0e2b680c79e67c40c1814b7ceed2c

commit 53ea05e09b04fd7b6dea66b42b34d65fe61b9636
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Apr 3 06:55:52 2021 +0000

    upstream: sync CASignatureAlgorithms lists with reality. GHPR#174 from
    
    Matt Hazinski
    
    OpenBSD-Commit-ID: f05e4ca54d7e67b90fe58fe1bdb1d2a37e0e2696

commit 57ed647ee07bb883a2f2264231bcd1df6a5b9392
Author: Damien Miller <djm@mindrot.org>
Date:   Sat Apr 3 17:47:37 2021 +1100

    polish whitespace for portable files

commit 31d8d231eb9377df474746a822d380c5d68d7ad6
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Apr 3 06:18:40 2021 +0000

    upstream: highly polished whitespace, mostly fixing spaces-for-tab
    
    and bad indentation on continuation lines. Prompted by GHPR#185
    
    OpenBSD-Commit-ID: e5c81f0cbdcc6144df1ce468ec1bac366d8ad6e9

commit 34afde5c73b5570d6f8cce9b49993b23b77bfb86
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Apr 3 05:54:14 2021 +0000

    upstream: whitespace (tab after space)
    
    OpenBSD-Commit-ID: 0e2b3f7674e985d3f7c27ff5028e690ba1c2efd4

commit 7cd262c1c5a08cc7f4f30e3cab108ef089d0a57b
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Apr 3 16:59:10 2021 +1100

    Save config.h and config.log on failure too.

commit 460aee9298f365357e9fd26851c22e0dca51fd6a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Apr 3 05:46:41 2021 +0000

    upstream: fix incorrect plural; from Ville Skyt
    
    =?UTF-8?q?t=C3=A4=20via=20GHPR#181?=
    MIME-Version: 1.0
    Content-Type: text/plain; charset=UTF-8
    Content-Transfer-Encoding: 8bit
    
    OpenBSD-Commit-ID: 92f31754c6296d8f403d7c293e09dc27292d22c9

commit 082804c14e548cada75c81003a3c68ee098138ee
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Apr 3 05:40:39 2021 +0000

    upstream: ensure that pkcs11_del_provider() is called before exit -
    
    some PKCS#11 providers get upset if C_Initialize is not matched with
    C_Finalize.
    
    From Adithya Baglody via GHPR#234; ok markus
    
    OpenBSD-Commit-ID: f8e770e03b416ee9a58f9762e162add900f832b6

commit 464ebc82aa926dd132ec75a0b064574ef375675e
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Apr 3 05:28:43 2021 +0000

    upstream: unused variable
    
    OpenBSD-Commit-ID: 85f6a394c8e0f60d15ecddda75176f112007b205

commit dc3c0be8208c488e64a8bcb7d9efad98514e0ffb
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Apr 3 05:21:46 2021 +0000

    upstream: Fix two problems in string->argv conversion: 1) multiple
    
    backslashes were not being dequoted correctly and 2) quoted space in the
    middle of a string was being incorrectly split.
    MIME-Version: 1.0
    Content-Type: text/plain; charset=UTF-8
    Content-Transfer-Encoding: 8bit
    
    A unit test for these cases has already been committed
    
    prompted by and based on GHPR#223 by Eero Häkkinen; ok markus@
    
    OpenBSD-Commit-ID: d7ef27abb4eeeaf6e167e9312e4abe9e89faf1e4

commit f75bcbba58a08c670727ece5e3f8812125969799
Author: Damien Miller <djm@mindrot.org>
Date:   Sat Apr 3 16:22:48 2021 +1100

    missing bits from 259d648e

commit 4cbc4a722873d9b68cb5496304dc050d7168df78
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Mar 31 21:59:26 2021 +0000

    upstream: cannot effectively test posix-rename extension after
    
    changes in feature advertisment.
    
    OpenBSD-Regress-ID: 5e390bf88d379162aaa81b60ed86b34cb0c54d29

commit 259d648e63e82ade4fe2c2c73c8b67fe57d9d049
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Mar 19 04:23:50 2021 +0000

    upstream: add a test for misc.c:argv_split(), currently fails
    
    OpenBSD-Regress-ID: ad6b96d6ebeb9643b698b3575bdd6f78bb144200

commit 473ddfc2d6b602cb2d1d897e0e5c204de145cd9a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Mar 19 03:25:01 2021 +0000

    upstream: split
    
    OpenBSD-Regress-ID: f6c03c0e4c58b3b9e04b161757b8c10dc8378c34

commit 1339800fef8d0dfbfeabff71b34670105bcfddd2
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Mar 31 22:16:34 2021 +0000

    upstream: Use new limits@openssh.com protocol extension to let the
    
    client select good limits based on what the server supports. Split the
    download and upload buffer sizes to allow them to be chosen independently.
    
    In practice (and assuming upgraded sftp/sftp-server at each end), this
    increases the download buffer 32->64KiB and the upload buffer
    32->255KiB.
    
    Patches from Mike Frysinger; ok dtucker@
    
    OpenBSD-Commit-ID: ebd61c80d85b951b794164acc4b2f2fd8e88606c

commit 6653c61202d104e59c8e741329fcc567f7bc36b8
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Mar 31 21:58:07 2021 +0000

    upstream: do not advertise protocol extensions that have been
    
    disallowed by the command-line options (e.g. -p/-P/-R); ok dtucker@
    
    OpenBSD-Commit-ID: 3a8a76b3f5131741aca4b41bfab8d101c9926205

commit 71241fc05db4bbb11bb29340b44b92e2575373d8
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Mar 29 15:14:25 2021 +1100

    gnome-ssh-askpass3 is a valid target here

commit 8a9520836e71830f4fccca066dba73fea3d16bda
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Mar 19 02:22:34 2021 +0000

    upstream: return non-zero exit status when killed by signal; bz#3281 ok
    
    dtucker@
    
    OpenBSD-Commit-ID: 117b31cf3c807993077b596bd730c24da9e9b816

commit 1269b8a686bf1254b03cd38af78167a04aa6ec88
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Mar 19 02:18:28 2021 +0000

    upstream: increase maximum SSH2_FXP_READ to match the maximum
    
    packet size. Also handle zero-length reads that are borderline nonsensical
    but not explicitly banned by the spec. Based on patch from Mike Frysinger,
    feedback deraadt@ ok dtucker@
    
    OpenBSD-Commit-ID: 4e67d60d81bde7b84a742b4ee5a34001bdf80d9c

commit 860b67604416640e8db14f365adc3f840aebcb1f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Mar 16 06:15:43 2021 +0000

    upstream: don't let logging clobber errno before use
    
    OpenBSD-Commit-ID: ce6cca370005c270c277c51c111bb6911e1680ec

commit 5ca8a9216559349c56e09039c4335636fd85c241
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Mar 13 14:40:43 2021 +1100

    Only call dh_set_moduli_file if using OpenSSL.
    
    Fixes link failure when configuring --without-openssl since dh.c is not
    linked in.

commit 867a7dcf003c51d5a83f83565771a35f0d9530ac
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Mar 13 13:52:53 2021 +1100

    Don't install moduli during tests.
    
    Now that we have TEST_SSH_MODULI_FILE pointing to the moduli in the
    soure directory we don't need to install the file to prevent warnings
    about it being missing.

commit 0c054538fccf92b4a028008321d3711107bee6d5
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Mar 13 13:51:26 2021 +1100

    Point TEST_SSH_MODULI_FILE at our own moduli.
    
    This will allow the test to run without requiring a moduli file
    installed at the configured default path.

commit 4d48219c72ab0c71238806f057f0e9630b7dd25c
Author: jsg@openbsd.org <jsg@openbsd.org>
Date:   Fri Mar 12 05:18:01 2021 +0000

    upstream: spelling
    
    OpenBSD-Commit-ID: 478bc3db04f62f1048ed6e1765400f3ab325e60f

commit 88057eb6df912abf2678ea5c846d9d9cbc92752c
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Mar 12 04:08:19 2021 +0000

    upstream: Add ModuliFile keyword to sshd_config to specify the
    
    location of the "moduli" file containing the groups for DH-GEX.  This will
    allow us to run tests against arbitrary moduli files without having to
    install them. ok djm@
    
    OpenBSD-Commit-ID: 8df99d60b14ecaaa28f3469d01fc7f56bff49f66

commit f07519a2af96109325b5a48b1af18b57601074ca
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Mar 12 03:43:40 2021 +0000

    upstream: pwcopy() struct passwd that we're going to reuse across a
    
    bunch of library calls; bz3273 ok dtucker@
    
    OpenBSD-Commit-ID: b6eafa977b2e44607b1b121f5de855107809b762

commit 69d6d4b0c8a88d3d1288415605f36e2df61a2f12
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Mar 10 06:32:27 2021 +0000

    upstream: Import regenerated moduli file.
    
    OpenBSD-Commit-ID: 7ac6c252d2a5be8fbad4c66d9d35db507c9dac5b

commit e5895e8ecfac65086ea6b34d0d168409a66a15e1
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Mar 10 04:58:45 2021 +0000

    upstream: no need to reset buffer after send_msg() as that is done
    
    for us; patch from Mike Frysinger
    
    OpenBSD-Commit-ID: 565516495ff8362a38231e0f1a087b8ae66da59c

commit 721948e67488767df0fa0db71ff2578ee2bb9210
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sat Mar 13 01:52:16 2021 +0000

    upstream: Add TEST_SSH_MODULI_FILE variable to allow overriding of the
    
    moduli file used during the test run.
    
    OpenBSD-Regress-ID: be10f785263120edb64fc87db0e0d6570a10220a

commit 82fef71e20ffef425b932bec26f5bc46aa1ed41c
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Mar 12 15:58:57 2021 +1100

    Allow (but return EACCES) fstatat64 in sandbox.
    
    This is apparently used in some configurations of OpenSSL when glibc
    has getrandom().  bz#3276, patch from Kris Karas, ok djm@

commit 1cd67ee15ce3d192ab51be22bc4872a6a7a4b6d9
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Mar 12 13:16:10 2021 +1100

    Move generic includes outside of ifdef.
    
    This ensures that the macros in log.h are defined in the case where
    either of --with-solaris-projects or --with-solaris-privs are used
    without --with-solaris-contracts.  bz#3278.

commit 2421a567a8862fe5102a4e7d60003ebffd1313dd
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Mar 10 17:41:21 2021 +1100

    Import regenerated moduli file.

commit e99080c05d9d48dbbdb022538533d53ae1bd567d
Author: millert@openbsd.org <millert@openbsd.org>
Date:   Sat Mar 6 20:36:31 2021 +0000

    upstream: Fix PRINT macro, the suffix param to sshlog() was missing.
    
    Also remove redundant __func__ prefix from PRINT calls as the macro already
    adds __FILE__, __func__ and __LINE__.  From Christos Zoulas. OK dtucker@
    
    OpenBSD-Commit-ID: 01fdfa9c5541151b5461d9d7d6ca186a3413d949

commit 160db17fc678ceb5e3fd4a7e006cc73866f484aa
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Mar 3 22:41:49 2021 +0000

    upstream: don't sshbuf_get_u32() into an enum; reported by goetze
    
    AT dovetail.com via bz3269
    
    OpenBSD-Commit-ID: 99a30a8f1df9bd72be54e21eee5c56a0f050921a

commit cffd033817a5aa388764b6661855dcdaabab0588
Author: sthen@openbsd.org <sthen@openbsd.org>
Date:   Wed Mar 3 21:40:16 2021 +0000

    upstream: typo in other_hostkeys_message() display output, ok djm
    
    OpenBSD-Commit-ID: 276f58afc97b6f5826e0be58380b737603dbf5f5

commit 7fe141b96b13bd7dc67ca985e14d55b9bd8a03fd
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Mar 3 08:42:52 2021 +0000

    upstream: needs FILE*; from Mike Frysinger
    
    OpenBSD-Commit-ID: dddb3aa9cb5792eeeaa37a1af67b5a3f25ded41d

commit d2afd717e62d76bb41ab5f3ab4ce6f885c8edc98
Author: Damien Miller <djm@mindrot.org>
Date:   Tue Mar 2 21:31:47 2021 +1100

    update depend

commit f0c4eddf7cf224ebcac1f07ac8afdb30c6e9fe0a
Author: Damien Miller <djm@mindrot.org>
Date:   Tue Mar 2 21:30:14 2021 +1100

    update relnotes URL

commit 67a8bb7fe62a381634db4c261720092e7d514a3d
Author: Damien Miller <djm@mindrot.org>
Date:   Tue Mar 2 21:29:54 2021 +1100

    update RPM spec version numbers

commit 0a4b23b11b9a4e6eec332dd5c6ab2ac6f62aa164
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Mar 2 01:48:18 2021 +0000

    upstream: openssh-8.5
    
    OpenBSD-Commit-ID: 185e85d60fe042b8f8fa1ef29d4ef637bdf397d6

commit de3866383b6720ad4cad83be76fe4c8aa111a249
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Mar 1 21:13:24 2021 +1100

    Only upload config logs if configure fails.

commit 85ff2a564ce838f8690050081176c1de1fb33116
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sun Feb 28 22:56:30 2021 +0000

    upstream: Add %k to list of keywords. From
    
    =?UTF-8?q?=20Eero=20H=C3=A4kkinenvia=20bz#3267?=
    MIME-Version: 1.0
    Content-Type: text/plain; charset=UTF-8
    Content-Transfer-Encoding: 8bit
    
    OpenBSD-Commit-ID: 9c87f39a048cee2a7d1c8bab951b2f716256865e

commit e774bac35933e71f924f4301786e7fb5bbe1422f
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sun Feb 28 01:50:47 2021 +0000

    upstream: Do not try to reset signal handler for signal 0 in
    
    subprocess. Prevents spurious debug message.  ok djm@
    
    OpenBSD-Commit-ID: 7f9785e292dcf304457566ad4637effd27ad1d46

commit 351c5dbbd74ce300c4f058112f9731c867c6e225
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Feb 27 23:42:37 2021 +0000

    upstream: fix alphabetic ordering of options; spotted by Iain Morgan
    
    OpenBSD-Commit-ID: f955fec617d74af0feb5b275831a9fee813d7ad5

commit 0d1c9dbe578597f8d45d3ac7690df10d32d743e5
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Feb 27 12:25:25 2021 +1100

    zlib is now optional.

commit b7c6ee7b437d9adfd19ef49d6c0f19f13f26f9b3
Author: Jeffrey H. Johnson <61629094+johnsonjh@users.noreply.github.com>
Date:   Sat Feb 27 01:04:58 2021 +0000

    Fix punctuatio and typo in README.md.
    
    Some very minor fixes, missing 's' and punctuation.

commit 6248b86074804983e8f7a2058856a516dbfe2924
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Feb 26 16:45:50 2021 +1100

    Revert "ssh: optional bind interface if bind address specified."
    
    This reverts commit 5a878a71a3528c2626aa1d331934fd964782d41c.
    
    Apologies - I accidentally pushed this.

commit 493339a940b13be6071629c3c2dd5a3b6fc17023
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Feb 26 15:45:38 2021 +1100

    detech BSD libc hash functions in libbsd / libmd
    
    Some Linux distributions are shipping the BSD-style hashing functions
    (e.g. SHA256Update) in libbsd and/or libmd. Detect this situation to
    avoid header/replacement clashes later. ok dtucker@

commit 5a878a71a3528c2626aa1d331934fd964782d41c
Author: Dmitrii Turlupov <dturlupov@factor-ts.ru>
Date:   Thu Feb 4 16:27:31 2021 +0300

    ssh: optional bind interface if bind address specified.
    
    Allows the -b and -B options to be used together.
    For example, when the interface is in the VRF.

commit 1fe4d70df94d3bcc2b35fd57cad6b5fc4b2d7b16
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Feb 26 04:18:42 2021 +0000

    upstream: remove this KEX fuzzer; it's awkward to use and doesn't play
    
    nice with popular fuzzing drivers like libfuzzer. AFAIK nobody has used it
    but me.
    
    OpenBSD-Regress-ID: cad919522b3ce90c147c95abaf81b0492ac296c9

commit 24a3a67bd7421740d08803b84bd784e764107928
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Feb 26 11:49:19 2021 +1100

    Remove macos-11.00 PAM test target too.
    
    These are failing apparently due to some kind of infrastructure problem,
    making it look like every commit is busted.

commit 473201783f732ca8b0ec528b56aa55fa0d8cf717
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Feb 26 00:16:58 2021 +0000

    upstream: a bit more debugging behind #ifdef DEBUG_SK
    
    OpenBSD-Commit-ID: d9fbce14945721061cb322f0084c2165d33d1993

commit fd9fa76a344118fe1ef10b9a6c9e85d39599e9a8
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Feb 26 01:15:10 2021 +1100

    Remove macos-11.0 from the test target list.
    
    It has been consistently failing for the past few days with a github
    actions internal error.

commit 476ac8e9d33dbf96ef97aab812b8d7089d0cdc24
Author: Philip Hands <phil@hands.com>
Date:   Wed Feb 24 23:43:16 2021 +0100

    tidy the $INSTALLKEY_SH code layout a little
    
    SSH-Copy-ID-Upstream: 78178aa5017222773e4c23d9001391eeaeca8983

commit 983e05ef3b81329d76d6a802b39ad0d1f637c06c
Author: Jakub Jelen <jjelen@redhat.com>
Date:   Tue Sep 29 10:02:45 2020 +0000

    if unable to add a missing newline, fail
    
    SSH-Copy-ID-Upstream: 76b25e18f55499ea9edb4c4d6dc4a80bebc36d95

commit 3594b3b015f6014591da88ba71bf6ff010be7411
Author: Philip Hands <phil@hands.com>
Date:   Tue Oct 13 14:12:58 2020 +0200

    use $AUTH_KEY_DIR, now that we have it
    
    since that was a change made since jjelen's commit was written
    
    also, quote the variables
    
    SSH-Copy-ID-Upstream: 588cd8e5cbf95f3443d92b9ab27c5d73ceaf6616

commit 333e25f7bc43cee6e36f766e39dad6f9918b318c
Author: Jakub Jelen <jjelen@redhat.com>
Date:   Tue Sep 29 10:00:01 2020 +0000

    restorecon the correct directory
    
    if using different path for authorized_keys file
    
    SSH-Copy-ID-Upstream: 791a3df47b48412c726bff6f7b1d190721e65d51

commit 9beeab8a37a49a9e3ffb1972fff6621ee5bd7a71
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Feb 25 03:27:34 2021 +0000

    upstream: s/PubkeyAcceptedKeyTypes/PubkeyAcceptedAlgorithms/
    
    OpenBSD-Regress-ID: 3dbc005fa29f69dc23d97e433b6dffed6fe7cb69

commit 2dd9870c16ddbd83740adeead5030d6840288c8f
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Feb 24 23:12:35 2021 +0000

    upstream: Rename pubkeyacceptedkeytypes to pubkeyacceptedalgorithms in
    
    test to match change to config-dump output.
    
    OpenBSD-Regress-ID: 74c9a4ad50306be873d032819d5e55c24eb74d5d

commit b9225c3a1c3f5827e31d5d64a71b8e0504a25619
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Feb 24 01:18:08 2021 +0000

    upstream: Put obsolete aliases for hostbasedalgorithms and
    
    pubkeyacceptedalgorithms after their current names so that the config-dump
    mode finds and uses the current names.  Spotted by Phil Pennock.
    
    OpenBSD-Commit-ID: 5dd10e93cccfaff3aaaa09060c917adff04a9b15

commit 8b8b60542d6652b2c91e0ef9e9cc81bcb65e6b42
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Feb 23 21:55:08 2021 +0000

    upstream: lots more s/key types/signature algorithms/ mostly in
    
    HostbasedAcceptedAlgorithms and HostKeyAlgorithms; prompted by Jakub Jelen
    
    OpenBSD-Commit-ID: 3f719de4385b1a89e4323b2549c66aae050129cb

commit 0aeb508aaabc4818970c90831e3d21843c3c6d09
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Feb 23 21:50:18 2021 +0000

    upstream: Correct reference to signature algorithms as keys; from
    
    Jakub Jelen
    
    OpenBSD-Commit-ID: 36f7ecee86fc811aa0f8e21e7a872eee044b4be5

commit f186a020f2ba5f9c462a23293750e29ba0a746b1
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Feb 23 16:05:22 2021 +1100

    Add a couple more test VMs.

commit ffcdd3d90e74176b3bb22937ad1f65a6c1cd3f9d
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Feb 22 08:09:27 2021 +1100

    Valgrind test: split and move up list.
    
    Since the valgrind test takes so long it approaches the limit allowed by
    github, move it to the head of the list so it's the first one started and
    split the longest tests out into a second instance that runs concurrently
    with the first.

commit c3b1636770785cc2830dedd0f22ef7d3d3491d6d
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Feb 23 00:05:31 2021 +0000

    upstream: warn when the user specifies a ForwardAgent path that does
    
    not exist and exit if ExitOnForwardFailure is set; bz3264
    
    OpenBSD-Commit-ID: 72f7875865e723e464c71bf8692e83110699bf26

commit 5fcb0514949d61aadaf4a89cf16eb78fb47491ec
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Feb 20 13:34:02 2021 +1100

    Disable rlimit sandbox, doesn't work with valgrind
    
    Only run regress tests, runing unit tests as well makes it run longer
    than allowed y github.

commit bb0b9bf45396c19486080d3eb0a159f94de7e6ba
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Feb 20 13:06:25 2021 +1100

    Upload valgrind logs on failure.

commit ebb3b75e974cb241c6b9b9f5881b09c7bd32b651
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Feb 19 22:18:50 2021 +1100

    Rename "vm" to "os" in selfhosted to match c-cpp.
    
    Should make it easier to share code or maybe merge at some point.

commit 76c0be0fe0465cb2b975dbd409f8d38b55e55bcb
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Feb 19 22:15:22 2021 +1100

    Upload regress failure logs in c-cpp too.

commit 8751b6c3136f5225c40f41bbf29aa29e15795f6e
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Feb 19 22:13:36 2021 +1100

    Comment out Solaris 64bit PAM build...
    
    until I can figure out why it's failing.

commit e9f6d563c06886b277c6b9abafa99fa80726dc48
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Feb 19 10:20:17 2021 +1100

    Actually run Valgrind tests.

commit 41d232e226624f1a81c17091c36b44c9010aae62
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Feb 19 10:16:56 2021 +1100

    Add test against Valgrind.

commit e6528d91f12fba05f0ea64224091c9d0f38bdf1d
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Feb 18 16:30:01 2021 +1100

    Add fbsd12 test target.

commit 6506cb2798d98ff03a7cc06567c392a81f540680
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Feb 18 15:21:13 2021 +1100

    Remove unused arg.

commit 93c31a623973b0fad508214593aab6ca94b11dcb
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Feb 18 14:54:07 2021 +1100

    Add DEBUG_SK to kitchensink builds.

commit 65085740d3574eeb3289d592f042df62c2689bb0
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Feb 18 14:53:14 2021 +1100

    Add bbone test target (arm32).

commit 63238f5aed66148b8d6ca7bd5fb347d624200155
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Feb 18 02:49:35 2021 +0000

    upstream: Fix the hostkeys rotation extension documentation
    
    The documentation was lacking the needed want-reply field in the initial
    global request.
    
    https://github.com/openssh/openssh-portable/pull/218 by dbussink
    
    OpenBSD-Commit-ID: 051824fd78edf6d647a0b9ac011bf88e28775054

commit 34c5ef6e2d06d9f0e20cb04a9aebf67a6f96609a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Feb 18 02:15:07 2021 +0000

    upstream: make names in function prototypes match those in
    
    definition from https://github.com/openssh/openssh-portable/pull/225 by
    ZenithalHourlyRate
    
    OpenBSD-Commit-ID: 7c736307bf3f2c7cb24d6f82f244eee959485acd

commit 88e3d4de31ab4f14cac658e9e0c512043b15b146
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Feb 18 02:13:58 2021 +0000

    upstream: unbreak SK_DEBUG builds
    
    from https://github.com/openssh/openssh-portable/pull/225 by
    ZenithalHourlyRate
    
    OpenBSD-Commit-ID: 28d7259ce1b04d025411464decfa2f1a097b43eb

commit 788cbc5b74a53956ba9fff11e1ca506271a3597f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Feb 18 00:30:17 2021 +0000

    upstream: sftp-server: implement limits@openssh.com extension
    
    This is a simple extension that allows the server to clearly
    communicate transfer limits it is imposing so the client doesn't
    have to guess, or force the user to manually tune.  This is
    particularly useful when an attempt to use too large of a value
    causes the server to abort the connection.
    
    Patch from Mike Frysinger; ok dtucker@
    
    OpenBSD-Commit-ID: f96293221e5aa24102d9bf30e4f4ef04d5f4fb51

commit 324449a68d510720d0e4dfcc8e9e5a702fe6a48f
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Feb 18 12:06:25 2021 +1100

    support OpenSSL 3.x cipher IV API change
    
    OpenSSL renamed the "get current CIPHER_CTX" IV operation in 3.x.
    This uses the new name if available.
    
    https://github.com/openssl/openssl/issues/13411
    
    bz#3238 ok dtucker@

commit 845fe9811c047063d935eca89188ed55c993626b
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Feb 18 11:25:38 2021 +1100

    prefer login_getpwclass() to login_getclass()
    
    FreeBSD has login_getpwclass() that does some special magic for
    UID=0. Prefer this to login_getclass() as its easier to emulate
    the former with the latter.
    
    Based on FreeBSD PR 37416 via Ed Maste; ok dtucker@

commit d0763c8d566119cce84d9806e419badf20444b02
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Feb 18 10:45:27 2021 +1100

    Fixing quoting for installing moduli on target guest.

commit b3afc243bc820f323a09e3218e9ec8a30a3c1933
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Feb 18 10:27:16 2021 +1100

    Install moduli on target not host.

commit f060c2bc85d59d111fa18a12eb3872ee4b9f7e97
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Feb 18 10:33:58 2021 +1100

    don't free string returned by login_getcapstr(3)
    
    OpenBSD and NetBSD require the caller to free strings returned
    bu the login_* functions, but FreeBSD requires that callers don't.
    
    Fortunately in this case, we can harmlessly leak as the process is
    about to exec the shell/command.
    
    From https://reviews.freebsd.org/D28617 via Ed Maste; ok dtucker@

commit bc9b0c25703215501da28aa7a6539f96c0fa656f
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Feb 18 10:10:00 2021 +1100

    Skip unit tests on sol11 to speed things up.

commit 161873035c12cc22211fc73d07170ade47746bc5
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Feb 18 10:09:27 2021 +1100

    Remove SKIP_UNIT as it needs to be a make arg.

commit 1c293868e4b4e8e74e3ea15b8dff90f6b089967a
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Feb 18 10:05:03 2021 +1100

    Always intall moduli.
    
    Allows us to run tests without falling back to a fixed modulus.  Ensure that
    the directory exists.

commit 5c8f41ad100601ec2fdcbccdfe92890c31f81bbe
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Feb 18 09:59:09 2021 +1100

    Quote SSHD_CONFOPTS in case it contains spaces.

commit 4653116c1f5384ea7006e6396d9b53c33d218975
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Feb 18 09:51:18 2021 +1100

    Fix labels on targets (dots vs underscores).

commit 4512047f57ca3c6e8cd68f0cc69be59e98b25287
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Feb 17 21:47:48 2021 +1100

    More compact representation of config matrix.

commit 0406cd09f05c2e419b113dd4c0eac8bc34ec915b
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Feb 17 21:19:18 2021 +1100

    Skip unit tests on hosted VMs to speed things up.

commit 4582612e6147d766c336198c498740242fb8f1ec
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Feb 17 20:21:29 2021 +1100

    Merge macos and ubuntu tests.

commit 09f4b84654b71099559492e9aed5e1a38bf24815
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Feb 17 18:41:30 2021 +1100

    Convert most github hosted tests to new config structure.

commit 65380ff7e054be1454e5ab4fd7bb9c66f8fcbaa9
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Feb 17 18:27:36 2021 +1100

    Only run selfhosted tests from selfhosted repo.

commit f031366535650b88248ed7dbf23033afdf466240
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Jan 15 14:11:43 2021 +1100

    Add self-hosted runners for VMs of other platforms.
    
    Github only hosts a limited number of platforms, and the runner code
    is only supported on slightly wider range of platforms.  To increase
    our test coverage beyond that, we run the runner natively on a VM host,
    where it runs a jobs that boot VMs of other platforms, waits for them
    to come up then runs the build and test by ssh'ing into the guest.
    This means that the minimum dependencies for the guests are quite low
    (basically just sshd, a compiler and make).
    
    The interface to the VM host is fairly simple (basically 3 scripts:
    vmstartup, vmrun and vmshutdown), but those are specific to the VM host
    so are not in the public repo.  We also mount the working directory on the
    host via sshfs, so things like artifact upload by the runner also work.
    
    As part of this we are moving the per-test-target configs into a single
    place (.github/configs) where there will be referenced by a single short
    "config" key.  I plan to make the github-hosted runners use this too.
    
    The self-hosted runners are run off a private repo on github since that
    prevents third parties from accessing them[0], and since runner quota is
    limited on private repos, we avoid running the tests we run on the public
    repo.
    
    [0] https://docs.github.com/en/actions/hosting-your-own-runners/about-self-hosted-runners#self-hosted-runner-security-with-public-repositories

commit 64bbd7444d658ef7ee14a7ea5ccc7f5810279ee7
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Feb 17 03:59:00 2021 +0000

    upstream: Make sure puttygen is new enough to successfully run the
    
    PuTTY interop tests, otherwise skip them.
    
    OpenBSD-Regress-ID: 34565bb50b8aec58331ed02a5e9e0a9a929bef51

commit da0a9afcc446a30ca49dd216612c41ac3cb1f2d4
Author: markus@openbsd.org <markus@openbsd.org>
Date:   Mon Feb 15 20:43:15 2021 +0000

    upstream: ssh: add PermitRemoteOpen for remote dynamic forwarding
    
    with SOCKS ok djm@, dtucker@
    
    OpenBSD-Commit-ID: 64fe7b6360acc4ea56aa61b66498b5ecc0a96a7c

commit b696858a7f9db72a83d02cb6edaca4b30a91b386
Author: markus@openbsd.org <markus@openbsd.org>
Date:   Mon Feb 15 20:36:35 2021 +0000

    upstream: factor out opt_array_append; ok djm@
    
    OpenBSD-Commit-ID: 571bc5dd35f99c5cf9de6aaeac428b168218e74a

commit ad74fc127cc45567e170e8c6dfa2cfd9767324ec
Author: dlg@openbsd.org <dlg@openbsd.org>
Date:   Mon Feb 15 11:09:22 2021 +0000

    upstream: ProxyJump takes "none" to disable processing like
    
    ProxyCommand does
    
    ok djm@ jmc@
    
    OpenBSD-Commit-ID: 941a2399da2193356bdc30b879d6e1692f18b6d3

commit 16eacdb016ccf38dd9959c78edd3a6282513aa53
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Feb 12 03:49:09 2021 +0000

    upstream: sftp: add missing lsetstat@openssh.com documentation
    
    patch from Mike Frysinger
    
    OpenBSD-Commit-ID: 9c114db88d505864075bfe7888b7c8745549715b

commit e04fd6dde16de1cdc5a4d9946397ff60d96568db
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Feb 12 03:14:18 2021 +0000

    upstream: factor SSH_AGENT_CONSTRAIN_EXTENSION parsing into its own
    
    function and remove an unused variable; ok dtucker@
    
    OpenBSD-Commit-ID: e1a938657fbf7ef0ba5e73b30365734a0cc96559

commit 1bb130ed34721d46452529d094d9bbf045607d79
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Feb 11 10:18:05 2021 +1100

    Add __NR_futex_time64 to seccomp sandbox.
    
    This is apparently needed for (some) 32 bit platforms with glibc 2.33.
    Patch from nix at esperi.org.uk and jjelen at redhat.com via bz#3260.

commit f88a7a431212a16e572ecabd559e632f369c363e
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Feb 6 09:37:01 2021 +1100

    Add a hostname function for systems that don't have it.
    
    Some systems don't have a hostname command (it's not required by POSIX).
    The do have uname -n (which is), but as found by tim@ some others (eg
    UnixWare) do not report the FQDN from uname -n.

commit 5e385a71ef2317856f37c91a98658eb12eb5a89c
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Feb 5 22:03:40 2021 +0000

    upstream: Roll back the hostname->uname change in rev 1.10. It turns
    
    out uname -n doesn't do what we need for some platforms in portable, so we'll
    fix the original problem (that some other platforms don't have hostname at
    all) by providing wrapper function to implement it.
    
    OpenBSD-Regress-ID: 827a707d6201d5a8e196a8c28aec1d2c76c52341

commit b446c214279de50ed8388e54897eb1be5281c894
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Feb 5 06:01:58 2021 +0000

    upstream: hostname is not specified by POSIX but uname -n is, so use
    
    the latter for portability.  Patch from Geert Hendrickx via github PR#208.
    
    OpenBSD-Regress-ID: d6a79c7c4d141a0d05ade4a042eb57dddbce89f3

commit 1cb6ce98d658e5fbdae025a3bd65793980e3b5d9
Author: David Carlier <devnexen@gmail.com>
Date:   Sat Nov 21 12:22:23 2020 +0000

    Using explicit_memset for the explicit_bzero compatibility layer.
    
    Favoriting the native implementation in this case.

commit 2e0beff67def2120f4b051b1016d7fbf84823e78
Author: Luca Weiss <luca@z3ntu.xyz>
Date:   Sun Nov 8 14:19:23 2020 +0100

    Deny (non-fatal) statx in preauth privsep child.

commit a35d3e911e193a652bd09eed40907e3e165b0a7b
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Feb 5 02:20:23 2021 +0000

    upstream: Remove debug message from sigchld handler. While this
    
    works on OpenBSD it can cause problems on other platforms.  From kircherlike
    at outlook.com via bz#3259, ok djm@
    
    OpenBSD-Commit-ID: 3e241d7ac1ee77e3de3651780b5dc47b283a7668

commit 69338ab46afe9e3dfb7762ad65351d854077c998
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Feb 2 22:36:59 2021 +0000

    upstream: whitespace
    
    OpenBSD-Commit-ID: 544bb092e03fcbecb420196cd0f70af13ea868ad

commit f71219a01d8f71c4b3ed7e456337a84ddba1653e
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Feb 2 22:36:46 2021 +0000

    upstream: fix memleaks in private key deserialisation; enforce more
    
    consistency between redundant fields in private key certificate and private
    key body; ok markus@
    
    OpenBSD-Commit-ID: dec344e414d47f0a7adc13aecf3760fe58101240

commit 3287790e78bf5b53c4a3cafb67bb5aa03e3910f0
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Feb 2 22:35:14 2021 +0000

    upstream: memleak on error path; ok markus@
    
    OpenBSD-Commit-ID: 2091a36d6ca3980c81891a6c4bdc544e63cb13a8

commit 3dd0c64e08f1bba21d71996d635c7256c8c139d1
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Jan 31 22:55:29 2021 +0000

    upstream: more strictly enforce KEX state-machine by banning packet
    
    types once they are received. Fixes memleak caused by duplicate
    SSH2_MSG_KEX_DH_GEX_REQUEST (spotted by portable OpenSSH kex_fuzz via
    oss-fuzz #30078).
    
    ok markus@
    
    OpenBSD-Commit-ID: 87331c715c095b587d5c88724694cdeb701c9def

commit 7a92a324a2e351fabd0ba8ef9b434d3b12d54ee3
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sun Jan 31 10:50:10 2021 +0000

    upstream: Set linesize returned by getline to zero when freeing and
    
    NULLing the returned string.  OpenBSD's getline handles this just fine, but
    some implementations used by -portable do not.  ok djm@
    
    OpenBSD-Commit-ID: 4d7bd5169d3397654247db9655cc69a9908d165c

commit a5dfc5bae8c16e2a7caf564758d812c7672480b5
Author: Damien Miller <djm@mindrot.org>
Date:   Sat Jan 30 16:32:29 2021 +1100

    allow a fuzz case to contain more than one request
    
    loop until input buffer empty, no message consumed or 256 messages
    processed

commit 0ef24ad60204022f7e33b6e9d171172c50514132
Author: Damien Miller <djm@mindrot.org>
Date:   Sat Jan 30 16:28:23 2021 +1100

    expect fuzz cases to have length prefix
    
    might make life a little easier for the fuzzer, e.g. it can now
    produce valid (multi-request) messages by smashing two cases together.

commit de613f2713d2dfcd3b03c00e5558a40997f52712
Author: Damien Miller <djm@mindrot.org>
Date:   Sat Jan 30 12:03:30 2021 +1100

    ssh-agent fuzzer

commit 7e96c877bcb2fb645355a687b8cb7347987c1c58
Author: Damien Miller <djm@mindrot.org>
Date:   Sat Jan 30 12:02:46 2021 +1100

    move keys out of kex_fuzz.cc into separate header
    
    add certificates and missing key types

commit 76f46d75664fdaa1112739ca523ff85ee4eb52b4
Author: Damien Miller <djm@mindrot.org>
Date:   Sat Jan 30 12:02:10 2021 +1100

    some fixed test data (mostly keys) for fuzzing

commit 7c2e3d6de1f2edb0c8b4725b4c2b56360e032b19
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Jan 30 00:56:38 2021 +0000

    upstream: add a SK_DUMMY_INTEGRATE define that allows the dummy
    
    security key middleware to be directly linked; useful for writing fuzzers,
    etc.
    
    OpenBSD-Regress-ID: 0ebd00159b58ebd85e61d8270fc02f1e45df1544

commit 1a4b92758690faa12f49079dd3b72567f909466d
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jan 29 06:29:46 2021 +0000

    upstream: fix the values of enum sock_type
    
    OpenBSD-Commit-ID: 18d048f4dbfbb159ff500cfc2700b8fb1407facd

commit 8afaa7d7918419d3da6c0477b83db2159879cb33
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jan 29 06:28:10 2021 +0000

    upstream: give typedef'd struct a struct name; makes the fuzzer I'm
    
    writing a bit easier
    
    OpenBSD-Commit-ID: 1052ab521505a4d8384d67acb3974ef81b8896cb

commit 1e660115f0c7c4a750cd31e468ff889f33dd8088
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Jan 29 11:09:14 2021 +1100

    fuzz diffie-hellman-group-exchange-sha1 kex too

commit be5f0048ea2aaeddd27be7dcca23aaad345fa16c
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Jan 29 11:03:35 2021 +1100

    support for running kex fuzzer with null cipher

commit 3d59e88c0e42182c3749b446ccd9027933c84be4
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Jan 28 20:55:16 2021 +1100

    make with -j2 to use available CPUs.

commit 66dd9ddb5d2ea8c407908c8e8468c9d6e71db05b
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Jan 28 14:31:01 2021 +1100

    Add test against openssl head and libressl head.

commit 237dbb34e24b6b7ea888d54bda4d17da0a0fd0fa
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Jan 28 14:30:50 2021 +1100

    Remove whitespace.

commit d983e1732b8135d7ee8d92290d6dce35f736ab88
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Jan 27 23:49:46 2021 +0000

    upstream: fix leak: was double allocating kex->session_id buffer
    
    OpenBSD-Commit-ID: 3765f4cc3ae1df874dba9102a3588ba7b48b8183

commit 1134a48cdcef8e7363b9f6c73ebdd24405066738
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Jan 28 08:57:31 2021 +1100

    correct kex name in disabled code

commit 67f47f1965abafc1830a287761125c2f4790857e
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Jan 27 10:15:08 2021 +0000

    upstream: this needs kex.h now
    
    OpenBSD-Commit-ID: c5a42166c5aa002197217421a971e48be7cb5d41

commit 39be3dc209f28f9c1ebfeba42adde8963b01e1cd
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Jan 27 10:05:28 2021 +0000

    upstream: make ssh->kex->session_id a sshbuf instead of u_char*/size_t
    
    and use that instead of global variables containing copies of it. feedback/ok
    markus@
    
    OpenBSD-Commit-ID: a4b1b1ca4afd2e37cb9f64f737b30a6a7f96af68

commit 4ca6a1fac328477c642329676d6469dba59019a3
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Jan 27 09:26:53 2021 +0000

    upstream: remove global variable used to stash compat flags and use the
    
    purpose-built ssh->compat variable instead; feedback/ok markus@
    
    OpenBSD-Commit-ID: 7c4f200e112dae6bcf99f5bae1a5629288378a06

commit bba229b6f3328171f5e3ae85de443002523c0452
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Jan 27 12:34:07 2021 +1100

    Install moduli file before tests.
    
    Reduces warnings during test runs.

commit 1b83185593a90a73860a503d753a95ca6d726c00
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Jan 27 11:58:26 2021 +1100

    Run one test with -Werror to catch warnings.

commit d1532d90074b212054d5fd965f833231b09982f5
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Jan 27 00:37:26 2021 +0000

    upstream: Logical not bitwise or. ok djm@
    
    OpenBSD-Commit-ID: d4dc855cf04951b93c45caa383e1ac9af0a3b0e5

commit 507b448a2465a53ab03a88acbc71cc51b48ca6ac
Author: naddy@openbsd.org <naddy@openbsd.org>
Date:   Tue Jan 26 15:40:17 2021 +0000

    upstream: move HostbasedAcceptedAlgorithms to the right place in
    
    alphabetical order
    
    OpenBSD-Commit-ID: d766820d33dd874d944c14b0638239adb522c7ec

commit e26c980778b228bdd42b8353cc70101cf49b731b
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Jan 26 11:25:01 2021 +0000

    upstream: Remove unused variables leftover from refactoring. ok
    
    djm@
    
    OpenBSD-Commit-ID: 8b3ad58bff828fcf874e54b2fc27a4cf1d9505e8

commit e9f78d6b06fc323bba1890b2dc3b8423138fb35c
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Jan 26 05:32:21 2021 +0000

    upstream: Rename HostbasedKeyTypes (ssh) and
    
    HostbasedAcceptedKeyTypes (sshd) to HostbasedAcceptedAlgorithms, which more
    accurately reflects its effect. This matches a previous change to
    PubkeyAcceptedAlgorithms.  The previous names are retained as aliases.  ok
    djm@
    
    OpenBSD-Commit-ID: 49451c382adc6e69d3fa0e0663eeef2daa4b199e

commit 48d0d7a4dd31154c4208ec39029d60646192f978
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Jan 26 14:48:07 2021 +1100

    Disable sntrup761 if compiler doesn't support VLAs.
    
    The sntrup761 code sourced from supercop uses variable length
    arrays.  Although widely supported, they are not part of the ANSI
    C89 spec so if the compiler does not support VLAs, disable the
    sntrup761x25519-sha512@openssh.com KEX method by replacing the kex
    functions with no-op ones similar to what we do in kexecdh.c.
    
    This should allow OpenSSH to build with a plain C89 compiler again.
    Spotted by tim@, ok djm@.

commit 37c70ea8d4f3664a88141bcdf0bf7a16bd5fd1ac
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jan 26 00:54:49 2021 +0000

    upstream: refactor key constraint parsing in ssh-agent
    
    Key constraints parsing code previously existed in both the "add regular
    key" and "add smartcard key" path. This unifies them but also introduces
    more consistency checking: duplicated constraints and constraints that
    are nonsensical for a particular situation (e.g. FIDO provider for a
    smartcard key) are now banned.
    
    ok markus@
    
    OpenBSD-Commit-ID: 511cb1b1c021ee1d51a4c2d649b937445de7983c

commit e0e8bee8024fa9e31974244d14f03d799e5c0775
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jan 26 00:53:31 2021 +0000

    upstream: more ssh-agent refactoring
    
    Allow confirm_key() to accept an additional reason suffix
    
    Factor publickey userauth parsing out into its own function and allow
    it to optionally return things it parsed out of the message to its
    caller.
    
    feedback/ok markus@
    
    OpenBSD-Commit-ID: 29006515617d1aa2d8b85cd2bf667e849146477e

commit dfe18a295542c169ffde8533b3d7fe42088e2de7
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jan 26 00:51:30 2021 +0000

    upstream: make struct hostkeys public; I have no idea why I made it
    
    opaque originally.
    
    ok markus@
    
    OpenBSD-Commit-ID: e50780b34d4bbe628d69b2405b024dd749d982f3

commit 3b44f2513cae89c920e8fe927b9bc910a1c8c65a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jan 26 00:49:30 2021 +0000

    upstream: move check_host_cert() from sshconnect,c to sshkey.c and
    
    refactor it to make it more generally usable and testable.
    
    ok markus@
    
    OpenBSD-Commit-ID: 536f489f5ff38808c1fa711ba58d4579b636f9e4

commit 1fe16fd61bb53944ec510882acc0491abd66ff76
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jan 26 00:47:47 2021 +0000

    upstream: use recallocarray to allocate the agent sockets table;
    
    also clear socket entries that are being marked as unused.
    
    spinkle in some debug2() spam to make it easier to watch an agent
    do its thing.
    
    ok markus
    
    OpenBSD-Commit-ID: 74582c8e82e96afea46f6c7b6813a429cbc75922

commit cb7b22ea20a01332c81c0ddcb3555ad50de9cce2
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jan 26 00:46:17 2021 +0000

    upstream: factor out common code in the agent client
    
    Add a ssh_request_reply_decode() function that sends a message to
    the agent, reads and parses a success/failure reply.
    Use it for all requests that only expect success/failure
    
    ok markus@
    
    OpenBSD-Commit-ID: e0c1f4d5e6cfa525d62581e2b8de93be0cb85adb

commit d1e578afe7cd48140ad6e92a453f9b035363fd7f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jan 25 06:00:17 2021 +0000

    upstream: make ssh hostbased authentication send the signature
    
    algorithm in its SSH2_MSG_USERAUTH_REQUEST packets instead of the key type.
    This make HostbasedAcceptedAlgorithms do what it is supposed to - filter on
    signature algorithm and not key type.
    
    spotted with dtucker@ ok markus@
    
    OpenBSD-Commit-ID: 25bffe19f0326972f5728170f7da81d5f45c78c6

commit 95eca1e195a3b41baa1a725c2c5af8a09d885e4b
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Jan 23 18:26:05 2021 +1100

    ifdef new instance of sin6_scope_id
    
    Put inside HAVE_STRUCT_SOCKADDR_IN6_SIN6_SCOPE_ID similar to
    existing instance.  Should fix error on UnixWare 7.

commit 6ffdcdda128045226dda7fbb3956407978028a1e
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Jan 18 11:43:34 2021 +0000

    upstream: Fix long->int for convtime tests here too. Spotted by
    
    tobhe@.
    
    OpenBSD-Regress-ID: a87094f5863312d00938afba771d25f788c849d0

commit b55b7565f15327d82ad7acbddafa90b658c5f0af
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jan 22 02:46:40 2021 +0000

    upstream: PubkeyAcceptedKeyTypes->PubkeyAcceptedAlgorithms
    
    here too.
    
    OpenBSD-Commit-ID: 3b64a640f8ce8c21d9314da9df7ce2420eefde3a

commit ee9c0da8035b3168e8e57c1dedc2d1b0daf00eec
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jan 22 02:44:58 2021 +0000

    upstream: Rename PubkeyAcceptedKeyTypes keyword to
    
    PubkeyAcceptedAlgorithms. While the two were originally equivalent, this
    actually specifies the signature algorithms that are accepted.  Some key
    types (eg RSA) can be used by multiple algorithms (eg ssh-rsa, rsa-sha2-512)
    so the old name is becoming increasingly misleading.  The old name is
    retained as an alias. Prompted by bz#3253, help & ok djm@, man page help jmc@
    
    OpenBSD-Commit-ID: 0346b2f73f54c43d4e001089759d149bfe402ca5

commit a8e798feabe36d02de292bcfd274712cae1d8d17
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jan 15 02:58:11 2021 +0000

    upstream: Change types in convtime() unit test to int to match change
    
    its new type. Add tests for boundary conditions and fix convtime to work up
    to INT_MAX. ok djm@
    
    OpenBSD-Regress-ID: ba2b81e9a3257fff204b020affe85b604a44f97e

commit 9bde1a420626da5007bf7ab499fa2159b9eddf72
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jan 15 04:31:25 2021 +0000

    upstream: Make output buffer larger to prevent potential truncation
    
    warnings from compilers not smart enough to know the strftime calls won't
    ever fully fill "to" and "from".  ok djm@
    
    OpenBSD-Commit-ID: 83733f1b01b82da88b9dd1769475952aff10bdd7

commit 02da325f10b214219eae2bb1bc2d3bf0c2f13f9f
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jan 15 02:58:11 2021 +0000

    upstream: Change types in convtime() unit test to int to match
    
    change its new type. Add tests for boundary conditions and fix convtime to
    work up to INT_MAX. ok djm@
    
    OpenBSD-Commit-ID: 01dc0475f1484ac2f47facdfcf9221f9472145de

commit 5339ab369c225b40bc64d5ec3374f5c91b3ad609
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jan 15 02:32:41 2021 +0000

    upstream: In waitfd(), when poll returns early we are subtracting
    
    the elapsed time from the timeout each loop, so we only want to measure the
    elapsed time the poll() in that loop, not since the start of the function.
    Spotted by chris.xj.zhu at gmail.com, ok djm@
    
    OpenBSD-Commit-ID: 199df060978ee9aa89b8041a3dfaf1bf7ae8dd7a

commit a164862dfa863b54b7897f66e1dd75437f086c11
Author: rob@openbsd.org <rob@openbsd.org>
Date:   Thu Jan 14 19:45:06 2021 +0000

    upstream: Minor grammatical correction.
    
    OK jmc@
    
    OpenBSD-Commit-ID: de0fad0581e212b2750751e479b79c18ff8cac02

commit 8635e7df7e3a3fbb4a4f6cd5a7202883b2506087
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Jan 13 18:00:57 2021 +1100

    Merge Mac OS X targets into a single config.

commit ac112ade990585c511048ed4edaf2d9fc92b61f0
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Jan 12 19:22:47 2021 +1100

    Add Mac OS X test targets.

commit 1050109b4b2884bf50fd1b3aa084c7fd0a42ae90
Author: anatasluo <luolongjuna@gmail.com>
Date:   Mon Jan 11 13:51:39 2021 +0000

    Remove duplicated declaration in fatal.c .

commit 7d0f8a3369579dfe398536eb4e3da7bc15da9599
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Jan 11 04:48:22 2021 +0000

    upstream: Correct spelling of persourcenetblocksize in config-dump
    
    mode.
    
    OpenBSD-Commit-ID: ecdc49e2b6bde6b6b0e52163d621831f6ac7b13d

commit ba328bd7a6774f30daaf90b83f1933cc4afc866c
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sat Jan 9 12:31:46 2021 +0000

    upstream: Adjust kexfuzz to addr.c/addrmatch.c split.
    
    OpenBSD-Regress-ID: 1d8d23bb548078020be2fb52c4c643efb190f0eb

commit b08ef25552443e94c0857d5e3806dd019ccc55d7
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sat Jan 9 12:24:30 2021 +0000

    upstream: Update unittests for addr.c/addrmatch.c split.
    
    OpenBSD-Regress-ID: de2b415fb7af084a91c6ef147a90482d8f771eef

commit 6d30673fedec2d251f4962c526fd0451f70c4d97
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Jan 11 02:12:57 2021 +0000

    upstream: Change convtime() from returning long to returning int.
    
    On platforms where sizeof(int) != sizeof(long), convtime could accept values
    >MAX_INT which subsequently truncate when stored in an int during config
    parsing.  bz#3250, ok djm@
    
    OpenBSD-Commit-ID: 8fc932683d6b4660d52f50911d62bd6639c5db31

commit 7a57adb8b07b2ad0aead4b2e09ee18edc04d0481
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Sat Jan 9 12:51:12 2021 +0000

    upstream: add a comma to previous;
    
    OpenBSD-Commit-ID: 9139433701c0aa86a0d3a6c7afe10d1c9c2e0869

commit 3a923129534b007c2e24176a8655dec74eca9c46
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sat Jan 9 12:10:02 2021 +0000

    upstream: Add PerSourceMaxStartups and PerSourceNetBlockSize
    
    options which provide more fine grained MaxStartups limits.  Man page help
    jmc@, feedback & ok djm@
    
    OpenBSD-Commit-ID: e2f68664e3d02c0895b35aa751c48a2af622047b

commit d9a2bc71693ea27461a78110005d5a2d8b0c6a50
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sat Jan 9 11:58:50 2021 +0000

    upstream: Move address handling functions out into their own file
    
    in order to reuse them for per-source maxstartups limiting.  Supplement with
    some additional functions from djm's flowtools that we'll also need.  ok djm@
    (as part of a larger diff).
    
    OpenBSD-Commit-ID: e3e7d9ccc6c9b82e25cfef0ec83598e8e2327cbf

commit b744914fcb76d70761f1b667de95841b3fc80a56
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Jan 9 00:36:05 2021 +1100

    Add test against Graphene hardened malloc.

commit 6cb52d5bf771f6769b630fce35a8e9b8e433044f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jan 8 04:49:13 2021 +0000

    upstream: make CheckHostIP default to 'no'. It doesn't provide any
    
    perceptible value and makes it much harder for hosts to change host keys,
    particularly ones that use IP-based load-balancing.
    
    ok dtucker@
    
    OpenBSD-Commit-ID: 0db98413e82074f78c7d46784b1286d08aee78f0

commit 309b642e1442961b5e57701f095bcd4acd2bfb5f
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Jan 8 15:50:41 2021 +1100

    Run tests with sudo for better coverage.

commit c336644351fa3c715a08b7a292e309e72792e71e
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Jan 8 14:26:32 2021 +1100

    Add Ubuntu 16.04 and 20.04 test targets.

commit 4c7af01f9dcc1606dec033e7665a042cb0d8ec52
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jan 8 02:57:24 2021 +0000

    upstream: If a signature operation on a FIDO key fails with a
    
    "incorrect PIN" reason and no PIN was initially requested from the user, then
    request a PIN and retry the operation.
    
    This smoothes over a few corner cases including FIDO devices that
    require PINs for all hosted credentials, biometric FIDO devices that
    fall back to requiring PIN when reading the biometric failed, devices
    that don't implement reading credProtect status for downloaded keys
    and probably a few more cases that I haven't though of yet.
    
    ok dtucker@
    
    OpenBSD-Commit-ID: 176db8518933d6a5bbf81a2e3cf62447158dc878

commit 64ddd0fe68c4a7acf99b78624f8af45e919cd317
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jan 8 02:44:14 2021 +0000

    upstream: don't try to use timespeccmp(3) directly as a qsort(3)
    
    comparison function - it returns 0/1 and not the -1/0/1 that qsort expectes.
    
    fixes sftp "ls -ltr" under some circumstances.
    
    Based on patch by Masahiro Matsuya via bz3248.
    
    OpenBSD-Commit-ID: 65b5e9f18bb0d10573868c3516de6e5170adb163

commit 599df78f3008cf78af21f8977be3e1dd085f8e2e
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jan 8 02:33:13 2021 +0000

    upstream: Update the sntrup761 creation script and generated code:
    
    - remove unneeded header files and typedefs and rely on crypto_api.h  - add
    defines to map types used to the crypto_api ones instead of typedefs.  This
     prevents typedef name collisions in -portable.  - remove CRYPTO_NAMESPACE
    entirely instead of making it a no-op  - delete unused functions and make the
    remaining ones that aren't exported static.
    
    ok djm@
    
    OpenBSD-Commit-ID: 7b9d0cf3acd5a3c1091da8afe00c904d38cf5783

commit 16448ff529affda7e2a15ee7c3200793abde0759
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jan 8 02:19:24 2021 +0000

    upstream: mention that DisableForwarding is valid in a sshd_config
    
    Match block reported by Fredrik Eriksson in bz3239
    
    OpenBSD-Commit-ID: 3a71c3d84b597f5e43e4b40d5232797daf0993f6

commit 91bac5e95b1b0debf9b2b4f05c20dcfa96b368b9
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Jan 4 21:58:58 2021 +0000

    upstream: estructure sntrup761.sh to process all files in a single
    
    list, which will make it easier to reorder.  Re-inline int32_MINMAX.  ok
    tobhe@
    
    OpenBSD-Commit-ID: d145c6c19b08bb93c9e14bfaa7af589d90f144c0

commit 4d96a3ebab2224f17e639a15078e03be1ad3736d
Author: tobhe@openbsd.org <tobhe@openbsd.org>
Date:   Sun Jan 3 18:05:21 2021 +0000

    upstream: Prevent redefinition of `crypto_int32' error with gcc3.
    
    Fixes compilation on luna88k.
    
    Feedback millert@
    Found by and ok aoyama@
    
    OpenBSD-Commit-ID: f305ddfe575a26cc53431af3fde3f4aeebed9ba6

commit a23954eeb930ccc8a66a2710153730769dba31b6
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Jan 1 22:00:49 2021 +1100

    Undef int32 after sort routines.
    
    This prevents typedef'ing crypto_int32 twice, in sntrup761.c and
    crypto_api.h, which some compilers (at least some GCCs) don't accept.

commit 148b8a661c3f93e4b6d049ee902de3d521261fbc
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Dec 31 12:47:22 2020 +1100

    fix: missing pieces of previous commit

commit 3d999be7b987c848feda718cfcfcdc005ddf670d
Author: tobhe@openbsd.org <tobhe@openbsd.org>
Date:   Wed Dec 30 14:13:28 2020 +0000

    upstream: Use int64_t for intermediate values in int32_MINMAX to
    
    prevent signed 32-bit integer overflow.
    
    Found by and ok djm@
    ok markus@
    
    OpenBSD-Commit-ID: 4f0704768e34cf45fdd792bac4011c6971881bb3

commit 5c1953bf98732da5a76c706714ac066dbfa015ac
Author: Damien Miller <djm@mindrot.org>
Date:   Tue Dec 29 12:40:54 2020 +1100

    adapt KEX fuzzer to PQ kex change

commit 659864fe81dbc57eeed3769c462679d83e026640
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Dec 29 01:02:15 2020 +0000

    upstream: Adapt to replacement of
    
    sntrup4591761x25519-sha512@tinyssh.org with
    sntrup761x25519-sha512@openssh.com.
    
    Also test sntrup761x25519-sha512@openssh.com in unittests/kex
    
    OpenBSD-Regress-ID: cfa3506b2b077a9cac1877fb521efd2641b6030c

commit 2c71cec020219d69df84055c59eba5799a1233ec
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Dec 29 00:59:15 2020 +0000

    upstream: Update/replace the experimental post-quantim hybrid key
    
    exchange method based on Streamlined NTRU Prime (coupled with X25519).
    
    The previous sntrup4591761x25519-sha512@tinyssh.org method is
    replaced with sntrup761x25519-sha512@openssh.com. Per the authors,
    sntrup4591761 was replaced almost two years ago by sntrup761.
    
    The sntrup761 implementaion, like sntrup4591761 before it, is public
    domain code extracted from the SUPERCOP cryptography benchmark
    suite (https://bench.cr.yp.to/supercop.html).
    
    Thanks for Daniel J Bernstein for guidance on algorithm selection.
    Patch from Tobias Heider; feedback & ok markus@ and myself
    
    (note this both the updated method and the one that it replaced are
    disabled by default)
    
    OpenBSD-Commit-ID: 2bf582b772d81ee24e911bb6f4b2aecfd39338ae

commit 09d070ccc3574ae0d7947d212ed53c7268ef7e1f
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Tue Dec 22 07:40:26 2020 +0000

    upstream: tweak the description of KnownHostsCommand in ssh_conf.5,
    
    and add entries for it to the -O list in scp.1 and sftp.1;
    
    ok djm
    
    OpenBSD-Commit-ID: aba31ebea03f38f8d218857f7ce16a500c3e4aff

commit 931c93389a80e32272712459b1102d303844453d
Author: Damien Miller <djm@mindrot.org>
Date:   Tue Dec 22 19:43:55 2020 +1100

    whitespace at EOL

commit 397b1c4d393f97427283a4717e9015a2bd31b8a5
Author: Damien Miller <djm@mindrot.org>
Date:   Tue Dec 22 19:42:37 2020 +1100

    whitespace at EOL

commit 33fa3ac547e5349ca34681cce6727b2f933dff0a
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Dec 22 19:21:26 2020 +1100

    Improve AIX text.

commit 0f2e21c9dca89598b694932b5b05848380a23ec0
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Dec 22 18:56:54 2020 +1100

    Include stdio.h for FILE in misc.h.
    
    Fixes build on at least OpenBSD.

commit 3e9811e57b57ee66b0f70d99d7258da3153b0e8a
Author: Damien Miller <djm@mindrot.org>
Date:   Tue Dec 22 18:31:50 2020 +1100

    ensure $LOGNAME is set in tests

commit 3eb647cbb34d87a063aa7714256c6e56103fffda
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Dec 22 06:47:24 2020 +0000

    upstream: more detail for failing tests
    
    OpenBSD-Regress-ID: c68c0e5a521cad7e7f68e54c54ebf86d6c10ee1d

commit 2873f19570d4d8758be24dbf78332be9a779009b
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Dec 22 06:03:36 2020 +0000

    upstream: regress test for KnownHostsCommand
    
    OpenBSD-Regress-ID: ffc77464320b6dabdcfa0a72e0df02659233a38a

commit 0121aa87bab9ad2365de2d07f2832b56d5ff9871
Author: tb@openbsd.org <tb@openbsd.org>
Date:   Tue Dec 22 03:05:31 2020 +0000

    upstream: Remove lines accidentally left behind in the ProxyJump
    
    parsing fix r1.345.
    
    ok djm
    
    OpenBSD-Commit-ID: fe767c108c8117bea33767b080ff62eef2c55f5c

commit da4bf0db942b5f0278f33238b86235e5813d7a5a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Dec 22 00:15:22 2020 +0000

    upstream: add a ssh_config KnownHostsCommand that allows the client
    
    to obtain known_hosts data from a command in addition to the usual files.
    
    The command accepts bunch of %-expansions, including details of the
    connection and the offered server host key. Note that the command may
    be invoked up to three times per connection (see the manpage for
    details).
    
    ok markus@
    
    OpenBSD-Commit-ID: 2433cff4fb323918ae968da6ff38feb99b4d33d0

commit a34e14a5a0071de2036826a00197ce38c8b4ba8b
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Dec 22 00:12:22 2020 +0000

    upstream: move subprocess() from auth.c to misc.c
    
    make privilege dropping optional but allow it via callbacks (to avoid
    need to link uidswap.c everywhere)
    
    add some other flags (keep environment, disable strict path safety check)
    that make this more useful for client-side use.
    
    feedback & ok markus@
    
    OpenBSD-Commit-ID: a80ea9fdcc156f1a18e9c166122c759fae1637bf

commit 649205fe388b56acb3481a1b2461f6b5b7c6efa6
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Dec 21 22:48:41 2020 +0000

    upstream: Remove explicit rijndael-cbc@lysator.liu.se test since the
    
    cipher was removed.
    
    OpenBSD-Regress-ID: aa93cddb4ecd9bc21446a79008a1a53050e64f17

commit 03e93c753d7c223063ad8acaf9a30aa511e5f931
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Dec 21 11:09:32 2020 +0000

    upstream: Remove the pre-standardization cipher
    
    rijndael-cbc@lysator.liu.se. It is an alias for aes256-cbc which was
    standardized in RFC4253 (2006), has been deprecated and disabled by default
    since OpenSSH 7.2 (2016) and was only briefly documented in ssh.1 in 2001.
    
    This will reduce the amount of work the cipher/kex regression tests need
    to do by a little bit.  ok markus@ djm@
    
    OpenBSD-Commit-ID: fb460acc18290a998fd70910b19c29b4e4f199ad

commit a11ca015879eab941add8c6bdaaec7d41107c6f5
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Dec 21 09:19:53 2020 +0000

    upstream: properly fix ProxyJump parsing; Thanks to tb@ for
    
    pointing out my error (parse_ssh_uri() can return -1/0/1, that I missed).
    Reported by Raf Czlonka via bugs@
    
    ok tb@
    
    OpenBSD-Commit-ID: a2991a3794bcaf1ca2b025212cce11cdb5f6b7d6

commit d97fb879724f1670bf55d9adfea7278a93c33ae2
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Dec 21 01:31:06 2020 +0000

    upstream: adapt to API change in hostkeys_foreach()/load_hostkeys()
    
    OpenBSD-Regress-ID: dcb468514f32da49a446372453497dc6eeafdbf3

commit bf7eb3c266b7fd4ddda108fcf72b860af2af6406
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Oct 16 14:02:24 2020 +0000

    upstream: few more things needs match.c and addrmatch.c now that
    
    log.c calls match_pattern_list()
    
    OpenBSD-Regress-ID: f7c95c76b150d0aeb00a67858b9579b7d1b2db74

commit 2c64f24e27a5e72a7f59e515fc4f4985355237ae
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Dec 21 14:02:56 2020 +1100

    Pull in missing rev 1.2.

commit 0f504f592d15d8047e466eb7453067a6880992a8
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Dec 20 23:40:19 2020 +0000

    upstream: plumb ssh_conn_info through to sshconnect.c; feedback/ok
    
    markus@
    
    OpenBSD-Commit-ID: e8d14a09cda3f1dc55df08f8a4889beff74e68b0

commit 729b05f59ded35483acef90a6f88aa03eae33b29
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Dec 20 23:38:00 2020 +0000

    upstream: allow UserKnownHostsFile=none; feedback and ok markus@
    
    OpenBSD-Commit-ID: c46d515eac94a35a1d50d5fd71c4b1ca53334b48

commit b4c7cd1185c5dc0593d47eafcc1a34fda569dd1d
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Dec 20 23:36:51 2020 +0000

    upstream: load_hostkeys()/hostkeys_foreach() variants for FILE*
    
    Add load_hostkeys_file() and hostkeys_foreach_file() that accept a
    FILE* argument instead of opening the file directly.
    
    Original load_hostkeys() and hostkeys_foreach() are implemented using
    these new interfaces.
    
    Add a u_int note field to the hostkey_entry and hostkey_foreach_line
    structs that is passed directly from the load_hostkeys() and
    hostkeys_foreach() call. This is a lightweight way to annotate results
    between different invocations of load_hostkeys().
    
    ok markus@
    
    OpenBSD-Commit-ID: 6ff6db13ec9ee4edfa658b2c38baad0f505d8c20

commit 06fbb386bed666581095cb9cbc7a900e02bfe1b7
Author: tobhe@openbsd.org <tobhe@openbsd.org>
Date:   Sat Dec 19 22:09:21 2020 +0000

    upstream: Print client kem key with correct length.
    
    ok markus@
    
    OpenBSD-Commit-ID: 91689e14a4fc6c270e265a32d1c8faba63a45755

commit 0ebead6593e2441e4af2735bbe2cd097607cd0d3
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Dec 17 23:28:50 2020 +0000

    upstream: fix possible error("%s", NULL) on error paths
    
    OpenBSD-Commit-ID: 0b3833c2cb985453ecca1d76803ebb8f3b736a11

commit d060bc7f6e6244f001e658208f53e3e2ecbbd382
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Dec 17 23:26:11 2020 +0000

    upstream: refactor client percent_expand() argument passing;
    
    consolidate the common arguments into a single struct and pass that around
    instead of using a bunch of globals. ok markus@
    
    OpenBSD-Commit-ID: 035e6d7ca9145ad504f6af5a021943f1958cd19b

commit 43026da035cd266db37df1f723d5575056150744
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Dec 17 23:10:27 2020 +0000

    upstream: prepare readconf.c for fuzzing; remove fatal calls and
    
    fix some (one-off) memory leaks; ok markus@
    
    OpenBSD-Commit-ID: 91c6aec57b0e7aae9190de188e9fe8933aad5ec5

commit bef92346c4a808f33216e54d6f4948f9df2ad7c1
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Dec 14 03:13:12 2020 +0000

    upstream: use _PATH_SSH_USER_DIR instead of hardcoded .ssh in path
    
    OpenBSD-Commit-ID: 5c1048468813107baa872f5ee33ba51623630e01

commit a5ab499bd2644b4026596fc2cb24a744fa310666
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Dec 4 14:01:27 2020 +1100

    basic KEX fuzzer; adapted from Markus' unittest

commit 021ff33e383c77b11badd60cec5b141a3e3fa532
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Dec 4 13:57:43 2020 +1100

    use options that work with recent clang

commit e4d1a0b40add800b6e9352b40c2223e44acc3a45
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Dec 4 02:41:10 2020 +0000

    upstream: shuffle a few utility functions into sftp-client.c; from
    
    Jakub Jelen
    
    OpenBSD-Commit-ID: fdeb1aae1f6149b193f12cd2af158f948c514a2a

commit ace12dc64f8e3a2496ca48d36b53cb3c0a090755
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Dec 4 02:29:56 2020 +0000

    upstream: make ssh_free(NULL) a no-op
    
    OpenBSD-Commit-ID: 42cb285d94789cefe6608db89c63040ab0a80fa0

commit 3b98b6e27f8a122dbfda9966b1afeb3e371cce91
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Dec 4 02:29:25 2020 +0000

    upstream: memleak of DH public bignum; found with libfuzzer
    
    OpenBSD-Commit-ID: 0e913b542c3764b100b1571fdb0d0e5cc086fe97

commit 553b90feedd7da5b90901d73005f86705456d686
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Dec 4 02:27:57 2020 +0000

    upstream: fix minor memleak of kex->hostkey_alg on rekex
    
    OpenBSD-Commit-ID: 2c3969c74966d4ccdfeff5e5f0df0791919aef50

commit ac0364b85e66eb53da2f9618f699ba6bd195ceea
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Dec 4 02:27:08 2020 +0000

    upstream: typos: s/hex/kex/ in error messages
    
    OpenBSD-Commit-ID: 43a026c9571dd779ec148de1829cf5a6b6651905

commit ee22db7c5885a1d90219202c0695bc621aa0409b
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Dec 4 02:25:13 2020 +0000

    upstream: make program name be const
    
    OpenBSD-Commit-ID: ece25680ec637fdf20502721ccb0276691df5384

commit 2bcbf679de838bb77a8bd7fa18e100df471a679c
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Nov 30 05:36:39 2020 +0000

    upstream: Ignore comments at the end of config lines in ssh_config,
    
    similar to what we already do for sshd_config.  bz#2320, with & ok djm@
    
    OpenBSD-Commit-ID: bdbf9fc5bc72b1a14266f5f61723ed57307a6db4

commit b755264e7d3cdf1de34e18df1af4efaa76a3c015
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sat Nov 28 12:52:32 2020 +0000

    upstream: Include cipher.h for declaration of cipher_by_name.
    
    OpenBSD-Commit-ID: ddfebbca03ca0e14e00bbad9d35f94b99655d032

commit 022def7bd16c3426a95e25f57cb259d54468341c
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Nov 28 03:27:59 2020 +0000

    upstream: check result of strchr() against NULL rather than
    
    searched-for characters; from zhongjubin@huawei.com
    
    OpenBSD-Commit-ID: e6f57de1d4a4d25f8db2d44e8d58d847e247a4fe

commit 57bf03f0217554afb8980f6697a7a0b88658d0a9
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Nov 27 10:12:30 2020 +0000

    upstream: Document ssh-keygen -Z, sanity check its argument earlier and
    
    provide a better error message if it's not correct.  Prompted by bz#2879, ok
    djm@ jmc@
    
    OpenBSD-Commit-ID: 484178a173e92230fb1803fb4f206d61f7b58005

commit 33313ebc1c7135085676db62189e3520341d6b73
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Nov 27 00:49:58 2020 +0000

    upstream: Set the specified TOS/DSCP for interactive use prior to
    
    TCP connect. The connection phase of the SSH session is time-sensitive (due
    to server side login grace periods) and is frequently interactive (e.g.
    entering passwords). The ultimate interactive/bulk TOS/DSCP will be set after
    authentication completes.
    
    ok dtucker@
    
    OpenBSD-Commit-ID: f31ab10d9233363a6d2c9996007083ba43a093f1

commit b2bcec13f17ce9174238a704e91d52203e916432
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Nov 27 00:37:10 2020 +0000

    upstream: clean up passing of struct passwd from monitor to preauth
    
    privsep process. No longer copy entire struct w/ pointer addresses, but pass
    remaining scalar fields explicitly,
    
    Prompted by Yuichiro NAITO, feedback Thorsten Glaser; ok dtucker@
    
    OpenBSD-Commit-ID: 9925df75a56732c43f3663e70dd15ff413ab3e53

commit 19af04e2231155d513e24fdc81fbec2217ae36a6
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Nov 22 22:38:26 2020 +0000

    upstream: when loading PKCS#11 keys, include the key fingerprints
    
    and provider/slot information in debug output.
    
    OpenBSD-Commit-ID: 969a089575d0166a9a364a9901bb6a8d9b8a1431

commit 9b9465ea856e15b9e9890b4ecb4110d7106e7766
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Nov 22 22:37:11 2020 +0000

    upstream: when mentioning that the host key has changed, don't
    
    report the type because it is ambiguous as to whether it referred to the
    known or new host key. bz3216; ok dtucker@
    
    OpenBSD-Commit-ID: 2d5ce4a83dbcf44e340a572e361decad8aab7bad

commit 637017a7dd3281d3f2df804993cc27c30dbfda47
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Nov 25 17:38:46 2020 +1100

    Use "=" not "==" in string test.
    
    POSIX says "=" is string comparison and some shells (eg HP-UX) will
    complain about "==".

commit 9880f3480f9768897f3b8e714d5317fb993bc5b3
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Nov 20 17:16:51 2020 +1100

    Restore correct flags during localtime_r check.
    
    We were restoring the wrong thing CPPFLAGS (we used CFLAGS) for any
    platform that doesn't have localtime_r.

commit 41935882f4e82de60dbd6e033eabe79e1b963518
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Nov 20 03:16:56 2020 +0000

    upstream: When doing an sftp recursive upload or download of a
    
    read-only directory, ensure that the directory is created with write and
    execute permissions in the interim so that we can actually complete the
    transfer, then set the directory permission as the final step.  (The execute
    bit is only likely to be an issue with a non-POSIX server).  bz#3222, ok djm@
    
    OpenBSD-Commit-ID: a82606212f2796e31f0e1af94a63355a7ad5d903

commit 0f90440ca70abab947acbd77795e9f130967956c
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Nov 20 13:37:54 2020 +1100

    Add new pselect6_time64 syscall on ARM.
    
    This is apparently needed on armhfp/armv7hl.  bz#3232, patch from
    jjelen at redhat.com.

commit 3a7c46c72b6a1f643b1fc3589cd20d8320c3d9e1
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Nov 20 02:14:16 2020 +0000

    upstream: Explicitly initialize all members of the
    
    find_by_key_ctx struct.  Initializing a single member should be enough
    (the spec says the remainder should be initialized as per the static
    rules) but some GCCs warn on this which prevents us testing with -Werror
    on those.  ok deraadt@ djm@
    
    OpenBSD-Commit-ID: 687126e60a27d30f02614760ef3c3ae4e8d6af28

commit 076cb616b87d1ea1d292973fcd0ba38c08ea6832
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu Nov 19 23:05:05 2020 +0000

    upstream: draft-ietf-secsh-architecture is now RFC4251.
    
    OpenBSD-Commit-ID: cb0bb58c2711fb5ed519507659be1dcf179ed403

commit 85cceda21f1471548e04111aefe2c4943131c1c8
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Nov 17 11:23:58 2020 +0000

    upstream: Specify that the KDF function is bcrypt. Based on github
    
    PR#214 from rafork, ok markus@, mdoc correction jmc@
    
    OpenBSD-Commit-ID: d8f2853e7edbcd483f31b50da77ab80ffa18b4ef

commit 5b9720f9adbd70ba5a994f407fe07a7d016d8d65
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Nov 15 22:34:58 2020 +0000

    upstream: revert r1.341; it breaks ProxyJump; reported by sthen@
    
    OpenBSD-Commit-ID: 6ac2f945b26cb86d936eed338f77861d6da8356a

commit 04088725ec9c44880c01799b588cd4ba47b3e8bc
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Nov 13 07:30:44 2020 +0000

    upstream: scrub keyboard-interactive authentication prompts coming
    
    from the server through asmprintf() prior to display; suggested by and ok
    dtucker@
    
    OpenBSD-Commit-ID: 31fe93367645c37fbfe4691596bf6cf1e3972a58

commit 5442b491d0ee4bb82f6341ad0ee620ef3947f8c5
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Nov 13 04:53:12 2020 +0000

    upstream: prefix keyboard interactive prompts with (user@host) to
    
    make it easier to determine which connection they are associated with in
    cases like scp -3, ProxyJump, etc. bz#3224 ok dtucker
    
    OpenBSD-Commit-ID: 67e6189b04b46c867662f8a6759cf3ecb5f59170

commit 2992e4e7014ac1047062acfdbbf6feb156fef616
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Nov 13 17:56:11 2020 +1100

    Remove use of TIME_WITH_SYS_TIME.
    
    It was only set by the recently removed AC_HEADER_TIME macro, replace
    with simple inclusions of both sys/time.h and time.h.  Should prevent
    mis-detection of struct timespec.

commit e3f27006f15abacb7e89fda3f5e9a0bd420b7e38
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Nov 13 14:20:43 2020 +1100

    Revert "detect Linux/X32 systems"
    
    This reverts commit 5b56bd0affea7b02b540bdbc4d1d271b0e4fc885.
    
    The approach used was incorrect; discussion in bz#3085

commit e51dc7fab61df36e43f3bc64b673f88d388cab91
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Nov 13 13:22:15 2020 +1100

    SELinux has deprecated security_context_t
    
    (it was only ever a char* anyway)

commit b79add37d118276d67f3899987b9f0629c9449c3
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Nov 13 13:43:30 2020 +1100

    Remove obsolete AC_HEADER_TIME macro.
    
    AC_HEADER_TIME is marked as obsolete in autoconf-2.70 and as far as I
    can tell everything we have that might be old enough to need it doesn't.

commit d5d05cdb3d4efd4a618aa52caab5bec73097c163
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Nov 12 22:56:00 2020 +0000

    upstream: when prompting the user to accept a new hostkey, display
    
    any other host names/addresses already associated with the key. E.g.
    
    > The authenticity of host 'test (10.0.0.1)' can't be established.
    > ECDSA key fingerprint is SHA256:milU4MODXm8iJQI18wlsbPG7Yup+34fuNNmV08qDnax.
    > This host key is known by the following other names/addresses:
    >     ~/.ssh/known_hosts:1: host.example.org,10.0.0.1
    >     ~/.ssh/known_hosts:2: [hashed name]
    >     ~/.ssh/known_hosts:3: [hashed name]
    >     ~/.ssh/known_hosts:4: host
    >     ~/.ssh/known_hosts:5: [host]:2222
    > Are you sure you want to continue connecting (yes/no/[fingerprint])?
    
    feedback and ok markus@
    
    OpenBSD-Commit-ID: f6f58a77b49f1368b5883b3a1f776447cfcc7ef4

commit 819b44e8b9af6ce18d3ec7505b9f461bf7991a1f
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Thu Nov 12 22:38:57 2020 +0000

    upstream: Prevent integer overflow when ridiculously large
    
    ConnectTimeout is specified, capping the effective value (for most platforms)
    at 24 days. bz#3229, ok djm@
    
    OpenBSD-Commit-ID: 62d4c4b7b87d111045f8e9f28b5b532d17ac5bc0

commit add926dd1bbe3c4db06e27cab8ab0f9a3d00a0c2
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Nov 11 05:22:32 2020 +0000

    upstream: fix logic error that broke URI parsing in ProxyJump
    
    directives; ok dtucker@
    
    OpenBSD-Commit-ID: 96d48839b1704882a0e9a77898f5e14b2d222705

commit 4340dd43928dfe746cb7e75fe920b63c0d909a9a
Author: claudio@openbsd.org <claudio@openbsd.org>
Date:   Tue Nov 10 07:46:20 2020 +0000

    upstream: Free the previously allocated msg buffer after writing it
    
    out. OK djm@
    
    OpenBSD-Commit-ID: 18c055870fc75e4cb9f926c86c7543e2e21d7fa4

commit fcf429a4c69d30d8725612a55b37181594da8ddf
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Nov 11 12:30:46 2020 +1100

    Prevent excessively long username going to PAM.
    
    This is a mitigation for a buffer overflow in Solaris' PAM username
    handling (CVE-2020-14871), and is only enabled for Sun-derived PAM
    implementations.  This is not a problem in sshd itself, it only
    prevents sshd from being used as a vector to attack Solaris' PAM.
    It does not prevent the bug in PAM from being exploited via some other
    PAM application.
    
    Based on github PR#212 from Mike Scott but implemented slightly
    differently.  ok tim@ djm@

commit 10dce8ff68ef615362cfcab0c0cc33ce524e7682
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Nov 8 23:19:03 2020 +0000

    upstream: unbreak; missing NULL check
    
    OpenBSD-Commit-ID: 6613dfab488123f454d348ef496824476b8c11c0

commit d5a0cd4fc430c8eda213a4010a612d4778867cd9
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Nov 8 22:37:24 2020 +0000

    upstream: when requesting a security key touch on stderr, inform the
    
    user once the touch has been recorded; requested by claudio@ ok markus@
    
    OpenBSD-Commit-ID: 3b76ee444490e546b9ea7f879e4092ee0d256233

commit 292bcb2479deb27204e3ff796539c003975a5f7a
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Nov 9 00:33:35 2020 +1100

    Remove preprocessor directive from log macro calls.
    
    Preprocessor directives inside macro calls, such as the new log macros,
    are undefined behaviour and do not work with, eg old GCCs.  Put the
    entire log call inside the ifdef for OPENSSL_HAS_NISTP521.

commit 71693251b7cbb7dd89aaac18815147124732d0d3
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sun Nov 8 12:10:20 2020 +0000

    upstream: Add a comment documenting the source of the moduli group
    
    sizes.
    
    OpenBSD-Commit-ID: aec0725ce607630caaa62682624c6763b350391c

commit 4d94b031ff88b015f0db57e140f481bff7ae1a91
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sun Nov 8 11:46:12 2020 +0000

    upstream: Replace WITH_OPENSSL ifdefs in log calls with a macro.
    
    The log calls are themselves now macros, and preprocessor directives inside
    macro arguments are undefined behaviour which some compilers (eg old GCCs)
    choke on.  It also makes the code tidier.  ok deraadt@
    
    OpenBSD-Commit-ID: cc12a9029833d222043aecd252d654965c351a69

commit 6d2564b94e51184eb0b73b97d13a36ad50b4f810
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Nov 6 17:11:16 2020 +1100

    Fix function body for variadic macro test.
    
    AC_LANG_PROGRAM puts its second argument inside main() so we don't need
    to do it ourselves.

commit 586f9bd2f5980e12f8cf0d3c2a761fa63175da52
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Nov 6 16:53:24 2020 +1100

    Remove AC_PROC_CC_C99 obsoleted in autoconf 2.70.
    
    Since we only use it to make sure we can handle variadic macros,
    explicitly check only for that.  with & ok djm@

commit a019e353df04de1b2ca78d91b39c393256044ad7
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Nov 6 13:56:41 2020 +1100

    Replace AC_TRY_COMPILE obsoleted in autoconf 2.70.
    
    Replace with the equivalent AC_COMPILE_IFELSE.

commit 771b7795c0ef6a2fb43b4c6c66b615c2085cb9cd
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Nov 6 13:55:33 2020 +1100

    Move AC_PROG_CC_C99 to immediately afer AC_PROG_CC.
    
    This puts the related C version selection output in the same place.

commit e5591161f21ab493c6284a85ac3c0710ad94998f
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Nov 6 13:54:17 2020 +1100

    AC_CHECK_HEADER() is obsoleted in autoconf 2.70.
    
    Replace with the non-obsoleted AC_CHECK_HEADERS().

commit 05bcd0cadf160fd4826a2284afa7cba6ec432633
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Nov 3 22:53:12 2020 +0000

    upstream: fold consecutive '*' wildcards to mitigate combinatorial
    
    explosion of recursive searches; ok dtucker
    
    OpenBSD-Commit-ID: d18bcb39c40fb8a1ab61153db987e7d11dd3792b

commit 7d680448db5858dc76307663f78d0b8d3c2b4a3d
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Oct 30 01:50:07 2020 +0000

    upstream: print reason in fatal error message when
    
    kex_assemble_namelist() fails
    
    OpenBSD-Commit-ID: a9975ee8db6c98d6f32233d88051b2077ca63dab

commit 95d1109fec7e89ad21f2a97e92bde1305d32a353
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Oct 29 03:13:06 2020 +0000

    upstream: fix sshd_config SetEnv directive inside Match blocks; part of
    
    github PR#201 from github user manuelm
    
    OpenBSD-Commit-ID: 9772e3748abff3ad65ae8fc43d026ed569b1d2bc

commit b12b835dc022ba161afe68348e05a83dfbcb1515
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Oct 29 03:01:18 2020 +0000

    upstream: fix type of nid in type_bits_valid(); github PR#202 from
    
    github user thingsconnected
    
    OpenBSD-Commit-ID: 769d2b040dec7ab32d323daf54b854dd5dcb5485

commit 1a14c13147618144d1798c36a588397ba9008fcc
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Oct 29 02:52:43 2020 +0000

    upstream: whitespace; no code change
    
    OpenBSD-Commit-ID: efefc1c47e880887bdee8cd2127ca93177eaad79

commit 815209abfdd2991fb92ad7d2e33374916cdcbcf4
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Oct 29 02:47:23 2020 +0000

    upstream: UpdateHostkeys: fixed/better detection of host keys that
    
    exist under other names and addresses; spotted by and debugged with lots of
    help from jca@
    
    OpenBSD-Commit-ID: 5113d7f550bbd48243db1705afbf16b63792d4b7

commit a575cf44e59a65506c67bddb62a712208a7a279c
Author: Duncan Eastoe <duncan.eastoe@att.com>
Date:   Wed Oct 21 10:11:10 2020 +0100

    session.c: use "denylist" terminology
    
    Follow upstream (6d755706a0059eb9e2d63517f288b75cbc3b4701) language
    improvements in this portable-specific code.

commit 33267feaffd5d98aa56d2f0b3a99ec352effe938
Author: Damien Miller <djm@mindrot.org>
Date:   Tue Oct 27 16:46:31 2020 +1100

    Remove checks for strict POSIX mkdtemp()
    
    We needed a mkdtemp() that accepted template paths that did not
    end in XXXXXX a long time ago for KRB4, but that code is long
    deprecated. We no longer need to replace mkdtemp() for strictly
    following POSIX. ok dtucker@

commit 492d70e18bad5a8c97d05f5eddac817171e88d2c
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Oct 26 00:39:04 2020 +0000

    upstream: Minor man page fixes (capitalization, commas) identified by
    
    the manpage-l10n project via bz#3223.  feedback deraadt@, ok jmc@
    
    OpenBSD-Commit-ID: ab83af0daf18369244a72daaec6c4a58a9eb7e2c

commit eab2888cfc6cc4e2ef24bd017da9835a0f365f3f
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Oct 19 22:49:23 2020 +0000

    upstream: Adapt XMSS to new logging infrastructure. With markus@, ok
    
    djm@.
    
    OpenBSD-Commit-ID: 9c35ec3aa0f710e4e3325187ceff4fa3791686de

commit f7bd11e4941620991f3e727cd0131b01f0311a58
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Oct 19 08:07:08 2020 +0000

    upstream: fix SEGV on fatal() errors spotted by dtucker@
    
    OpenBSD-Commit-ID: 75f155a1ac61e364ed00dc379e2c42df81067ce2

commit 7715a3b171049afa1feffb1d5a1245dfac36ce99
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Oct 19 10:54:41 2020 +1100

    Use fatal_fr not fatal_r when passing r.
    
    Caught by the PAM -Werror tinderbox build.

commit 816036f142ecd284c12bb3685ae316a68d2ef190
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Oct 18 11:32:01 2020 +0000

    upstream: use the new variant log macros instead of prepending
    
    __func__ and appending ssh_err(r) manually; ok markus@
    
    OpenBSD-Commit-ID: 1f14b80bcfa85414b2a1a6ff714fb5362687ace8

commit 9e2c4f64224f68fb84c49b5182e449f94b0dc985
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Oct 18 11:21:59 2020 +0000

    upstream: variants of the log methods that append a ssherr.h string
    
    from a supplied error code; ok markus@
    
    OpenBSD-Commit-ID: aed98c4435d48d036ae6740300f6a8357b7cc0bf

commit 28cb0a4b03940d1ee576eb767a81a4113bdc917e
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Oct 18 11:14:27 2020 +0000

    upstream: remove a level of macro indirection; ok markus@
    
    OpenBSD-Commit-ID: 0c529d06e902c5d1a6b231e1bec6157f76dc67c9

commit 9cac1db52e6c4961c447910fe02cd68a3b2f9460
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Oct 18 11:13:45 2020 +0000

    upstream: add some variant log.h calls that prepend the calling
    
    function name; ok markus@
    
    OpenBSD-Commit-ID: 4be1b2e2455b271ddb7457bc195c5367644f4e48

commit d55dfed34ef6ef1f028d552a90d5f3dba8dd6f7b
Author: Damien Miller <djm@mindrot.org>
Date:   Sat Oct 17 22:55:24 2020 +1100

    missing header

commit 999d7cb79a3a73d92a6dfbf174c33da0d984c7a2
Author: Damien Miller <djm@mindrot.org>
Date:   Sat Oct 17 22:47:52 2020 +1100

    sync regress/misc/sk-dummy/fatal.c

commit 3554b4afa38b3483a3302f1be18eaa6f843bb260
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Oct 17 01:28:20 2020 +0000

    upstream: make the log functions that exit (sshlogdie(),
    
    sshfatal(), etc) have identical signatures. Makes things a bit more
    consistent...
    
    OpenBSD-Commit-ID: bd0ae124733389d7c0042e135c71ee9091362eb9

commit 616029a85ad7529b24bb8c4631d9607c0d6e7afe
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Fri Oct 16 14:34:33 2020 +0000

    upstream: add space between macro arg and punctuation;
    
    OpenBSD-Commit-ID: bb81e2ed5a77832fe62ab30a915ae67cda57633e

commit f812a36cee5727147bc897d34ab9af068dd4561e
Author: Damien Miller <djm@mindrot.org>
Date:   Sat Oct 17 12:03:34 2020 +1100

    check for and require a C99 capable compiler
    
    recent logging changes use __VA_ARGS__.

commit f9ea6515202b59a1e2d5b885cafc1b12eff33016
Author: Damien Miller <djm@mindrot.org>
Date:   Sat Oct 17 11:51:20 2020 +1100

    logging is now macros, remove function pointers

commit 0f938f998626e8359324f803157cd7c9f8f403e2
Author: Damien Miller <djm@mindrot.org>
Date:   Sat Oct 17 11:42:26 2020 +1100

    adapt sk-dummy's fatal implementation to changes

commit afbd9ec9e2dbad04834ce7ce53e58740434f32a5
Author: Damien Miller <djm@mindrot.org>
Date:   Sat Oct 17 11:33:13 2020 +1100

    fix netcat build problem

commit 793b583d097381730adaf6f68bed3c343139a013
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Oct 16 13:26:13 2020 +0000

    upstream: LogVerbose keyword for ssh and sshd
    
    Allows forcing maximum debug logging by file/function/line pattern-
    lists.
    
    ok markus@
    
    OpenBSD-Commit-ID: c294c25732d1b4fe7e345cb3e044df00531a6356

commit 752250caabda3dd24635503c4cd689b32a650794
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Oct 16 13:24:45 2020 +0000

    upstream: revised log infrastructure for OpenSSH
    
    log functions receive function, filename and line number of caller.
    We can use this to selectively enable logging via pattern-lists.
    
    ok markus@
    
    OpenBSD-Commit-ID: 51a472610cbe37834ce6ce4a3f0e0b1ccc95a349

commit acadbb3402b70f72f14d9a6930ad41be97c2f9dc
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Oct 16 02:37:12 2020 +0000

    upstream: use do_log2 instead of function pointers to different log
    
    functions
    
    OpenBSD-Commit-ID: 88077b826d348c58352a6b394755520f4e484480

commit 95b0bcfd1531d59e056ae8af27bb741391f26ab0
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Oct 14 00:55:17 2020 +0000

    upstream: make UpdateHostkeys still more conservative: refuse to
    
    proceed if one of the keys offered by the server is already in known_hosts
    under another name. This avoid collisions between address entries for
    different host aliases when CheckHostIP=yes
    
    Also, do not attempt to fix known_hosts with incomplete host/ip matches
    when there are no new or deprecated hostkeys.
    
    OpenBSD-Commit-ID: 95c19842f7c41f9bd9c92aa6441a278c0fd0c4a3

commit a336ce8c2c55547cc00e0070a18c55f30bb53fb6
Author: kn@openbsd.org <kn@openbsd.org>
Date:   Mon Oct 12 08:36:36 2020 +0000

    upstream: Zap unused family parameter from ssh_connect_direct()
    
    sshconnect.c r1.241 from 2013 made it unused;  found while reading code.
    
    OK djm
    
    OpenBSD-Commit-ID: 219ba6d7f9925d0b7992918612680399d86712b5

commit e545d94b713effab8e6c7dfabbfb76c1d84d7498
Author: Philip Hands <phil@hands.com>
Date:   Sun Oct 4 00:15:46 2020 +0200

    shift contents of long $() into filter_ids()
    
    This was prompted by the fact that posh does not deal with $()
    that contains comments where the comment includes an odd number
    of single-quotes. It seems to get befuddled into trying to find
    the matching quote.
    Regardless, making a function for filtering the unneeded ids
    seems much neater than avoiding apostrophes,
    so that's what I've done.
    
    SSH-Copy-ID-Upstream: 3dab3366a584427045c8a690a93282f02c09cf24

commit fd360174596047b52aa1cddda74d85012a03ca4b
Author: Philip Hands <phil@hands.com>
Date:   Sat Oct 3 23:15:16 2020 +0200

    combine if/elif to avoid duplication of the action
    
    SSH-Copy-ID-Upstream: 42aeb1cc53d3f7f6e78edc210fb121fda0834914

commit f7c3a39b016dd77709ecbf18da8282f967b86cd7
Author: Philip Hands <phil@hands.com>
Date:   Sat Oct 3 21:45:16 2020 +0200

    shellcheck tidyage
    
    SSH-Copy-ID-Upstream: 5b08f840e78ac544288b3983010a1b0585e966fd

commit 108676c3f26be6c873db0dd8754063699908727b
Author: Philip Hands <phil@hands.com>
Date:   Sat Oct 3 21:10:03 2020 +0200

    tidy up test of $SCRATCH_DIR creation
    
    SSH-Copy-ID-Upstream: 2d8b22d96c105d87743ffe8874887b06f8989b93

commit a9c9e91a82bc1a2cf801b4e3ef27a941dbd27717
Author: Philip Hands <phil@hands.com>
Date:   Wed Sep 16 16:13:30 2020 +0200

    add -s flag: to install keys via SFTP
    
    This is prompted by:
    
     https://bugzilla.mindrot.org/show_bug.cgi?id=3201
    
    Thanks go to Matthias Blümel for the idea, and the helpful patch, from
    which this patch grew.
    
    SSH-Copy-ID-Upstream: f7c76dc64427cd20287a6868f672423b62057614

commit f92424970c02b78852ff149378c7f2616ada4ccf
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Oct 11 22:14:38 2020 +0000

    upstream: UpdateHostkeys: check for keys under other names
    
    Stop UpdateHostkeys from automatically removing deprecated keys from
    known_hosts files if the same keys exist under a different name or
    address to the host that is being connected to.
    
    This avoids UpdateHostkeys from making known_hosts inconsistent in
    some cases. For example, multiple host aliases sharing address-based
    known_hosts on different lines, or hosts that resolves to multiple
    addresses.
    
    ok markus@
    
    OpenBSD-Commit-ID: 6444a705ba504c3c8ccddccd8d1b94aa33bd11c1

commit d98f14b5328922ae3085e07007d820c4f655b57a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Oct 11 22:13:37 2020 +0000

    upstream: UpdateHostkeys: better CheckHostIP handling
    
    When preparing to update the known_hosts file, fully check both
    entries for both the host and the address (if CheckHostIP enabled)
    and ensure that, at the end of the operation, entries for both are
    recorded.
    
    Make sure this works with HashKnownHosts too, which requires maintaining
    a list of entry-types seen across the whole file for each key.
    
    ok markus@
    
    OpenBSD-Commit-ID: 374dc263103f6b343d9671f87dbf81ffd0d6abdd

commit af5941ae9b013aac12585e84c4cf494f3728982f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Oct 11 22:12:44 2020 +0000

    upstream: UpdateHostkeys: better detect manual host entries
    
    Disable UpdateHostkeys if the known_hosts line has more than two
    entries in the pattern-list. ssh(1) only writes "host" or "host,ip"
    lines so anything else was added by a different tool or by a human.
    
    ok markus@
    
    OpenBSD-Commit-ID: e434828191fb5f3877d4887c218682825aa59820

commit 6247812c76f70b2245f3c23f5074665b3d436cae
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Oct 8 01:15:16 2020 +0000

    upstream: don't misdetect comma-separated hostkey names as wildcards;
    
    spotted by naddy@
    
    OpenBSD-Commit-ID: 4b874edfec7fc324a21b130bdb42f912177739ce

commit 67146c7d022a170be3cdad2f5f40259a663fb266
Author: wangxp006 <wangxiaopeng7@huawei.com>
Date:   Thu Oct 8 17:49:59 2020 +0800

    fix TEST_MALLOC_OPTIONS var

commit 3205eaa3f8883a34fa4559ddef6c90d1067c5cce
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Oct 8 00:31:05 2020 +0000

    upstream: clarify conditions for UpdateHostkeys
    
    OpenBSD-Commit-ID: 9cba714cf6aeed769f998ccbe8c483077a618e27

commit e8dfca9bfeff05de87160407fb3e6a5717fa3dcb
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Oct 7 06:38:16 2020 +0000

    upstream: remove GlobalKnownHostsFile for this test after
    
    UpdateHostkeys change
    
    OpenBSD-Regress-ID: a940ad79d59343319613ba8fc46b6ef24aa3f8e1

commit 4aa2717d7517cff4bc423a6cfba3a2defb055aea
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Oct 7 02:26:28 2020 +0000

    upstream: Disable UpdateHostkeys when hostkey checking fails
    
    If host key checking fails (i.e. a wrong host key is recorded for the
    server) and the user elects to continue (via StrictHostKeyChecking=no),
    then disable UpdateHostkeys for the session.
    
    reminded by Mark D. Baushke; ok markus@
    
    OpenBSD-Commit-ID: 98b524f121f4252309dd21becd8c4cacb0c6042a

commit 04c06d04475f1f673e9d9743710d194453fe3888
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Oct 7 02:25:43 2020 +0000

    upstream: Fix UpdateHostkeys/HashKnownHosts/CheckHostIP bug
    
    When all of UpdateHostkeys, HashKnownHosts and ChechHostIP
    were enabled and new host keys were learned, known_hosts IP
    entries were not being recorded for new host keys.
    
    reported by matthieu@ ok markus@
    
    OpenBSD-Commit-ID: a654a8290bd1c930aac509e8158cf85e42e49cb7

commit b70e33711291f3081702133175a41cccafc0212a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Oct 7 02:24:51 2020 +0000

    upstream: don't UpdateHostkeys when the hostkey is verified by the
    
    GlobalKnownHostsFile file, support only UserKnownHostsFile matches
    
    suggested by Mark D. Baushke; feedback and ok markus@
    
    OpenBSD-Commit-ID: eabb771a6add676c398d38a143a1aff5f04abbb9

commit aa623142e426ca1ab9db77b06dcc9b1b70bd102b
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Oct 7 02:22:23 2020 +0000

    upstream: revert kex->flags cert hostkey downgrade back to a plain
    
    key (commitid VtF8vozGOF8DMKVg). We now do this a simpler way that needs less
    plumbing.
    
    ok markus@
    
    OpenBSD-Commit-ID: fb92d25b216bff8c136da818ac2221efaadf18ed

commit f4f14e023cafee1cd9ebe4bb0db4029e6e1fafac
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Oct 7 02:20:35 2020 +0000

    upstream: simply disable UpdateHostkeys when a certificate
    
    successfully authenticated the host; simpler than the complicated plumbing
    via kex->flags we have now.
    
    ok markus@
    
    OpenBSD-Commit-ID: 80e39644eed75717d563a7f177e8117a0e14f42c

commit e79957e877db42c4c68fabcf6ecff2268e53acb5
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Oct 7 02:18:45 2020 +0000

    upstream: disable UpdateHostkeys by default if VerifyHostKeyDNS is
    
    enabled; suggested by Mark D. Baushke
    
    OpenBSD-Commit-ID: 85a1b88592c81bc85df7ee7787dbbe721a0542bf

commit 3d4c2016bae1a6f14b48c1150a4c79ca4c9968bd
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Oct 6 07:12:04 2020 +0000

    upstream: Agent protocol draft is now at rev 4. ok djm@
    
    OpenBSD-Commit-ID: 8c01ea3aae48aab45e01b7421b0fca2dad5e7837

commit af889a40ffc113af9105c03d7b32131eb4372d50
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Oct 4 09:45:01 2020 +0000

    upstream: when ordering host key algorithms in the client, consider
    
    the ECDSA key subtype; ok markus@
    
    OpenBSD-Commit-ID: 3097686f853c61ff61772ea35f8b699931392ece

commit 2d39fc9f7e039351daa3d6aead1538ac29258add
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sun Oct 4 03:04:02 2020 +0000

    upstream: Allow full range of UIDs and GIDs for sftp chown and
    
    chgrp on 32bit platforms instead of being limited by LONG_MAX.  bz#3206,
    found by booking00 at sina.cn, ok markus@
    
    OpenBSD-Commit-ID: 373b7bbf1f15ae482d39567ce30d18b51c9229b5

commit 396d32f3a1a16e54df2a76b2a9b237868580dcbe
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Oct 3 09:22:26 2020 +0000

    upstream: There are lots of place where we want to redirect stdin,
    
    stdout and/or stderr to /dev/null. Factor all these out to a single
    stdfd_devnull() function that allows selection of which of these to redirect.
    ok markus@
    
    OpenBSD-Commit-ID: 3033ba5a4c47cacfd5def020d42cabc52fad3099

commit 1286981d08b8429a64613215ce8bff3f6b32488a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Oct 3 08:30:47 2020 +0000

    upstream: enable UpdateHostkeys by default when the configuration
    
    has not overridden UserKnownHostsFile; ok markus@ "The timing is perfect"
    deraadt@
    
    OpenBSD-Commit-ID: 62df71c9c5242da5763cb473c2a2deefbd0cef60

commit 332f21537293d66508f7342dc643bc7fe45f0f69
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Oct 3 08:12:59 2020 +0000

    upstream: disable UpdateHostkeys when a wildcard hostname pattern
    
    is encountered or when a certificate host key is in use. feedback/ok markus@
    
    OpenBSD-Commit-ID: b6e5575af7e6732322be82ec299e09051a5413bd

commit 13cee44ef907824083d89cb9395adbbd552e46c1
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Oct 3 08:11:28 2020 +0000

    upstream: record when the host key checking code downgrades a
    
    certificate host key to a plain key. This occurs when the user connects to a
    host with a certificate host key but no corresponding CA key configured in
    known_hosts; feedback and ok markus@
    
    OpenBSD-Commit-ID: 2ada81853ff9ee7824c62f440bcf4ad62030c901

commit 12ae8f95e2e0c273e9e7ef930b01a028ef796a3f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Oct 3 04:15:06 2020 +0000

    upstream: prefer ed25519 signature algorithm variants to ECDSA; ok
    
    markus@
    
    OpenBSD-Commit-ID: 82187926fca96d35a5b5afbc091afa84e0966e5b

commit e5ed753add7aa8eed6b167e44db6240a76404db2
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Oct 3 03:40:38 2020 +0000

    upstream: want time.h here too
    
    OpenBSD-Commit-ID: fafee8f1108c64ad8b282f9a1ed5ea830d8c58a7

commit 66bd9fdf8b7762eb6a85cabbb1ae4ed955679f60
Author: deraadt@openbsd.org <deraadt@openbsd.org>
Date:   Sat Oct 3 02:18:33 2020 +0000

    upstream: split introductory paragraph, and insert ominous words about
    
    the glob issue, which cannot be fully fixed and really requires completely
    replacing scp with a completely different subsystem. team effort to find the
    right words..
    
    OpenBSD-Commit-ID: 58e1f72d292687f63eb357183036ee242513691c

commit 86cc8ce002ea10e88a4c5d622a8fdfab8a7d261f
Author: Damien Miller <djm@mindrot.org>
Date:   Sat Oct 3 13:38:55 2020 +1000

    use relative rather than system include here

commit 922cfac5ed5ead9f796f7d39f012dd653dc5c173
Author: Damien Miller <djm@mindrot.org>
Date:   Sat Oct 3 13:38:41 2020 +1000

    add some openbsd-compat licenses we missed

commit ce941c75ea9cd6c358508a5b206809846c8d9240
Author: Philip Hands <phil@hands.com>
Date:   Sat Oct 3 00:20:07 2020 +0200

    un-nest $() to make ksh cheerful

commit 18ea5f4b88e303677d2003b95e5cb864b439e442
Author: Philip Hands <phil@hands.com>
Date:   Fri Oct 2 21:30:10 2020 +0200

    ksh doesn't grok 'local'
    
    and AFAICT it's not actually doing anything useful in the code, so let's
    see how things go without it.

commit d9e727dcc04a52caaac87543ea1d230e9e6b5604
Author: Oleg <Fallmay@users.noreply.github.com>
Date:   Thu Oct 1 12:09:08 2020 +0300

    Fix `EOF: command not found` error in ssh-copy-id

commit a1a856d50c89be3206f320baa4bfb32fff4e826f
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Sep 30 09:11:39 2020 +0000

    upstream: Regen moduli.
    
    OpenBSD-Commit-ID: 04967f8c43e9854ac34b917bcd6f5ac96c53a693

commit fa1fe3ead7069d90d3c67d62137ad66acfcc9f48
Author: HARUYAMA Seigo <haruyama@unixuser.org>
Date:   Sun Sep 27 20:06:20 2020 +0900

    Restore first section title of INSTALL

commit 279261e1ea8150c7c64ab5fe7cb4a4ea17acbb29
Author: Damien Miller <djm@mindrot.org>
Date:   Sun Sep 27 17:25:01 2020 +1000

    update version numbers

commit 58ca6ab6ff035ed12b5078e3e9c7199fe72c8587
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Sep 27 07:22:05 2020 +0000

    upstream: openssh 8.4
    
    OpenBSD-Commit-ID: a29e5b372d2c00e297da8a35a3b87c9beb3b4a58

commit 9bb8a303ce05ff13fb421de991b495930be103c3
Author: Damien Miller <djm@mindrot.org>
Date:   Tue Sep 22 10:07:43 2020 +1000

    sync with upstream ssh-copy-id rev f0da1a1b7

commit 0a4a5571ada76b1b012bec9cf6ad1203fc19ec8d
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Sep 21 07:29:09 2020 +0000

    upstream: close stdin when forking after authentication too; ok markus
    
    OpenBSD-Commit-ID: 43db17e4abc3e6b4a7b033aa8cdab326a7cb6c24

commit d14fe25e6c3b89f8af17e2894046164ac3b45688
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Sep 20 23:31:46 2020 +0000

    upstream: close stdout/stderr after "ssh -f ..." forking
    
    bz#3137, ok markus
    
    OpenBSD-Commit-ID: e2d83cc4dea1665651a7aa924ad1ed6bcaaab3e2

commit 53a33a0d745179c02108589e1722457ca8ae4372
Author: Damien Miller <djm@mindrot.org>
Date:   Sun Sep 20 15:57:09 2020 +1000

    .depend

commit 107eb3eeafcd390e1fa7cc7672a05e994d14013e
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Sep 20 05:47:25 2020 +0000

    upstream: cap channel input buffer size at 16MB; avoids high memory use
    
    when peer advertises a large window but is slow to consume the data we send
    (e.g. because of a slow network)
    
    reported by Pierre-Yves David
    
    fix with & ok markus@
    
    OpenBSD-Commit-ID: 1452771f5e5e768876d3bfe2544e3866d6ade216

commit acfe2ac5fe033e227ad3a56624fbbe4af8b5da04
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Sep 18 22:02:53 2020 +1000

    libfido2 1.5.0 is recommended

commit 52a03e9fca2d74eef953ddd4709250f365ca3975
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Sep 18 08:16:38 2020 +0000

    upstream: handle multiple messages in a single read()
    
    PR#183 by Dennis Kaarsemaker; feedback and ok markus@
    
    OpenBSD-Commit-ID: 8570bb4d02d00cf70b98590716ea6a7d1cce68d1

commit dc098405b2939146e17567a25b08fc6122893cdf
Author: pedro martelletto <pedro@ambientworks.net>
Date:   Fri Sep 18 08:57:29 2020 +0200

    configure.ac: add missing includes
    
    when testing, make sure to include the relevant header files that
    declare the types of the functions used by the test:
    
    - stdio.h for printf();
    - stdlib.h for exit();
    - string.h for strcmp();
    - unistd.h for unlink(), _exit(), fork(), getppid(), sleep().

commit b3855ff053f5078ec3d3c653cdaedefaa5fc362d
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Sep 18 05:23:03 2020 +0000

    upstream: tweak the client hostkey preference ordering algorithm to
    
    prefer the default ordering if the user has a key that matches the
    best-preference default algorithm.
    
    feedback and ok markus@
    
    OpenBSD-Commit-ID: a92dd7d7520ddd95c0a16786a7519e6d0167d35f

commit f93b187ab900c7d12875952cc63350fe4de8a0a8
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Sep 18 14:55:48 2020 +1000

    control over the colours in gnome-ssh-askpass[23]
    
    Optionally set the textarea colours via $GNOME_SSH_ASKPASS_FG_COLOR and
    $GNOME_SSH_ASKPASS_BG_COLOR. These accept the usual three or six digit
    hex colours.

commit 9d3d36bdb10b66abd1af42e8655502487b6ba1fa
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Sep 18 14:50:38 2020 +1000

    focus improvement for gnome-ssh-askpass[23]
    
    When serving a SSH_ASKPASS_PROMPT=none information dialog, ensure
    then <enter> doesn't immediately close the dialog. Instead, require an
    explicit <tab> to reach the close button, or <esc>.

commit d6f507f37e6c75a899db0ef8224e72797c5563b6
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Sep 16 03:07:31 2020 +0000

    upstream: Remove unused buf, last user was removed when switching
    
    to the sshbuf API. Patch from Sebastian Andrzej Siewior.
    
    OpenBSD-Commit-ID: 250fa17f0cec01039cc4abd95917d9746e24c889

commit c3c786c3a0973331ee0922b2c51832a3b8d7f20f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Sep 9 21:57:27 2020 +0000

    upstream: For the hostkey confirmation message:
    
    > Are you sure you want to continue connecting (yes/no/[fingerprint])?
    
    compare the fingerprint case sensitively; spotted Patrik Lundin
    ok dtucker
    
    OpenBSD-Commit-ID: 73097afee1b3a5929324e345ba4a4a42347409f2

commit f2950baf0bafe6aa20dfe2e8d1ca4b23528df617
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Sep 11 14:45:23 2020 +1000

    New config-build-time dependency on automake.

commit 600c1c27abd496372bd0cf83d21a1c119dfdf9a5
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sun Sep 6 21:56:36 2020 +1000

    Add aclocal.m4 and config.h.in~ to .gitignore.
    
    aclocal.m4 is now generated by autoreconf.

commit 4bf7e1d00b1dcd3a6b3239f77465c019e61c6715
Author: Sebastian Andrzej Siewior <sebastian@breakpoint.cc>
Date:   Sat Sep 5 17:50:03 2020 +0200

    Quote the definition of OSSH_CHECK_HEADER_FOR_FIELD
    
    autoreconf complains about underquoted definition of
    OSSH_CHECK_HEADER_FOR_FIELD after aclocal.m4 has been and now is beeing
    recreated.
    
    Quote OSSH_CHECK_HEADER_FOR_FIELD as suggested.
    
    Signed-off-by: Sebastian Andrzej Siewior <sebastian@breakpoint.cc>

commit a2f3ae386b5f7938ed3c565ad71f30c4f7f010f1
Author: Sebastian Andrzej Siewior <sebastian@breakpoint.cc>
Date:   Sat Sep 5 17:50:02 2020 +0200

    Move the local m4 macros
    
    The `aclocal' step is skipped during `autoreconf' because aclocal.m4 is
    present.
    Move the current aclocal.m4 which contains local macros into the m4/
    folder. With this change the aclocal.m4 will be re-created during
    changes to the m4/ macro.
    This is needed so the `aclocal' can fetch m4 macros from the system if
    they are references in the configure script. This is a prerequisite to
    use PKG_CHECK_MODULES.
    
    Signed-off-by: Sebastian Andrzej Siewior <sebastian@breakpoint.cc>

commit 8372bff3a895b84fd78a81dc39da10928b662f5a
Author: Sebastian Andrzej Siewior <sebastian@breakpoint.cc>
Date:   Sat Sep 5 17:50:01 2020 +0200

    Remove HAVE_MMAP and BROKEN_MMAP
    
    BROKEN_MMAP is no longer defined since commit
       1cfd5c06efb12 ("Remove portability support for mmap")
    
    this commit also removed other HAVE_MMAP user. I didn't find anything
    that defines HAVE_MMAP. The check does not trigger because compression
    on server side is by default COMP_DELAYED (2) so it never triggers.
    
    Remove remaining HAVE_MMAP and BROKEN_MMAP bits.
    
    Signed-off-by: Sebastian Andrzej Siewior <sebastian@breakpoint.cc>

commit bbf20ac8065905f9cb9aeb8f1df57fcab52ee2fb
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Sep 9 03:10:21 2020 +0000

    upstream: adapt to SSH_SK_VERSION_MAJOR crank
    
    OpenBSD-Regress-ID: 0f3e76bdc8f9dbd9d22707c7bdd86051d5112ab8

commit 9afe2a150893b20bdf9eab764978d817b9a7b783
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Aug 28 03:17:13 2020 +0000

    upstream: Ensure that address/mask mismatches are flagged at
    
    config-check time. ok djm@
    
    OpenBSD-Regress-ID: 8f5f4c2c0bf00e6ceae7a1755a444666de0ea5c2

commit c76773524179cb654ff838dd43ba1ddb155bafaa
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Sep 9 03:08:01 2020 +0000

    upstream: when writing an attestation blob for a FIDO key, record all
    
    the data needed to verify the attestation. Previously we were missing the
    "authenticator data" that is included in the signature.
    
    spotted by Ian Haken
    feedback Pedro Martelletto and Ian Haken; ok markus@
    
    OpenBSD-Commit-ID: 8439896e63792b2db99c6065dd9a45eabbdb7e0a

commit c1c44eeecddf093a7983bd91e70b446de789b363
Author: pedro martelletto <pedro@ambientworks.net>
Date:   Tue Sep 1 17:01:55 2020 +0200

    configure.ac: fix libfido2 back-compat
    
    - HAVE_FIDO_CRED_PROD -> HAVE_FIDO_CRED_PROT;
    - check for fido_dev_get_touch_begin(), so that
      HAVE_FIDO_DEV_GET_TOUCH_BEGIN gets defined.

commit 785f0f315bf7ac5909e988bb1ac3e019fb5e1594
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Aug 31 04:33:17 2020 +0000

    upstream: refuse to add verify-required (PINful) FIDO keys to
    
    ssh-agent until the agent supports them properly
    
    OpenBSD-Commit-ID: 125bd55a8df32c87c3ec33c6ebe437673a3d037e

commit 39e88aeff9c7cb6862b37ad1a87a03ebbb38c233
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Aug 31 00:17:41 2020 +0000

    upstream: Add RCS IDs to the few files that are missing them; from
    
    Pedro Martelletto
    
    OpenBSD-Commit-ID: 39aa37a43d0c75ec87f1659f573d3b5867e4a3b3

commit 72730249b38a676da94a1366b54a6e96e6928bcb
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Aug 28 03:15:52 2020 +0000

    upstream: Check that the addresses supplied to Match Address and
    
    Match LocalAddress are valid when parsing in config-test mode.  This will
    catch address/mask mismatches before they cause problems at runtime. Found by
    Daniel Stocker, ok djm@
    
    OpenBSD-Commit-ID: 2d0b10c69fad5d8fda4c703e7c6804935289378b

commit 2a3a9822311a565a9df48ed3b6a3c972f462bd7d
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Thu Aug 27 12:34:00 2020 +0000

    upstream: sentence fix; from pedro martelletto
    
    OpenBSD-Commit-ID: f95b84a1e94e9913173229f3787448eea2f8a575

commit ce178be0d954b210c958bc2b9e998cd6a7aa73a9
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Aug 27 20:01:52 2020 +1000

    tweak back-compat for older libfido2

commit d6f45cdde031acdf434bbb27235a1055621915f4
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Aug 27 09:46:04 2020 +0000

    upstream: debug()-print a little info about FIDO-specific key
    
    fields via "ssh-keygen -vyf /path/key"
    
    OpenBSD-Commit-ID: cf315c4fe77db43947d111b00155165cb6b577cf

commit b969072cc3d62d05cb41bc6d6f3c22c764ed932f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Aug 27 09:43:28 2020 +0000

    upstream: skip a bit more FIDO token selection logic when only a
    
    single token is attached.
    
    with Pedro Martelletto
    
    OpenBSD-Commit-ID: e4a324bd9814227ec1faa8cb619580e661cca9ac

commit 744df42a129d7d7db26947b7561be32edac89f88
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Thu Aug 27 06:15:22 2020 +0000

    upstream: tweak previous;
    
    OpenBSD-Commit-ID: 92714b6531e244e4da401b2defaa376374e24be7

commit e32479645ce649b444ba5c6e7151304306a09654
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Aug 27 03:55:22 2020 +0000

    upstream: adapt to API changes
    
    OpenBSD-Regress-ID: 5f147990cb67094fe554333782ab268a572bb2dd

commit bbcc858ded3fbc46abfa7760e40389e3ca93884c
Author: Damien Miller <djm@mindrot.org>
Date:   Thu Aug 27 12:37:12 2020 +1000

    degrade semi-gracefully when libfido2 is too old

commit 9cbbdc12cb6a2ab1e9ffe9974cca91d213c185c2
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Aug 27 01:15:36 2020 +0000

    upstream: dummy firmware needs to match API version numner crank (for
    
    verify-required resident keys) even though it doesn't implement this feature
    
    OpenBSD-Regress-ID: 86579ea2891e18e822e204413d011b2ae0e59657

commit c1e76c64956b424ba260fd4eec9970e5b5859039
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Aug 27 02:11:09 2020 +0000

    upstream: remove unreachable code I forgot to delete in r1.334
    
    OpenBSD-Commit-ID: 9ed6078251a0959ee8deda443b9ae42484fd8b18

commit 0caff05350bd5fc635674c9e051a0322faba5ae3
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Aug 27 01:08:45 2020 +0000

    upstream: Request PIN ahead of time for certain FIDO actions
    
    When we know that a particular action will require a PIN, such as
    downloading resident keys or generating a verify-required key, request
    the PIN before attempting it.
    
    joint work with Pedro Martelletto; ok markus@
    
    OpenBSD-Commit-ID: 863182d38ef075bad1f7d20ca485752a05edb727

commit b649b3daa6d4b8ebe1bd6de69b3db5d2c03c9af0
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Aug 27 01:08:19 2020 +0000

    upstream: preserve verify-required for resident FIDO keys
    
    When downloading a resident, verify-required key from a FIDO token,
    preserve the verify-required in the private key that is written to
    disk. Previously we weren't doing that because of lack of support
    in the middleware API.
    
    from Pedro Martelletto; ok markus@ and myself
    
    OpenBSD-Commit-ID: 201c46ccdd227cddba3d64e1bdbd082afa956517

commit 642e06d0df983fa2af85126cf4b23440bb2985bf
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Aug 27 01:07:51 2020 +0000

    upstream: major rework of FIDO token selection logic
    
    When PINs are in use and multiple FIDO tokens are attached to a host, we
    cannot just blast requests at all attached tokens with the PIN specified
    as this will cause the per-token PIN failure counter to increment. If
    this retry counter hits the token's limit (usually 3 attempts), then the
    token will lock itself and render all (web and SSH) of its keys invalid.
    We don't want this.
    
    So this reworks the key selection logic for the specific case of
    multiple keys being attached. When multiple keys are attached and the
    operation requires a PIN, then the user must touch the key that they
    wish to use first in order to identify it.
    
    This may require multiple touches, but only if there are multiple keys
    attached AND (usually) the operation requires a PIN. The usual case of a
    single key attached should be unaffected.
    
    Work by Pedro Martelletto; ok myself and markus@
    
    OpenBSD-Commit-ID: 637d3049ced61b7a9ee796914bbc4843d999a864

commit 801c9f095e6d8b7b91aefd98f5001c652ea13488
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Aug 27 01:07:09 2020 +0000

    upstream: support for requiring user verified FIDO keys in sshd
    
    This adds a "verify-required" authorized_keys flag and a corresponding
    sshd_config option that tells sshd to require that FIDO keys verify the
    user identity before completing the signing/authentication attempt.
    Whether or not user verification was performed is already baked into the
    signature made on the FIDO token, so this is just plumbing that flag
    through and adding ways to require it.
    
    feedback and ok markus@
    
    OpenBSD-Commit-ID: 3a2313aae153e043d57763d766bb6d55c4e276e6

commit 9b8ad93824c682ce841f53f3b5762cef4e7cc4dc
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Aug 27 01:06:18 2020 +0000

    upstream: support for user-verified FIDO keys
    
    FIDO2 supports a notion of "user verification" where the user is
    required to demonstrate their identity to the token before particular
    operations (e.g. signing). Typically this is done by authenticating
    themselves using a PIN that has been set on the token.
    
    This adds support for generating and using user verified keys where
    the verification happens via PIN (other options might be added in the
    future, but none are in common use now). Practically, this adds
    another key generation option "verify-required" that yields a key that
    requires a PIN before each authentication.
    
    feedback markus@ and Pedro Martelletto; ok markus@
    
    OpenBSD-Commit-ID: 57fd461e4366f87c47502c5614ec08573e6d6a15

commit 1196d7f49d4fbc90f37e550de3056561613b0960
Author: cheloha@openbsd.org <cheloha@openbsd.org>
Date:   Wed Aug 12 01:23:45 2020 +0000

    upstream: ssh-keyscan(1): simplify conloop() with timercmp(3),
    
    timersub(3); ok djm@
    
    OpenBSD-Commit-ID: a102acb544f840d33ad73d40088adab4a687fa27

commit d0a195c89e26766d3eb8f3e4e2a00ebc98b57795
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Aug 11 09:49:57 2020 +0000

    upstream: let ssh_config(5)'s AddKeysToAgent keyword accept a time
    
    limit for keys in addition to its current flag options. Time-limited keys
    will automatically be removed from ssh-agent after their expiry time has
    passed; ok markus@
    
    OpenBSD-Commit-ID: 792e71cacbbc25faab5424cf80bee4a006119f94

commit e9c2002891a7b8e66f4140557a982978f372e5a3
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Aug 11 09:45:54 2020 +0000

    upstream: let the "Confirm user presence for key ..." ssh-askpass
    
    notification respect $SSH_ASKPASS_REQUIRE; ok markus@
    
    OpenBSD-Commit-ID: 7c1a616b348779bda3b9ad46bf592741f8e206c1

commit eaf8672b1b52db2815a229745f4e4b08681bed6d
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Aug 21 00:04:13 2020 +1000

    Remove check for 'ent' command.
    
    It was added in 8d1fd57a9 for measuring entropy of ssh_prng_cmds which
    has long since been removed and there are no other references to it.

commit 05c215de8d224e094a872d97d45f37f60c06206b
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Aug 17 21:34:32 2020 +1000

    Wrap stdint.h include in ifdef HAVE_STDINT_H.

commit eaf2765efe8bc74feba85c34295d067637fc6635
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Aug 10 13:24:09 2020 +1000

    sync memmem.c with OpenBSD

commit ed6bef77f5bb5b8f9ca2914478949e29f2f0a780
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Aug 7 17:12:16 2020 +1000

    Always send any PAM account messages.
    
    If the PAM account stack reaturns any messages, send them to the user
    not just if the check succeeds.  bz#2049, ok djm@

commit a09e98dcae1e26f026029b7142b0e0d10130056f
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Aug 7 15:37:37 2020 +1000

    Output test debug logs on failure.

commit eb122b1eebe58b29a83a507ee814cbcf8aeded1b
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Aug 7 15:11:42 2020 +1000

    Add ability to specify exact test target.

commit c2ec7a07f8caabb4d8e00c66e7cd46bf2cd1e922
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Aug 7 14:21:15 2020 +1000

    Document --without-openssl and --without-zlib.

commit 651bb3a31949bbdc3a78b2ede95a77bce0c72984
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Aug 7 14:15:11 2020 +1000

    Add without-openssl without-zlib test target.

commit 9499f2bb01dc1032ae155999b2d7764b9491341f
Author: Stefan Schindler <dns2utf8@estada.ch>
Date:   Wed Aug 5 19:00:52 2020 +0200

    Add CI with prepare script
    
    * Only use heimdal kerberos implementation
    * Fetch yubico/libfido2 (see: https://github.com/Yubico/libfido2)
    * Add one target for
        * all features
        * each feature alone
        * no features

commit ea1f649046546a860f68b97ddc3015b7e44346ca
Author: Damien Miller <djm@mindrot.org>
Date:   Wed Aug 5 08:58:57 2020 +1000

    support NetBSD's utmpx.ut_ss address field
    
    bz#960, ok dtucker

commit 32c63e75a70a0ed9d6887a55fcb0e4531a6ad617
Author: Damien Miller <djm@mindrot.org>
Date:   Tue Aug 4 14:59:21 2020 +1000

    wrap a declaration in the same ifdefs as its use
    
    avoids warnings on NetBSD

commit c9e3be9f4b41fda32a2a0138d54c7a6b563bc94d
Author: Damien Miller <djm@mindrot.org>
Date:   Tue Aug 4 14:58:46 2020 +1000

    undef TAILQ_CONCAT and friends
    
    Needed for NetBSD. etc that supply these macros

commit 2d8a3b7e8b0408dfeb933ac5cfd3a58f5bac49af
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Aug 3 02:53:51 2020 +0000

    upstream: ensure that certificate extensions are lexically sorted.
    
    Previously if the user specified a custom extension then the everything would
    be in order except the custom ones. bz3198 ok dtucker markus
    
    OpenBSD-Commit-ID: d97deb90587b06cb227c66ffebb2d9667bf886f0

commit a8732d74cb8e72f0c6366015687f1e649f60be87
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Aug 3 02:43:41 2020 +0000

    upstream: allow -A to explicitly enable agent forwarding in scp and
    
    sftp. The default remains to not forward an agent, even when ssh_config
    enables it. ok jmc dtucker markus
    
    OpenBSD-Commit-ID: 36cc526aa3b0f94e4704b8d7b969dd63e8576822

commit ab9105470a83ed5d8197959a1b1f367399958ba1
Author: deraadt@openbsd.org <deraadt@openbsd.org>
Date:   Mon Aug 3 02:42:49 2020 +0000

    upstream: clang -Wimplicit-fallthrough does not recognise /*
    
    FALLTHROUGH */ comments, which is the style we currently use, and gives too
    many boring warnings. ok djm
    
    OpenBSD-Commit-ID: 07b5031e9f49f2b69ac5e85b8da4fc9e393992a0

commit ced327b9fb78c94d143879ef4b2a02cbc5d38690
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jul 31 04:19:37 2020 +0000

    upstream: Also compare username when checking for JumpHost loops.
    
    bz#3057, ok djm@
    
    OpenBSD-Commit-ID: 9bbc1d138adb34c54f3c03a15a91f75dbf418782

commit ae7527010c44b3376b85d036a498f136597b2099
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Jul 31 15:19:04 2020 +1000

    Remove AC_REVISION.
    
    It hasn't been useful since we switched to git in 2014.  ok djm@

commit 89fc3f414be0ce4e8008332a9739a7d721269e50
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Jul 28 19:40:30 2020 +1000

    Use argv in OSSH_CHECK_CFLAG_COMPILE test.
    
    configure.ac is not detecting -Wextra in compilers that implement the
    option. The problem is that -Wextra implies -Wunused-parameter, and the
    C excerpt used by aclocal.m4 does not use argv.  Patch from pedro at
    ambientworks.net, ok djm@

commit 62c81ef531b0cc7ff655455dd34f5f0c94f48e82
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Jul 20 22:12:07 2020 +1000

    Skip ECDSA-SK webauthn test when built w/out ECC

commit 3ec9a6d7317236a9994887d8bd5d246af403a00d
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Jul 20 13:09:25 2020 +1000

    Add ssh-sk-helper and manpage to RPM spec file
    
    Based on patch from Fabio Pedretti

commit a2855c048b3f4b17d8787bd3f24232ec0cd79abe
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jul 17 07:09:24 2020 +0000

    upstream: Add %k to the TOKENs for Match Exec for consistency with
    
    the other keywords that recently got %k.
    
    OpenBSD-Commit-ID: 1857d1c40f270cbc254fca91e66110641dddcfdb

commit 69860769fa9f4529d8612ec055ae11912f7344cf
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Fri Jul 17 05:59:05 2020 +0000

    upstream: fix macro slip in previous;
    
    OpenBSD-Commit-ID: 624e47ab209450ad9ad5c69f54fa69244de5ed9a

commit 40649bd0822883b684183854b16d0b8461d5697b
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jul 17 07:10:24 2020 +0000

    upstream: Add test for '%k' (HostKeyAlias) TOKEN.
    
    OpenBSD-Regress-ID: 8ed1ba1a811790031aad3fcea860a34ad7910456

commit 6736fe680704a3518cb4f3f8f6723b00433bd3dd
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jul 17 03:26:58 2020 +0000

    upstream: Add tests for expansions on UserKnownHostsFile.
    
    OpenBSD-Regress-ID: bccf8060306c841bbcceb1392644f906a4d6ca51

commit 287dc6396e0f9cb2393f901816dbd7f2a7dfbb5f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jul 17 03:51:32 2020 +0000

    upstream: log error message for process_write() write failures
    
    OpenBSD-Commit-ID: f733d7b3b05e3c68967dc18dfe39b9e8fad29851

commit 8df5774a42d2eaffe057bd7f293fc6a4b1aa411c
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jul 17 03:43:42 2020 +0000

    upstream: Add a '%k' TOKEN that expands to the effective HostKey of
    
    the destination.  This allows, eg, keeping host keys in individual files
    using "UserKnownHostsFile ~/.ssh/known_hosts.d/%k". bz#1654, ok djm@, jmc@
    (man page bits)
    
    OpenBSD-Commit-ID: 7084d723c9cc987a5c47194219efd099af5beadc

commit c4f239944a4351810fd317edf408bdcd5c0102d9
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jul 17 03:23:10 2020 +0000

    upstream: Add %-TOKEN, environment variable and tilde expansion to
    
    UserKnownHostsFile, allowing the file to be automagically split up in the
    configuration (eg bz#1654).  ok djm@, man page parts jmc@
    
    OpenBSD-Commit-ID: 7e1b406caf147638bb51558836a72d6cc0bd1b18

commit dbaaa01daedb423c38124a72c471982fb08a16fb
Author: solene@openbsd.org <solene@openbsd.org>
Date:   Wed Jul 15 07:50:46 2020 +0000

    upstream: - Add [-a rounds] in ssh-keygen man page and usage() -
    
    Reorder parameters list in the first usage() case - Sentence rewording
    
    ok dtucker@
    jmc@ noticed usage() missed -a flag too
    
    OpenBSD-Commit-ID: f06b9afe91cc96f260b929a56e9930caecbde246

commit 69924a92c3af7b99a7541aa544a2334ec0fb092c
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Wed Jul 15 05:40:05 2020 +0000

    upstream: start sentence with capital letter;
    
    OpenBSD-Commit-ID: ab06581d51b2b4cc1b4aab781f7f3cfa56cad973

commit 5b56bd0affea7b02b540bdbc4d1d271b0e4fc885
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Jul 17 13:15:50 2020 +1000

    detect Linux/X32 systems
    
    This is a frankenstein monster of AMD64 instructions/calling conventions
    but with a 4GB address space. Allegedly deprecated but people still run
    into it causing weird sandbox failures, e.g. bz#3085

commit 9c9ddc1391d6af8d09580a2424ab467d0a5df3c7
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Jul 15 06:43:16 2020 +0000

    upstream: Fix previous by calling the correct function.
    
    OpenBSD-Regress-ID: 821cdd1dff9c502cceff4518b6afcb81767cad5a

commit f1a4798941b4372bfe5e46f1c0f8672fe692d9e4
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Jul 15 05:36:50 2020 +0000

    upstream: Update test to match recent change in match.c
    
    OpenBSD-Regress-ID: 965bda1f95f09a765050707340c73ad755f41167

commit d7e71be4fd57b7c7e620d733cdf2333b27bfa924
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Jul 15 15:30:43 2020 +1000

    Adjust portable code to match changes in 939d787d,

commit fec89f32a84fd0aa1afc81deec80a460cbaf451a
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Jul 15 04:27:34 2020 +0000

    upstream: Add default for number of rounds (-a). ok djm@
    
    OpenBSD-Commit-ID: cb7e9aa04ace01a98e63e4bd77f34a42ab169b15

commit aaa8b609a7b332be836cd9a3b782422254972777
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jul 14 23:57:01 2020 +0000

    upstream: allow some additional control over the use of ssh-askpass
    
    via $SSH_ASKPASS_REQUIRE, including force-enable/disable. bz#69 ok markus@
    
    OpenBSD-Commit-ID: 3a1e6cbbf6241ddc4405c4246caa2c249f149eb2

commit 6368022cd4dd508671c4999a59ec5826df098530
Author: deraadt@openbsd.org <deraadt@openbsd.org>
Date:   Tue Jul 7 02:47:21 2020 +0000

    upstream: correct recently broken comments
    
    OpenBSD-Commit-ID: 964d9a88f7de1d0eedd3f8070b43fb6e426351f1

commit 6d755706a0059eb9e2d63517f288b75cbc3b4701
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Jul 5 23:59:45 2020 +0000

    upstream: some language improvements; ok markus
    
    OpenBSD-Commit-ID: 939d787d571b4d5da50b3b721fd0b2ac236acaa8

commit b0c1e8384d5e136ebdf895d1434aea7dd8661a1c
Author: markus@openbsd.org <markus@openbsd.org>
Date:   Fri Jul 3 10:12:26 2020 +0000

    upstream: update setproctitle after re-exec; ok djm
    
    OpenBSD-Commit-ID: bc92d122f9184ec2a9471ade754b80edd034ce8b

commit cd119a5ec2bf0ed5df4daff3bd14f8f7566dafd3
Author: markus@openbsd.org <markus@openbsd.org>
Date:   Fri Jul 3 10:11:33 2020 +0000

    upstream: keep ignoring HUP after fork+exec; ok djm
    
    OpenBSD-Commit-ID: 7679985a84ee5ceb09839905bb6f3ddd568749a2

commit 8af4a743693ccbea3e15fc9e93edbeb610fa94f4
Author: markus@openbsd.org <markus@openbsd.org>
Date:   Fri Jul 3 10:10:17 2020 +0000

    upstream: don't exit the listener on send_rexec_state errors; ok
    
    djm
    
    OpenBSD-Commit-ID: 57cbd757d130d3f45b7d41310b3a15eeec137d5c

commit 03da4c2b70468f04ed1c08518ea0a70e67232739
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Jul 15 04:55:47 2020 +0000

    upstream: Use $OBJ to find key files. Fixes test when run on an obj
    
    directory (on OpenBSD) or out of tree (in Portable).
    
    OpenBSD-Regress-ID: 938fa8ac86adaa527d64a305bd2135cfbb1c0a17

commit 73f20f195ad18f1cf633eb7d8be95dc1b6111eea
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Sat Jul 4 23:11:23 2020 +1000

    Wrap stdint.h in ifdef HAVE_STDINT_H.

commit aa6fa4bf3023fa0e5761cd8f4b2cd015d2de74dd
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jul 3 07:25:18 2020 +0000

    upstream: put back the mux_ctx memleak fix, but only for channels of
    
    type SSH_CHANNEL_MUX_LISTENER; Specifically SSH_CHANNEL_MUX_PROXY channels
    should not have this structure freed.
    
    OpenBSD-Commit-ID: f3b213ae60405f77439e2b06262f054760c9d325

commit d8195914eb43b20b13381f4e5a74f9f8a14f0ded
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jul 3 07:17:35 2020 +0000

    upstream: revert r1.399 - the lifetime of c->mux_ctx is more complex;
    
    simply freeing it here causes other problems
    
    OpenBSD-Commit-ID: c6fee8ca94e2485faa783839541962be2834c5ed

commit 20b5fab9f773b3d3c7f06cb15b8f69a2c081ee80
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jul 3 07:02:37 2020 +0000

    upstream: avoid tilde_expand_filename() in expanding ~/.ssh/rc - if
    
    sshd is in chroot mode, the likely absence of a password database will cause
    tilde_expand_filename() to fatal; ok dtucker@
    
    OpenBSD-Commit-ID: e20aee6159e8b79190d18dba1513fc1b7c8b7ee1

commit c8935081db35d73ee6355999142fa0776a2af912
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jul 3 06:46:41 2020 +0000

    upstream: when redirecting sshd's log output to a file, undo this
    
    redirection after the session child process is forked(); ok dtucker@
    
    OpenBSD-Commit-ID: 6df86dd653c91f5bc8ac1916e7680d9d24690865

commit 183c4aaef944af3a1a909ffa01058c65bac55748
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jul 3 06:29:57 2020 +0000

    upstream: start ClientAliveInterval bookkeeping before first pass
    
    through select() loop; fixed theoretical case where busy sshd may ignore
    timeouts from client; inspired by and ok dtucker
    
    OpenBSD-Commit-ID: 96bfc4b1f86c7da313882a84755b2b47eb31957f

commit 6fcfd303d67f16695198cf23d109a988e40eefb6
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Jul 3 15:28:27 2020 +1000

    add check for fido_cred_set_prot() to configure

commit f11b23346309e4d5138e733a49321aedd6eeaa2f
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jul 3 05:09:06 2020 +0000

    upstream: Only reset the serveralive check when we receive traffic from
    
    the server and ignore traffic from a port forwarding client, preventing a
    client from keeping a connection alive when it should be terminated.  Based
    on a patch from jxraynor at gmail.com via openssh-unix-dev and bz#2265, ok
    djm@
    
    OpenBSD-Commit-ID: a941a575a5cbc244c0ef5d7abd0422bbf02c2dcd

commit adfdbf1211914b631c038f0867a447db7b519937
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Jul 3 15:15:15 2020 +1000

    sync sys-queue.h with OpenBSD upstream
    
    needed for TAILQ_CONCAT

commit 1b90ddde49e2ff377204082b6eb130a096411dc1
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jul 3 05:08:41 2020 +0000

    upstream: fix memory leak of mux_ctx; patch from Sergiy Lozovsky
    
    via bz3189 ok dtucker
    
    OpenBSD-Commit-ID: db249bd4526fd42d0f4f43f72f7b8b7705253bde

commit 55ef3e9cbd5b336bd0f89205716924886fcf86de
Author: markus@openbsd.org <markus@openbsd.org>
Date:   Wed Jul 1 16:28:31 2020 +0000

    upstream: free kex in ssh_packet_close; ok djm semarie
    
    OpenBSD-Commit-ID: dbc181e90d3d32fd97b10d75e68e374270e070a2

commit e1c401109b61f7dbc199b5099933d579e7fc5dc9
Author: bket@openbsd.org <bket@openbsd.org>
Date:   Sat Jun 27 13:39:09 2020 +0000

    upstream: Replace TAILQ concatenation loops with TAILQ_CONCAT
    
    OK djm@
    
    OpenBSD-Commit-ID: 454b40e09a117ddb833794358970a65b14c431ef

commit 14beca57ac92d62830c42444c26ba861812dc837
Author: semarie@openbsd.org <semarie@openbsd.org>
Date:   Fri Jun 26 11:26:01 2020 +0000

    upstream: backout 1.293 fix kex mem-leak in ssh_packet_close at markus
    
    request
    
    the change introduced a NULL deref in sshpkt_vfatal() (uses of ssh->kex after
    calling ssh_packet_clear_keys())
    
    OpenBSD-Commit-ID: 9c9a6721411461b0b1c28dc00930d7251a798484

commit 598c3a5e3885080ced0d7c40fde00f1d5cdbb32b
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Jun 26 16:07:12 2020 +1000

    document a PAM spec problem in a frustrated comment

commit 976c4f86286d52a0cb2aadf4a095d379c0da752e
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 26 05:42:16 2020 +0000

    upstream: avoid spurious error message when ssh-keygen creates files
    
    outside ~/.ssh; with dtucker@
    
    OpenBSD-Commit-ID: ac0c662d44607e00ec78c266ee60752beb1c7e08

commit 32b2502a9dfdfded1ccdc1fd6dc2b3fe41bfc205
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Jun 26 15:30:06 2020 +1000

    missing ifdef SELINUX; spotted by dtucker

commit e073106f370cdd2679e41f6f55a37b491f0e82fe
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 26 05:12:21 2020 +0000

    upstream: regress test for ssh-add -d; ok dtucker@
    
    OpenBSD-Regress-ID: 3a2e044be616afc7dd4f56c100179e83b33d8abf

commit c809daaa1bad6b1c305b0e0b5440360f32546c84
Author: markus@openbsd.org <markus@openbsd.org>
Date:   Wed Jun 24 15:16:23 2020 +0000

    upstream: add test for mux w/-Oproxy; ok djm
    
    OpenBSD-Regress-ID: 764d5c696e2a259f1316a056e225e50023abb027

commit 3d06ff4bbd3dca8054c238d2a94c0da563ef7eee
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 26 05:16:38 2020 +0000

    upstream: handle EINTR in waitfd() and timeout_connect() helpers;
    
    bz#3071; ok dtucker@
    
    OpenBSD-Commit-ID: 08fa87be50070bd8b754d9b1ebb1138d7bc9d8ee

commit fe2ec0b9c19adeab0cd9f04b8152dc17f31c31e5
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 26 05:04:07 2020 +0000

    upstream: allow "ssh-add -d -" to read keys to be deleted from
    
    stdin bz#3180; ok dtucker@
    
    OpenBSD-Commit-ID: 15c7f10289511eb19fce7905c9cae8954e3857ff

commit a3e0c376ffc11862fa3568b28188bd12965973e1
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 26 05:03:36 2020 +0000

    upstream: constify a few things; ok dtucker (as part of another
    
    diff)
    
    OpenBSD-Commit-ID: 7c17fc987085994d752304bd20b1ae267a9bcdf6

commit 74344c3ca42c3f53b00b025daf09ae7f6aa38076
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jun 26 05:02:03 2020 +0000

    upstream: Defer creation of ~/.ssh by ssh(1) until we attempt to
    
    write to it so we don't leave an empty .ssh directory when it's not needed.
    Use the same function to replace the code in ssh-keygen that does the same
    thing. bz#3156, ok djm@
    
    OpenBSD-Commit-ID: 59c073b569be1a60f4de36f491a4339bc4ae870f

commit c9e24daac6324fcbdba171392c325bf9ccc3c768
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jun 26 04:45:11 2020 +0000

    upstream: Expand path to ~/.ssh/rc rather than relying on it
    
    being relative to the current directory, so that it'll still be found if the
    shell startup changes its directory.  Since the path is potentially longer,
    make the cmd buffer that uses it dynamically sized.  bz#3185, with & ok djm@
    
    OpenBSD-Commit-ID: 36e33ff01497af3dc8226d0c4c1526fc3a1e46bf

commit 07f5f369a25e228a7357ef6c57205f191f073d99
Author: markus@openbsd.org <markus@openbsd.org>
Date:   Wed Jun 24 15:12:09 2020 +0000

    upstream: fix kex mem-leak in ssh_packet_close; ok djm
    
    OpenBSD-Commit-ID: e2e9533f393620383afd0b68ef435de8d5e8abe4

commit e35995088cd6691a712bfd586bae8084a3a922ba
Author: markus@openbsd.org <markus@openbsd.org>
Date:   Wed Jun 24 15:10:38 2020 +0000

    upstream: fix ssh -O proxy w/mux which got broken by no longer
    
    making ssh->kex optional in packet.c revision 1.278 ok djm@
    
    OpenBSD-Commit-ID: 2b65df04a064c2c6277359921d2320c90ab7d917

commit 250246fef22b87a54a63211c60a2def9be431fbd
Author: markus@openbsd.org <markus@openbsd.org>
Date:   Wed Jun 24 15:09:53 2020 +0000

    upstream: support loading big sshd_config files w/o realloc; ok
    
    djm
    
    OpenBSD-Commit-ID: ba9238e810074ac907f0cf8cee1737ac04983171

commit 89b54900ac61986760452f132bbe3fb7249cfdac
Author: markus@openbsd.org <markus@openbsd.org>
Date:   Wed Jun 24 15:08:53 2020 +0000

    upstream: allow sshd_config longer than 256k; ok djm
    
    OpenBSD-Commit-ID: 83f40dd5457a64c1d3928eb4364461b22766beb3

commit e3fa6249e6d9ceb57c14b04dd4c0cfab12fa7cd5
Author: markus@openbsd.org <markus@openbsd.org>
Date:   Wed Jun 24 15:07:33 2020 +0000

    upstream: only call sshkey_xmss_init() once for KEY_XMSS_CERT; ok
    
    djm
    
    OpenBSD-Commit-ID: d0002ffb7f20f538b014d1d0735facd5a81ff096

commit 37f2da069c0619f2947fb92785051d82882876d7
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 22 23:44:27 2020 +0000

    upstream: some clarifying comments
    
    OpenBSD-Commit-ID: 5268479000fd97bfa30ab819f3517139daa054a2

commit b659319a5bc9e8adf3c4facc51f37b670d2a7426
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Mon Jun 22 06:37:38 2020 +0000

    upstream: updated argument name for -P in first synopsis was
    
    missed in previous;
    
    OpenBSD-Commit-ID: 8d84dc3050469884ea91e29ee06a371713f2d0b7

commit 02a9222cbce7131d639984c2f6c71d1551fc3333
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Mon Jun 22 06:36:40 2020 +0000

    upstream: supply word missing in previous;
    
    OpenBSD-Commit-ID: 16a38b049f216108f66c8b699aa046063381bd23

commit 5098b3b6230852a80ac6cef5d53a785c789a5a56
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Jun 22 16:54:02 2020 +1000

    missing files for webauthn/sshsig unit test

commit 354535ff79380237924ac8fdc98f8cdf83e67da6
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 22 06:00:06 2020 +0000

    upstream: add support for verification of webauthn sshsig signature,
    
    and example HTML/JS to generate webauthn signatures in SSH formats (also used
    to generate the testdata/* for the test).
    
    OpenBSD-Regress-ID: dc575be5bb1796fdf4b8aaee0ef52a6671a0f6fb

commit bb52e70fa5330070ec9a23069c311d9e277bbd6f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 22 05:58:35 2020 +0000

    upstream: Add support for FIDO webauthn (verification only).
    
    webauthn is a standard for using FIDO keys in web browsers. webauthn
    signatures are a slightly different format to plain FIDO signatures - this
    support allows verification of these. Feedback and ok markus@
    
    OpenBSD-Commit-ID: ab7e3a9fb5782d99d574f408614d833379e564ad

commit 64bc121097f377142f1387ffb2df7592c49935af
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 22 05:56:23 2020 +0000

    upstream: refactor ECDSA-SK verification a little ahead of adding
    
    support for FIDO webauthn signature verification support; ok markus@
    
    OpenBSD-Commit-ID: c9f478fd8e0c1bd17e511ce8694f010d8e32043e

commit 12848191f8fe725af4485d3600e0842d92f8637f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 22 05:54:10 2020 +0000

    upstream: support for RFC4648 base64url encoding; ok markus
    
    OpenBSD-Commit-ID: 0ef22c55e772dda05c112c88412c0797fec66eb4

commit 473b4af43db12127137c7fc1a10928313f5a16d2
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 22 05:53:26 2020 +0000

    upstream: better terminology for permissions; feedback & ok markus@
    
    OpenBSD-Commit-ID: ff2a71803b5ea57b83cc3fa9b3be42b70e462fb9

commit fc270baf264248c3ee3050b13a6c8c0919e6559f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 22 05:52:05 2020 +0000

    upstream: better terminology for permissions; feedback & ok markus@
    
    OpenBSD-Commit-ID: ffb220b435610741dcb4de0e7fc68cbbdc876d2c

commit 00531bb42f1af17ddabea59c3d9c4b0629000d27
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jun 19 07:21:42 2020 +0000

    upstream: Correct synopsis and usage for the options accepted when
    
    passing a command to ssh-agent.  ok jmc@
    
    OpenBSD-Commit-ID: b36f0679cb0cac0e33b361051b3406ade82ea846

commit b4556c8ad7177e379f0b60305a0cd70f12180e7c
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Jun 19 19:22:00 2020 +1000

    Add OPENBSD ORIGINAL marker to bcrypt_pbkdf.

commit 1babb8bb14c423011ca34c2f563bb1c51c8fbf1d
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Jun 19 19:10:47 2020 +1000

    Extra brackets around sizeof() in bcrypt.
    
    Prevents following warning from clang 10:
    bcrypt_pbkdf.c:94:40: error: expression does not compute the number of
      elements in this array; element type is ´uint32_tÂ[...]
      place parentheses around the ´sizeof(uint64_t)´ expression to
      silence this warning

commit 9e065729592633290e5ddb6852792913b2286545
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Jun 19 18:47:56 2020 +1000

    Add includes.h to new test.
    
    Fixes warnings eg "´bounded´ attribute directive ignor" from gcc.

commit e684b1ea365e070433f282a3c1dabc3e2311ce49
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Jun 19 18:38:39 2020 +1000

    Skip OpenSSL specific tests w/out OpenSSL.
    
    Allows unit tests to pass when configure'ed --without-openssl.

commit 80610e97a76407ca982e62fd051c9be03622fe7b
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Jun 19 17:15:27 2020 +1000

    Hook sshsig tests up to Portable Makefiles.

commit 5dba1fcabacaab46693338ec829b42a1293d1f52
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jun 19 05:07:09 2020 +0000

    upstream: Test that ssh-agent exits when running as as subprocess
    
    of a specified command (ie "ssh-agent command").  Would have caught bz#3181.
    
    OpenBSD-Regress-ID: 895b4765ba5153eefaea3160a7fe08ac0b6db8b3

commit 68e8294f6b04f9590ea227e63d3e129398a49e27
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 19 04:34:21 2020 +0000

    upstream: run sshsig unit tests
    
    OpenBSD-Regress-ID: 706ef17e2b545b64873626e0e35553da7c06052a

commit 5edfa1690e9a75048971fd8775f7c16d153779db
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 19 04:32:09 2020 +0000

    upstream: basic unit test for sshsig.[ch], including FIDO keys
    
    verification only so far
    
    OpenBSD-Regress-ID: fb1f946c8fc59206bc6a6666e577b5d5d7e45896

commit e95c0a0e964827722d29b4bc00d5c0ff4afe0ed2
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 19 03:48:49 2020 +0000

    upstream: basic unit test for FIDO kep parsing
    
    OpenBSD-Regress-ID: 8089b88393dd916d7c95422b442a6fd4cfe00c82

commit 7775819c6de3e9547ac57b87c7dd2bfd28cefcc5
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Jun 18 23:34:19 2020 +0000

    upstream: check public host key matches private; ok markus@ (as
    
    part of previous diff)
    
    OpenBSD-Commit-ID: 65a4f66436028748b59fb88b264cb8c94ce2ba63

commit c514f3c0522855b4d548286eaa113e209051a6d2
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Jun 18 23:33:38 2020 +0000

    upstream: avoid spurious "Unable to load host key" message when
    
    sshd can load a private key but no public counterpart; with & ok markus@
    
    OpenBSD-Commit-ID: 0713cbdf9aa1ff8ac7b1f78b09ac911af510f81b

commit 7fafaeb5da365f4a408fec355dac04a774f27193
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 12 05:26:37 2020 +0000

    upstream: correct RFC number; from HARUYAMA Seigo via GH PR191
    
    OpenBSD-Commit-ID: 8d03b6c96ca98bfbc23d3754c3c33e1fe0852e10

commit 3a7f654d5bcb20df24a134b6581b0d235da4564a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 5 06:18:07 2020 +0000

    upstream: unbreak "sshd -ddd" - close of config passing fd happened too
    
    early. ok markus@
    
    OpenBSD-Commit-ID: 49346e945c6447aca3e904e65fc400128d2f8ed0

commit 3de02be39e5c0c2208d9682a3844991651620fcc
Author: Andreas Schwab <schwab@suse.de>
Date:   Mon May 25 11:10:44 2020 +0200

    Add support for AUDIT_ARCH_RISCV64

commit ea547eb0329c2f8da77a4ac05f6c330bd49bdaab
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 5 03:25:35 2020 +0000

    upstream: make sshbuf_putb(b, NULL) a no-op
    
    OpenBSD-Commit-ID: 976fdc99b500e347023d430df372f31c1dd128f7

commit 69796297c812640415c6cea074ea61afc899cbaa
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 5 03:24:36 2020 +0000

    upstream: make sshbuf_dump() args const
    
    OpenBSD-Commit-ID: b4a5accae750875d665b862504169769bcf663bd

commit 670428895739d1f79894bdb2457891c3afa60a59
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 5 03:24:16 2020 +0000

    upstream: wrap long line
    
    OpenBSD-Commit-ID: ed405a12bd27bdc9c52e169bc5ff3529b4ebbbb2

commit 2f648cf222882719040906722b3593b01df4ad1a
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri Jun 5 03:15:26 2020 +0000

    upstream: Correct historical comment: provos@ modified OpenSSH to
    
    work with SSLeay (very quickly replaced by OpenSSL) not SSL in general.  ok
    deraadt, historical context markus@
    
    OpenBSD-Commit-ID: 7209e07a2984b50411ed8ca5a4932da5030d2b90

commit 56548e4efcc3e3e8093c2eba30c75b23e561b172
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Jun 3 08:23:18 2020 +0000

    upstream: Import regenerated moduli file.
    
    OpenBSD-Commit-ID: 52ff0e3205036147b2499889353ac082e505ea54

commit 8da801f585dd9c534c0cbe487a3b1648036bf2fb
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri Jun 5 13:20:10 2020 +1000

    Test fallthrough in OSSH_CHECK_CFLAG_COMPILE.
    
    clang 10's -Wimplicit-fallthrough does not understand /* FALLTHROUGH */
    comments and we don't use the __attribute__((fallthrough)) that it's
    looking for.  This has the effect of turning off -Wimplicit-fallthrough
    where it does not currently help (particularly with -Werror).  ok djm@

commit 049297de975b92adcc2db77e3fb7046c0e3c695d
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Jun 3 08:23:18 2020 +0000

    upstream: Import regenerated moduli file.
    
    OpenBSD-Commit-ID: 52ff0e3205036147b2499889353ac082e505ea54

commit b458423a38a3140ac022ffcffcb332609faccfe3
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Jun 1 07:11:38 2020 +0000

    upstream: Remove now-unused proto_spec and associated definitions.
    
    ok djm@
    
    OpenBSD-Commit-ID: 2e2b18e3aa6ee22a7b69c39f2d3bd679ec35c362

commit 5ad3c3a33ef038b55a14ebd31faeeec46073db2c
Author: millert@openbsd.org <millert@openbsd.org>
Date:   Fri May 29 21:22:02 2020 +0000

    upstream: Fix error message on close(2) and add printf format
    
    attributes. From Christos Zoulas, OK markus@
    
    OpenBSD-Commit-ID: 41523c999a9e3561fcc7082fd38ea2e0629ee07e

commit 712ac1efb687a945a89db6aa3e998c1a17b38653
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri May 29 11:17:56 2020 +0000

    upstream: Make dollar_expand variadic and pass a real va_list to
    
    vdollar_percent_expand. Fixes build error on arm64 spotted by otto@.
    
    OpenBSD-Commit-ID: 181910d7ae489f40ad609b4cf4a20f3d068a7279

commit 837ffa9699a9cba47ae7921d2876afaccc027133
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Fri May 29 20:39:00 2020 +1000

    Omit ToS setting if we don't have IPV6_TCLASS too.
    
    Fixes tests on old BSDs.

commit f85b118d2150847cc333895296bc230e367be6b5
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri May 29 09:02:44 2020 +0000

    upstream: Pass a NULL instead of zeroed out va_list from
    
    dollar_expand.  The original intent was in case there's some platform where
    va_list is not a pointer equivalent, but on i386 this chokes on the memset.
    This unbreaks that build, but will require further consideration.
    
    OpenBSD-Commit-ID: 7b90afcd8e1137a1d863204060052aef415baaf7

commit ec1d50b01c84ff667240ed525f669454c4ebc8e9
Author: jmc@openbsd.org <jmc@openbsd.org>
Date:   Fri May 29 05:48:39 2020 +0000

    upstream: remove a stray .El;
    
    OpenBSD-Commit-ID: 58ddfe6f8a15fe10209db6664ecbe7896f1d167c

commit 058674a62ffe33f01d871d46e624bc2a2c22d91f
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri May 29 04:32:26 2020 +0000

    upstream: Add regression and unit tests for ${ENV} style
    
    environment variable expansion in various keywords (bz#3140).  ok djm@
    
    OpenBSD-Regress-ID: 4d9ceb95d89365b7b674bc26cf064c15a5bbb197

commit 0b15892fc47d6840eba1291a6be9be1a70bc8972
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri May 29 01:21:35 2020 +0000

    upstream: Unit test for convtime. ok djm@
    
    OpenBSD-Regress-ID: cec4239efa2fc4c7062064f07a847e1cbdbcd5dd

commit 188e332d1c8f9f24e5b6659e9680bf083f837df9
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri May 29 05:37:03 2020 +0000

    upstream: mention that wildcards are processed in lexical order;
    
    bz#3165
    
    OpenBSD-Commit-ID: 8856f3d1612bd42e9ee606d89386cae456dd165c

commit 4a1b46e6d032608b7ec00ae51c4e25b82f460b05
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri May 29 04:25:40 2020 +0000

    upstream: Allow some keywords to expand shell-style ${ENV}
    
    environment variables on the client side.  The supported keywords are
    CertificateFile, ControlPath, IdentityAgent and IdentityFile, plus
    LocalForward and RemoteForward when used for Unix domain socket paths.  This
    would for example allow forwarding of Unix domain socket paths that change at
    runtime.  bz#3140, ok djm@
    
    OpenBSD-Commit-ID: a4a2e801fc2d4df2fe0e58f50d9c81b03822dffa

commit c9bab1d3a9e183cef3a3412f57880a0374cc8cb2
Author: Damien Miller <djm@mindrot.org>
Date:   Fri May 29 14:49:16 2020 +1000

    depend

commit 0b0d219313bf9239ca043f20b1a095db0245588f
Author: sobrado <sobrado@openbsd.org>
Date:   Thu Sep 3 23:06:28 2015 +0000

    partial sync of regress/netcat.c with upstream
    
    synchronize synopsis and usage.

commit 0f04c8467f589f85a523e19fd684c4f6c4ed9482
Author: chl <chl@openbsd.org>
Date:   Sun Jul 26 19:12:28 2015 +0000

    partial sync of regress/netcat.c with upstream
    
    remove unused variable
    
    ok tedu@

commit d6a81050ace2630b06c3c6dd39bb4eef5d1043f8
Author: tobias <tobias@openbsd.org>
Date:   Thu Mar 26 21:22:50 2015 +0000

    partial sync of regress/netcat.c with upstream
    
    The code in socks.c writes multiple times in a row to a socket. If the socket becomes invalid between these calls (e.g. connection closed), write will throw SIGPIPE. With this patch, SIGPIPE is ignored so we can handle write's -1 return value (errno will be EPIPE). Ultimately, it leads to program exit, too -- but with nicer error message. :)
    
    with input by and ok djm

commit bf3893dddd35e16def04bf48ed2ee1ad695b8f82
Author: tobias <tobias@openbsd.org>
Date:   Thu Mar 26 10:36:03 2015 +0000

    partial sync of regress/netcat.c with upstream
    
    Check for short writes in fdpass(). Clean up while at it.
    
    ok djm

commit e18435fec124b4c08eb6bbbbee9693dc04f4befb
Author: jca <jca@openbsd.org>
Date:   Sat Feb 14 22:40:22 2015 +0000

    partial sync of regress/netcat.c with upstream
    
    Support for nc -T on IPv6 addresses.
    
    ok sthen@

commit 4c607244054a036ad3b2449a6cb4c15feb846a76
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri May 29 03:14:02 2020 +0000

    upstream: fix compilation on !HAVE_DLOPEN platforms; stub function
    
    was not updated to match API change. From Dale Rahn via beck@ ok markus@
    
    OpenBSD-Commit-ID: 2b8d054afe34c9ac85e417dae702ef981917b836

commit 224418cf55611869a4ace1b8b07bba0dff77a9c3
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri May 29 03:11:54 2020 +0000

    upstream: fix exit status for downloading of FIDO resident keys;
    
    from Pedro Martelletto, ok markus@
    
    OpenBSD-Commit-ID: 0da77dc24a1084798eedd83c39a002a9d231faef

commit 1001dd148ed7c57bccf56afb40cb77482ea343a6
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Fri May 29 01:20:46 2020 +0000

    upstream: Fix multiplier in convtime when handling seconds after
    
